(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    146840,       4130]
NotebookOptionsPosition[    138662,       3879]
NotebookOutlinePosition[    139085,       3897]
CellTagsIndexPosition[    139042,       3894]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "ConvexCones"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, {
  3.400778953719181*^9, 3.400778959442259*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "Functions", " ", "for", " ", "constructing", " ", "convex", " ", 
      "cones", " ", "of", "\[IndentingNewLine]", "          ", "arbitrary", 
      " ", "dimension"}]}]}], ",", " ", 
   RowBox[{"manipulating", " ", "them"}], ",", " ", "\[IndentingNewLine]", 
   "             ", 
   RowBox[{"and", " ", "extracting", " ", "their", " ", 
    RowBox[{"attributes", "."}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, {
  3.4007789658769817`*^9, 3.40077897104366*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", 
     RowBox[{"1.0", ".2"}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
   3.453050795760126*^9, 3.453050797372744*^9}, {3.453136416718419*^9, 
   3.453136418488484*^9}, 3.469656558352631*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{
     RowBox[{
     "and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", "Library", 
      "\[IndentingNewLine]", "\t\t   ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"http", ":"}], "//", 
         RowBox[{
          RowBox[{"www", ".", "cs", ".", "unipr", ".", "it"}], "/", "ppl"}]}],
         ")"}], ".", "\[IndentingNewLine]", "          ", "1.0"}], ".1"}], 
     ":", " ", 
     RowBox[{
      RowBox[{
      "June", " ", "2009.", " ", "Fixed", " ", "bug", " ", "in", " ", 
       "ProjectConeAlongAxis", "\[IndentingNewLine]", "\t\t\t\t\t\t\t ", 
       "and", " ", "IntersectConeWithHyperplane", " ", "\[IndentingNewLine]", 
       "\t\t  ", "1.0", ".2"}], ":", " ", 
      RowBox[{
      "December", " ", "12", " ", "2009.", " ", "Fixed", " ", "bug", " ", 
       "in", " ", "AddDescriptor"}]}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}, {
  3.453050806202462*^9, 3.453050922425494*^9}, {3.469463283225263*^9, 
  3.469463290573628*^9}, {3.469463329494195*^9, 3.469463335110446*^9}, {
  3.469463506044404*^9, 3.469463519200086*^9}, {3.4696565691373987`*^9, 
  3.469656608979527*^9}, {3.469656657525494*^9, 3.469656670032043*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":"}]}], "  ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}, 
   3.400778979762742*^9}],

Cell[CellGroupData[{

Cell["Convex Cones", "Title",
 CellChangeTimes->{{3.389744032448317*^9, 3.389744040537517*^9}}],

Cell[CellGroupData[{

Cell["Introductory", "Subtitle",
 CellChangeTimes->{{3.389744082409287*^9, 3.38974408783501*^9}}],

Cell[TextData[{
 "An exposition titled",
 StyleBox[" ",
  FontSlant->"Italic"],
 "\"Some Elementary Theory of Convex Polyhedra\" accompanies this package. "
}], "Text",
 CellChangeTimes->{{3.398986353705883*^9, 3.398986448627446*^9}, 
   3.3989865805688257`*^9}],

Cell[CellGroupData[{

Cell["A Convex Cone", "Subsubtitle",
 CellChangeTimes->{{3.3897443845647583`*^9, 3.389744390796912*^9}}],

Cell[TextData[{
 "A ",
 StyleBox["closed convex polyhedral cone",
  FontWeight->"Bold"],
 " in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "may be characterized in either of two ways. It is the intersection of a \
finite set of ",
 StyleBox["linear halfspaces,",
  FontSlant->"Italic"],
 " where a ",
 StyleBox["linear halfspace",
  FontWeight->"Bold"],
 " is a set of the form "
}], "Text",
 CellChangeTimes->{{3.389744493780368*^9, 3.389744518312482*^9}, {
   3.389744590750802*^9, 3.3897446135306597`*^9}, {3.389744657349442*^9, 
   3.389744784210824*^9}, {3.389744861785694*^9, 3.3897449104510393`*^9}, {
   3.389744992524891*^9, 3.389744998357155*^9}, {3.3897450366221333`*^9, 
   3.389745095500985*^9}, {3.389745141313241*^9, 3.3897452673077993`*^9}, {
   3.389745674371421*^9, 3.389745810961742*^9}, 3.3897458550800257`*^9, {
   3.389746037321419*^9, 3.38974604092207*^9}, 3.39888576537427*^9, 
   3.398885857319481*^9, {3.398885960043288*^9, 3.3988859609177837`*^9}, {
   3.3988860372452717`*^9, 3.398886061996706*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      StyleBox["Hs",
       FontSlant->"Italic"], 
      StyleBox["z",
       FontWeight->"Bold"]], " ", "=", " ", 
     RowBox[{"{", " ", 
      RowBox[{"v", " ", "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["\[DoubleStruckCapitalR]", "d"], " ", ":", " ", 
        RowBox[{
         RowBox[{
          StyleBox["z",
           FontWeight->"Bold"], ".", 
          StyleBox["v",
           FontWeight->"Bold"]}], " ", "\[LessEqual]", " ", "0"}]}]}], " ", 
      "}"}]}], ",", " ", 
    RowBox[{
     StyleBox["z",
      FontWeight->"Bold"], " ", "\[Element]", " ", 
     SuperscriptBox["\[DoubleStruckCapitalR]", "d"]}], ",", " ", 
    RowBox[{
     StyleBox["z",
      FontWeight->"Bold"], " ", "\[NotEqual]", " ", "0", " "}]}], 
   TraditionalForm]],
  FontSize->14],
 StyleBox[". ",
  FontSize->14]
}], "Text",
 CellChangeTimes->{{3.389744493780368*^9, 3.389744518312482*^9}, {
   3.389744590750802*^9, 3.3897446135306597`*^9}, {3.389744657349442*^9, 
   3.389744784210824*^9}, {3.389744861785694*^9, 3.3897449104510393`*^9}, {
   3.389744992524891*^9, 3.389744998357155*^9}, {3.3897450366221333`*^9, 
   3.389745095500985*^9}, {3.389745141313241*^9, 3.3897452673077993`*^9}, {
   3.389745674371421*^9, 3.389745810961742*^9}, 3.3897458550800257`*^9, {
   3.389746037321419*^9, 3.38974604092207*^9}, 3.39888576537427*^9, 
   3.398885857319481*^9, {3.398885960043288*^9, 3.3988859609177837`*^9}, {
   3.3988860372452717`*^9, 3.398886082311316*^9}, 3.398886117445022*^9, {
   3.3989864854372873`*^9, 3.398986486197207*^9}},
 TextAlignment->Center],

Cell[TextData[{
 "It is",
 StyleBox[" ",
  FontSize->14],
 "also the ",
 StyleBox["conical hull of",
  FontSlant->"Italic"],
 " a finite set of vectors, where the ",
 StyleBox["conical hull of",
  FontWeight->"Bold"],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Y", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox[
       StyleBox["y",
        FontWeight->"Bold"], "1"], ",", " ", "...", ",", " ", 
      SubscriptBox[
       StyleBox["y",
        FontWeight->"Bold"], "k"]}], "}"}]}], TraditionalForm]]],
 " is"
}], "Text",
 CellChangeTimes->{{3.389744493780368*^9, 3.389744518312482*^9}, {
   3.389744590750802*^9, 3.3897446135306597`*^9}, {3.389744657349442*^9, 
   3.389744784210824*^9}, {3.389744861785694*^9, 3.3897449104510393`*^9}, {
   3.389744992524891*^9, 3.389744998357155*^9}, {3.3897450366221333`*^9, 
   3.389745095500985*^9}, {3.389745141313241*^9, 3.3897452673077993`*^9}, {
   3.389745674371421*^9, 3.389745810961742*^9}, 3.3897458550800257`*^9, {
   3.389746037321419*^9, 3.38974604092207*^9}, 3.39888576537427*^9, 
   3.398885857319481*^9, {3.398885960043288*^9, 3.3988859609177837`*^9}, {
   3.3988860372452717`*^9, 3.3988860670705423`*^9}, 3.398886133119412*^9}],

Cell[TextData[{
 "cone",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "Y", ")"}], " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox["t", "1"], 
         SubscriptBox[
          StyleBox["y",
           FontWeight->"Bold"], "1"]}], " ", "+"}], "..."}], "+", 
      RowBox[{
       SubscriptBox["t", "k"], 
       RowBox[{
        SubscriptBox[
         StyleBox["y",
          FontWeight->"Bold"], "k"], " ", ":", " ", 
        RowBox[{
         SubscriptBox["t", "i"], " ", "\[GreaterEqual]", " ", "0"}]}]}]}], 
     " ", "}"}]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.389746020303248*^9, 3.389746235336783*^9}},
 TextAlignment->Center],

Cell["\<\
This package contains functions for manipulating and constructing convex \
cones. (The attributes \"closed\" and \"polyhedral\" will be assumed \
throughout.)\
\>", "Text",
 CellChangeTimes->{{3.389746290400591*^9, 3.389746319360867*^9}, {
  3.389746352939332*^9, 3.389746360170669*^9}, {3.38974647188593*^9, 
  3.389746500838862*^9}}],

Cell[TextData[{
 "Note that a convex cone may be contained in a linear subspace of ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ". This will be the case, for instance, if it is the interection of \
halfspaces including ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["Hs",
     FontSlant->"Italic"], 
    StyleBox["z",
     FontWeight->"Bold"]], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["Hs",
     FontSlant->"Italic"], 
    RowBox[{"-", 
     StyleBox["z",
      FontWeight->"Bold"]}]], TraditionalForm]]],
 ". An an extreme case, the cone may reduce to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    StyleBox["0",
     FontWeight->"Bold"], "}"}], TraditionalForm]]],
 ". In this case, it is the conical hull of the empty set."
}], "Text",
 CellChangeTimes->{{3.389746456229398*^9, 3.389746463493431*^9}, {
  3.389746507894908*^9, 3.3897465650566263`*^9}, {3.389746806945303*^9, 
  3.389746987528585*^9}, {3.389747028904023*^9, 3.389747071152898*^9}, {
  3.3989865025887117`*^9, 3.398986505291141*^9}, {3.398986538415464*^9, 
  3.398986539108449*^9}}],

Cell[TextData[{
 "Likewise, a convex cone may include a linear subspace of  ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ". This will be the case, for instance, if it is the conical hull of a set \
including ",
 Cell[BoxData[
  FormBox[
   StyleBox["y",
    FontWeight->"Bold"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", 
    StyleBox["y",
     FontWeight->"Bold"]}], TraditionalForm]]],
 ". As an extreme case, the cone may be all of  ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "; we may regard this as the intersection of an empty set of halfspaces."
}], "Text",
 CellChangeTimes->{{3.389747014452127*^9, 3.3897470245670977`*^9}, {
   3.389747076921085*^9, 3.389747262367228*^9}, 3.389748277472775*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Attributes", "Subsubtitle",
 CellChangeTimes->{{3.3897444417540503`*^9, 3.389744444587513*^9}}],

Cell[TextData[{
 "A convex cone ",
 Cell[BoxData[
  FormBox["\[ScriptCapitalC]", TraditionalForm]]],
 " is described by four attributes, each of which is a sequence of vectors in \
",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ":"
}], "Text",
 CellChangeTimes->{{3.389791069225156*^9, 3.38979123594516*^9}, {
  3.389791586164505*^9, 3.389791595997445*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["Hyperplanes",
  FontWeight->"Bold"],
 ":  a list of vectors ",
 Cell[BoxData[
  FormBox[
   StyleBox["z",
    FontWeight->"Bold"], TraditionalForm]]],
 " such that \[ScriptCapitalC] is contained in ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold"], " ", "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["\[DoubleStruckCapitalR]", "d"], " ", ":", " ", 
        RowBox[{
         StyleBox["z",
          FontWeight->"Bold"], " ", ".", " ", 
         StyleBox["x",
          FontWeight->"Bold"]}]}]}], " ", "=", " ", "0"}], "}"}], " "}], 
   TraditionalForm]]],
 ";"
}], "Text",
 CellChangeTimes->{{3.389791457937825*^9, 3.3897915439614077`*^9}, {
   3.389791607954776*^9, 3.389791658393066*^9}, {3.3897916895075006`*^9, 
   3.389791746906234*^9}, 3.389793111115923*^9, {3.398984989258953*^9, 
   3.3989849926715107`*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["Halfspaces",
  FontWeight->"Bold"],
 ": a list of vectors ",
 Cell[BoxData[
  FormBox[
   StyleBox["z",
    FontWeight->"Bold"], TraditionalForm]]],
 " such that \[ScriptCapitalC] is contained in ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      StyleBox["x",
       FontWeight->"Bold"], " ", "\[Element]", " ", 
      RowBox[{
       SuperscriptBox["\[DoubleStruckCapitalR]", "d"], " ", ":", " ", 
       RowBox[{
        RowBox[{
         StyleBox["z",
          FontWeight->"Bold"], " ", ".", " ", 
         StyleBox["x",
          FontWeight->"Bold"]}], " ", "\[LessEqual]", " ", "0"}]}]}], "}"}], 
    " "}], TraditionalForm]]],
 ";"
}], "Text",
 CellChangeTimes->{{3.389791756249466*^9, 3.389791832854148*^9}, 
   3.389793115329177*^9, {3.398984995776231*^9, 3.398984997743815*^9}, {
   3.3991704425230837`*^9, 3.39917044782539*^9}}],

Cell["\<\
 \[ScriptCapitalC] is the intersection of these hyperplanes and halfspaces;\
\>", "Text",
 CellChangeTimes->{{3.389791863716325*^9, 3.389791909869101*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["Lines: ",
  FontWeight->"Bold"],
 "a list of vectors ",
 Cell[BoxData[
  FormBox[
   StyleBox["x",
    FontWeight->"Bold"], TraditionalForm]]],
 " such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["x",
     FontWeight->"Bold"], ",", 
    StyleBox[" ",
     FontWeight->"Bold"], 
    RowBox[{
     StyleBox[
      RowBox[{"-", "x"}],
      FontWeight->"Bold"], " ", "\[Element]", " ", "\[ScriptCapitalC]"}]}], 
   TraditionalForm]]],
 ";"
}], "Text",
 CellChangeTimes->{{3.3897919258646193`*^9, 3.389792028511915*^9}, 
   3.3897931209696617`*^9, {3.398985003039632*^9, 3.398985019599703*^9}}],

Cell[TextData[{
 "\[Paragraph] R",
 StyleBox["ays",
  FontWeight->"Bold"],
 ": a list of vectors ",
 Cell[BoxData[
  FormBox[
   StyleBox["x",
    FontWeight->"Bold"], TraditionalForm]]],
 " such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["x",
     FontWeight->"Bold"], " ", "\[Element]", " ", "\[ScriptCapitalC]"}], 
   TraditionalForm]]],
 ";"
}], "Text",
 CellChangeTimes->{{3.389792058533626*^9, 3.3897920886877203`*^9}, {
  3.3897931284375143`*^9, 3.3897931294533443`*^9}, {3.398985023920043*^9, 
  3.398985026615768*^9}}],

Cell["\<\
\[ScriptCapitalC] is the conical hull of these lines and rays.\
\>", "Text",
 CellChangeTimes->{{3.389792116689122*^9, 3.3897921297800407`*^9}, 
   3.3989850332797127`*^9}],

Cell[TextData[{
 StyleBox["\[Paragraph]: ",
  FontWeight->"Plain"],
 "AmbientDimension",
 StyleBox[": the dimension ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox["d", TraditionalForm]],
  FontWeight->"Plain"],
 StyleBox[" of the space ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 StyleBox[" containing the cone.",
  FontWeight->"Plain"]
}], "Text",
 CellChangeTimes->{{3.399043061501974*^9, 3.399043198428952*^9}},
 FontWeight->"Bold"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Optimization", "Subsubtitle",
 CellChangeTimes->{{3.398984853243517*^9, 3.398984857585017*^9}}],

Cell["\<\
In general, many different sets of attributes may define the same cone. This \
package keeps the descriptions optimized in the following ways:
\t1.  If two or more halfspace constraints imply a hyperplane constraint, \
then these halfspace constraints are merged into  the list of hyperplanes. \
Likewise, two or more rays that imply the existence of a line generator are \
merged with the list of lines.
\t2. The hyperplane constraints are linearly independent. Likewise, the line \
generators are linearly independent.
\t3. All redundant halfspace constraints and ray generators are removed.\
\>", "Text",
 CellChangeTimes->{{3.398984880216825*^9, 3.398984919242486*^9}, {
  3.398985041502904*^9, 3.398985081583918*^9}, {3.398985138170204*^9, 
  3.398985257261743*^9}, {3.3989852884980183`*^9, 3.398985373097127*^9}, {
  3.3989854242600613`*^9, 3.39898547844473*^9}, {3.399044118829006*^9, 
  3.399044125449729*^9}, {3.3990441978533297`*^9, 3.39904421270024*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notes on constructors", "Subsubtitle",
 CellChangeTimes->{{3.389744463645689*^9, 3.3897444667894297`*^9}, {
  3.398985710719389*^9, 3.398985721972419*^9}}],

Cell["\<\
The following functions can be used to construct convex cones.

All of the vectors used to construct a cone must have the same dimension, \
which becomes the dimension of the cone; otherwise an error message is shown \
and an error result is returned. It is expected that all components of the \
vectors are Integer or Rational; reasonable behavior is not guaranteed if \
this rule is not followed.\
\>", "Text",
 CellChangeTimes->{{3.389793581129601*^9, 3.389793598978793*^9}, {
   3.3898934636408577`*^9, 3.3898935258487883`*^9}, {3.389893695022306*^9, 
   3.389893708126958*^9}, {3.389893741248074*^9, 3.389893764872443*^9}, {
   3.389894110353261*^9, 3.389894161589068*^9}, {3.389897392303029*^9, 
   3.389897638538862*^9}, {3.391637687211608*^9, 3.39163771821005*^9}, 
   3.391637771637809*^9, 3.39898565420535*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["FullSpace",
  FontWeight->"Bold"],
 "\n\tFullSpace[",
 StyleBox["d",
  FontSlant->"Italic"],
 "]\n\tThis function returns a cone with no constraints, signifying the \
entire space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.398985860884492*^9, 3.3989859527655888`*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["ZeroCone",
  FontWeight->"Bold"],
 "\n\tZeroCone[",
 StyleBox["d]\n\t",
  FontSlant->"Italic"],
 "This function returns a cone with no generators, signifying the zero point \
in the space",
 StyleBox[" ",
  FontSlant->"Italic"],
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.398985964700178*^9, 3.398986038404174*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["ConeIntersection",
  FontWeight->"Bold"],
 ":\n\tConeIntersection[",
 StyleBox["hyperplanes, halfspaces",
  FontSlant->"Italic"],
 "] \n\tThe arguments ",
 StyleBox["hyperplanes",
  FontSlant->"Italic"],
 " and ",
 StyleBox["halfspaces",
  FontSlant->"Italic"],
 " must be lists of vectors, at least one list being non-empty. All of the \
vectors must have the same length ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ". \n\tThe convex cone defined by the intersection of the specified \
hyperplanes and halfspaces is returned.\n\tError result: a cone with no \
constraints, signifying the entire space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is a best guess at the intended dimension."
}], "Text",
 CellChangeTimes->{{3.389793761907063*^9, 3.3897938585705023`*^9}, {
   3.3898920840420628`*^9, 3.389892084971982*^9}, {3.389892393603078*^9, 
   3.389892458159342*^9}, {3.389911188162512*^9, 3.389911303499281*^9}, {
   3.3915357938707857`*^9, 3.3915357947638807`*^9}, 3.399045211192192*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["ConicalHull",
  FontWeight->"Bold"],
 ":\n\tConicalHull[",
 StyleBox["lines",
  FontSlant->"Italic"],
 ", ",
 StyleBox["rays",
  FontSlant->"Italic"],
 "]\n\tThe arguments ",
 StyleBox["lines",
  FontSlant->"Italic"],
 " and ",
 StyleBox["rays",
  FontSlant->"Italic"],
 " must be lists of vectors, at least one list being non-empty. All of the \
vectors must have the same length ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ". \n\tThe conical hull of the designated lines and rays is returned.\t\n\t\
Error result: a cone with no generators, signifying the origin in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is a best guess at the intended dimension.\n\t"
}], "Text",
 CellChangeTimes->{{3.389892482976336*^9, 3.389892703031596*^9}, {
   3.389911312413239*^9, 3.389911346084652*^9}, 3.399045661330081*^9}],

Cell[TextData[{
 "\[Paragraph] AddHyperplaneToCone",
 StyleBox["\n\tAddHyperplaneToCone[",
  FontWeight->"Plain"],
 StyleBox["cone, constraint",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox["]\n\tThe first argument must be a convex cone.  The second \
argument must be a vector whose length is the ambient dimension of the cone\n\
\tThe value returned is a cone with the same constraints as ",
  FontWeight->"Plain"],
 StyleBox["cone",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox[" plus one hyperplane constraint.\n\t\n\tError result: ",
  FontWeight->"Plain"],
 StyleBox["cone",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox[" unchanged.",
  FontWeight->"Plain"]
}], "Text",
 CellChangeTimes->{{3.395846967990244*^9, 3.3958470060535507`*^9}, {
   3.395847174181485*^9, 3.395847293182231*^9}, 3.395847589833959*^9, {
   3.399074495718175*^9, 3.3990745054275637`*^9}},
 FontWeight->"Bold"],

Cell[TextData[{
 StyleBox["\[Paragraph] AddHalfspaceToCone",
  FontWeight->"Bold"],
 "\n\tAddHalfspaceToCone[",
 StyleBox["cone, constraint",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex cone.  The second argument must be \
a vector",
 StyleBox["whose length is the ambient dimension of the cone",
  FontWeight->"Plain"],
 "\n\tThe value returned is a cone with the same constraints as ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " plus one halfspace constraint.\n\t\n\tError result: ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " unchanged."
}], "Text",
 CellChangeTimes->{{3.39584730518337*^9, 3.3958474337222424`*^9}, 
   3.395847592370288*^9, 3.399074516509494*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddConstraintGroupToCone",
  FontWeight->"Bold"],
 ":\n\tAddConstraintGroupToCone[",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", ",
 StyleBox["hyperplanes",
  FontSlant->"Italic"],
 ", ",
 StyleBox["halfspaces",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex cone. The second and third \
arguments must be lists of vectors ",
 StyleBox["whose length is the ambient dimension of the cone",
  FontWeight->"Plain"],
 "\n\tThe value returned is a cone with the same constraints as ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " plus the contents of ",
 StyleBox["hyperplanes",
  FontSlant->"Italic"],
 " added to the hyperplane constraints and the contents of ",
 StyleBox["halfplanes",
  FontSlant->"Italic"],
 " added to the halfplane constraints.\t\n\t\n\tError result: ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " unchanged."
}], "Text",
 CellChangeTimes->{{3.3898953021390553`*^9, 3.389895559497262*^9}, {
   3.38989574041927*^9, 3.389895743856206*^9}, {3.3899113877437487`*^9, 
   3.3899113933257523`*^9}, 3.3990745258717403`*^9}],

Cell[TextData[{
 "\[Paragraph] AddLineToCone",
 StyleBox["\n\tAddLineToCone[",
  FontWeight->"Plain"],
 StyleBox["cone, generator",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox["]\n\tThe first argument must be a convex cone. The second argument \
must be a vectorwhose length is the ambient dimension of the cone\n\tThe \
value returned is a cone with the same generators as ",
  FontWeight->"Plain"],
 StyleBox["cone",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox[", plus a line generator.\n\t\n\tError result: ",
  FontWeight->"Plain"],
 StyleBox["cone",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox[" unchanged.",
  FontWeight->"Plain"]
}], "Text",
 CellChangeTimes->{{3.395847463317946*^9, 3.395847608607541*^9}, 
   3.3990745334433203`*^9},
 FontWeight->"Bold"],

Cell[TextData[{
 "\[Paragraph] AddRayToCone",
 StyleBox["\n\tAddRayToCone[",
  FontWeight->"Plain"],
 StyleBox["cone, generator",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox["]\n\tThe first argument must be a convex cone.  The second \
argument must be a vector whose length is the ambient dimension of the cone\n\
\tThe value returned is a cone with the same generators as ",
  FontWeight->"Plain"],
 StyleBox["cone",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox[", plus a ray genertor.\n\t\n\tErro result: ",
  FontWeight->"Plain"],
 StyleBox["cone",
  FontWeight->"Plain",
  FontSlant->"Italic"],
 StyleBox[" unchanged.",
  FontWeight->"Plain"]
}], "Text",
 CellChangeTimes->{{3.3958476173460293`*^9, 3.3958477189068127`*^9}, 
   3.3990745401106567`*^9},
 FontWeight->"Bold"],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddGeneratorGroupToCone",
  FontWeight->"Bold"],
 ":\n\tAddGeneratorGroupToCone[",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", ",
 StyleBox["lines",
  FontSlant->"Italic"],
 ", ",
 StyleBox["rays",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex cone. The second and third \
arguments must be lists of vectors whose length is the ambient dimension of \
the cone.\n\tThe value returned is a cone with the same generators as ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " plus the contents of ",
 StyleBox["lines",
  FontSlant->"Italic"],
 " added to the line generators and the contents of ",
 StyleBox["rays",
  FontSlant->"Italic"],
 " added to the ray generators.\n\t\t\n\tError result: ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " unchanged."
}], "Text",
 CellChangeTimes->{{3.389896152299363*^9, 3.3898961912048817`*^9}, {
   3.3898971355634403`*^9, 3.389897286543507*^9}, {3.389897354154571*^9, 
   3.389897367586375*^9}, {3.3899114108484783`*^9, 3.389911411473184*^9}, {
   3.399074436654085*^9, 3.39907444748986*^9}, 3.3990745572924*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["TransformGeneratorsOfCone",
  FontWeight->"Bold"],
 ":\n\tTransformGeneratorsOfCone[",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", ",
 StyleBox["transformer",
  FontSlant->"Italic"],
 "]\n\tThe first  argument must be a convex cone. The second must be a \
non-singular ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "\[Times]", "d"}], TraditionalForm]]],
 " matrix of rational numbers, where ",
 StyleBox["d",
  FontSlant->"Italic"],
 " is the ambient dimension of the cone.\n\tThe value returned is a cone \
whose generators are the result of acting on the generators of ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " with ",
 StyleBox["transformer",
  FontSlant->"Italic"],
 ".\n\t\t\n\tError result: ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " unchanged."
}], "Text",
 CellChangeTimes->{{3.389897704269328*^9, 3.3898977111246843`*^9}, {
  3.38989775363026*^9, 3.389897765063038*^9}, {3.389897840518178*^9, 
  3.389897961137484*^9}, {3.38989799503331*^9, 3.3898980368958797`*^9}, {
  3.3898980796249027`*^9, 3.389898106677083*^9}, {3.3898982641841516`*^9, 
  3.389898265951095*^9}, {3.389911421219605*^9, 3.389911421786483*^9}, {
  3.399074454426689*^9, 3.399074466202693*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["ProjectConeAlongAxis",
  FontWeight->"Bold"],
 ":\n\tProjectConeAlongAxis[",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex cone.  The second must be an \
integer in the range from ",
 Cell[BoxData[
  FormBox["1", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is the ambient dimenstion of the cone.\n\tThe value returned is a cone of \
dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 ", the result of projecting the given cone along the specified axis, and \
removing the ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "-th component from all vectors.\n\t\n\tError result: a cone with no \
constraints, and dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.389898125661627*^9, 3.389898153770748*^9}, {
   3.389898186988223*^9, 3.389898188622521*^9}, {3.389898234869429*^9, 
   3.389898366841839*^9}, {3.389898473032501*^9, 3.389898617974494*^9}, {
   3.389911442611115*^9, 3.389911473761935*^9}, {3.399074421960167*^9, 
   3.39907442583438*^9}, 3.39907466243909*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["IntersectConeWithHyperplane",
  FontWeight->"Bold"],
 ":\n\tIntersectConeWithHyperplane[",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex cone.  The second must be an \
integer in the range from ",
 Cell[BoxData[
  FormBox["1", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is the ambient dimension of the cone.\n\tThe value returned is a cone of \
dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 ", the intersection with the hyperplane on which the ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "-th component is 0.  This component is removed from all vectors.\n\t\n\t\
Error result: a cone with no generators, and dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.389898735044035*^9, 3.389898917051111*^9}, {
   3.389911494284849*^9, 3.389911508954722*^9}, {3.397515624759365*^9, 
   3.397515638282683*^9}, {3.399074473484407*^9, 3.399074474795923*^9}, 
   3.3990747354571753`*^9, 3.3990747795020237`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsubtitle",
 CellChangeTimes->{{3.38974742169806*^9, 3.389747423739854*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["ConeContains",
  FontWeight->"Bold"],
 ":\n\tConeContains[",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", ",
 StyleBox["point",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex cone. The second argument must be \
a vector, of the same dimension as ",
 StyleBox["cone",
  FontSlant->"Italic"],
 ".\n\tReturn True if ",
 StyleBox["point",
  FontSlant->"Italic"],
 " is contained in ",
 StyleBox["cone",
  FontSlant->"Italic"],
 ", and False otherwise.\n\t\n\tError result: False."
}], "Text",
 CellChangeTimes->{{3.389910992416654*^9, 3.389911161692563*^9}, {
  3.389911536259157*^9, 3.389911542536604*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["SubCone",
  FontWeight->"Bold"],
 ":\n\tSubCone[",
 StyleBox["cone1, cone2",
  FontSlant->"Italic"],
 "]\n\tThe two arguments must be convex cones of equal dimension.\n\tValue \
returned is True if (as sets of points in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ", ",
 StyleBox["cone1",
  FontSlant->"Italic"],
 " is a subset of ",
 StyleBox["cone2",
  FontSlant->"Italic"],
 ".\n\t\n\tError result: False"
}], "Text",
 CellChangeTimes->{{3.3899115531699677`*^9, 3.389911758351276*^9}, 
   3.39751559823905*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["EqualCone",
  FontWeight->"Bold"],
 ":\n\tEqualCone[",
 StyleBox["cone1",
  FontSlant->"Italic"],
 ", ",
 StyleBox["cone2",
  FontSlant->"Italic"],
 "]\n\tThe two arguments must be convex cones of equal dimension.\n\tValue \
returned is True if (as sets of points in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ", ",
 StyleBox["cone1",
  FontSlant->"Italic"],
 " is equal to ",
 StyleBox["cone2",
  FontSlant->"Italic"],
 ".\n\t\n\tError result: False"
}], "Text",
 CellChangeTimes->{{3.3899118167746468`*^9, 3.389911963664501*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package ", "Subtitle",
 CellChangeTimes->{{3.3897441099085817`*^9, 3.3897441262903833`*^9}, 
   3.390088763935296*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<Convex`ConvexCones`\>\"", ",", 
    RowBox[{"{", "\"\<Global`\>\"", "}"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.389743693881078*^9, 3.389743743090199*^9}}],

Cell[CellGroupData[{

Cell["Declarations: Usage specifications", "Section",
 CellChangeTimes->{{3.389744148052143*^9, 3.389744155475335*^9}, {
  3.3900888102627993`*^9, 3.390088814224888*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConvexCone", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<ConvexCone is the head of an expression denoting a closed convex \
polynomial cone.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389914558623027*^9, 3.389914562462792*^9}, {
  3.3899145987761383`*^9, 3.389914653087998*^9}}],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 CellChangeTimes->{{3.3899142141586123`*^9, 3.389914219605483*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hyperplanes", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<Hyperplanes[cone] returns the list of vectors specifying hyperplanes \
which constrain cone.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3899126979194107`*^9, 3.3899127742842607`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Halfspaces", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<Halfspaces[cone] returns the list of vectors specifying halfspaces \
which constrain code.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3899127828312473`*^9, 3.389912791986746*^9}, {
  3.389913106804434*^9, 3.389913150610293*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lines", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<Lines[cone] returns the list of vectors specifying line generators of \
cone.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3899131621751747`*^9, 3.389913163858581*^9}, 
   3.389913199100821*^9, {3.389913237814199*^9, 3.389913261973608*^9}, {
   3.389913371879424*^9, 3.389913377888661*^9}, {3.389914053772689*^9, 
   3.389914079285378*^9}, 3.3976708614178753`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rays", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<Rays[cone] returns the list of vectors specifying ray generators of \
cone.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3899133448024063`*^9, 3.389913392760674*^9}, {
  3.3899140595110397`*^9, 3.389914081263576*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AmbientDimension", "::", "usage"}], " ", "=", 
   "\[IndentingNewLine]", 
   "\"\<AmbientDimension[cone] is the dimension of the space in which cone \
resides.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389913778717286*^9, 3.389913803108184*^9}, {
  3.3899138380419683`*^9, 3.389913858161889*^9}, {3.399043214802723*^9, 
  3.3990432259087687`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Subsection",
 CellChangeTimes->{{3.3899146863796597`*^9, 3.389914693275955*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FullSpace", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<FullSpace[d] constructs a cone which occupies the entire \
d-dimensional vector space.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.398551311352953*^9, 3.398551354786744*^9}, {
  3.3986045357133713`*^9, 3.398604536258898*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeroCone", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<ZeroCone[d] constructs a cone consisting of the origin in \
d-dimensional vector space.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.398551378755434*^9, 3.3985514186359177`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConeIntersection", "::", "usage"}], " ", "=", 
   "\[IndentingNewLine]", 
   "\"\<ConeIntersection[hyperplanes, halfspaces] constructs a cone with the \
given constraints.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389914723659666*^9, 3.3899147821742764`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConicalHull", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<ConicalHull[lines, rays] constructs a cone with the given generators.\
\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389914817449952*^9, 3.389914865807066*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHyperplaneToCone", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddHyperplaneToCone[cone, constraint] constructs from the given cone \
a new one, adding the given hyperplane constraint.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.395847851711596*^9, 3.3958479111353693`*^9}, 
   3.453050977561977*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHalfspaceToCone", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<AddHalfspaceToCone[cone, constraint] constructs from the given cone a \
new one, adding the given halfspace constraint.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.39584791494316*^9, 3.395847985853692*^9}, 
   3.453050990202199*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddConstraintGroupToCone", "::", "usage"}], " ", "=", 
   "\[IndentingNewLine]", 
   "\"\<AddConstraintGroupToCone[cone, hyperplanes, halfspaces] constructs a \
new cone from the old one, adding new constraints.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389914880627961*^9, 3.389914971243616*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddLineToCone", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<AddLineToCone[cone, generator] constructs a new cone from the given \
one, adding the given line generator.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3958479992913313`*^9, 3.3958480681793013`*^9}, {
  3.395848109748517*^9, 3.3958481171643457`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddRayToCone", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<AddRayToCone[cone, generator] constructs a new cone from the given \
one, adding the given ray generator.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.395848120866048*^9, 3.3958481714470587`*^9}, 
   3.3985515442540913`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddGeneratorGroupToCone", "::", "usage"}], " ", "=", 
   "\[IndentingNewLine]", 
   "\"\<AddGeneratorGroupToCone[cone, lines, rays] constructs from the given \
cone a new one, adding the given generators.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389915484601046*^9, 3.389915549369792*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformGeneratorsOfCone", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<TransformGeneratorsOfCone[cone, transformer] applies a linear \
transformation to the generators of a given cone, to obtain a new one.\>\""}],
   ";"}]], "Input",
 CellChangeTimes->{{3.3899155662469063`*^9, 3.3899156266887093`*^9}, 
   3.3900844172316313`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectConeAlongAxis", "::", "usage"}], " ", "=", 
   "\[IndentingNewLine]", 
   "\"\<ProjectConeAlongAxis[cone, axis] returns the projection of the given \
cone along the given axis.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.389915642581435*^9, 3.389915734244698*^9}, 
   3.390084407974695*^9, 3.3976708796921988`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IntersectConeWithHyperplane", "::", "usage"}], " ", "=", 
   "\[IndentingNewLine]", 
   "\"\<IntersectConeWithHyperplane[cone, axis] returns the intersection of \
the given cone with the coordinate hyperplane orthogonal to the given axis.\>\
\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3899157603059*^9, 3.3899158439641*^9}, 
   3.390084042859182*^9, {3.390084389035747*^9, 3.390084389933525*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests ", "Subsection",
 CellChangeTimes->{{3.397512987910059*^9, 3.397513016013926*^9}, 
   3.397513154988212*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConeContains", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<ConeContains[cone, point] assumes that cone is a convexCone and point \
is a vector of the same dimension as the descriptors of cone.  It returns \
True if & only if point is contained in conef.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.39751303299935*^9, 3.397513142217556*^9}, {
  3.397513322016553*^9, 3.397513366609591*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SubCone", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<SubCone[cone1,cone2]assumes that the arguments are ConvexCones of \
equal dimension.  It returns True if and only if cone1 is a subset of \
cone2.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.397513167893373*^9, 3.3975132580436277`*^9}, {
  3.3975132980041437`*^9, 3.397513332408113*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EqualCone", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<EqualCone[cone1,cone2] assumes that cone1 and cone2 are ConvexCone's \
of equal dimension.It returns True if & only if they are equal as point sets.\
\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.397513263356533*^9, 3.39751329002779*^9}, {
   3.3975133357810173`*^9, 3.397513337460699*^9}, {3.397513374525713*^9, 
   3.397513458932726*^9}, 3.4530510089324217`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation", "Section",
 CellChangeTimes->{{3.389744184717228*^9, 3.389744188636415*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.389743766322904*^9, 3.389743790154894*^9}}],

Cell["\<\
An expression denoting a convex cone has the form ConvexCone[d, hyperplanes, \
halfspaces, lines, rays].\
\>", "Text",
 CellChangeTimes->{{3.390067456720654*^9, 3.390067550000431*^9}}],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 CellChangeTimes->{{3.390068007753899*^9, 3.390068012300685*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hyperplanes", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", " ", "ra_"}], 
     "]"}], "]"}], " ", ":=", " ", "hp"}], ";"}]], "Input",
 CellChangeTimes->{{3.390067585293445*^9, 3.390067658391876*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Halfspaces", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", "hs"}], ";"}]], "Input",
 CellChangeTimes->{{3.390067672297346*^9, 3.3900677122202063`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lines", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", "ln"}], ";"}]], "Input",
 CellChangeTimes->{{3.390067724556039*^9, 3.390067749098268*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rays", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], ":=", " ", "ra"}], ";"}]], "Input",
 CellChangeTimes->{{3.3900677581031733`*^9, 3.390067770666514*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AmbientDimension", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", "d"}], ";"}]], "Input",
 CellChangeTimes->{{3.3900678210993137`*^9, 3.390067831529892*^9}, {
  3.399043235612802*^9, 3.399043237028318*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Subsection",
 CellChangeTimes->{{3.3899146863796597`*^9, 3.389914693275955*^9}}],

Cell[CellGroupData[{

Cell["Constructors of full space and zero cone", "Subsubsection",
 CellChangeTimes->{{3.3914446210226*^9, 3.391444640286521*^9}}],

Cell[TextData[{
 "\tFullSpace[d_] returns a ConvexCone representing the full space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ","
}], "Text",
 CellChangeTimes->{{3.390087394961988*^9, 3.390087449823783*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FullSpace", "[", "d_", "]"}], " ", ":=", 
   RowBox[{"ConvexCone", "[", 
    RowBox[{"d", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"IdentityMatrix", "[", "d", "]"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.390087456062148*^9, 3.390087468826109*^9}, {
  3.391444784397893*^9, 3.391444813369053*^9}, {3.391444987938871*^9, 
  3.391444994239937*^9}, {3.398604687966319*^9, 3.398604688775762*^9}}],

Cell[TextData[{
 "\tZeroCone[d_] returns a ConvexCone representing the zero cone in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.390087765394203*^9, 3.3900878221072197`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeroCone", "[", "d_", "]"}], " ", ":=", " ", 
   RowBox[{"ConvexCone", "[", 
    RowBox[{"d", ",", 
     RowBox[{"IdentityMatrix", "[", "d", "]"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3900878345432253`*^9, 3.390087845221933*^9}, {
  3.391445004975376*^9, 3.391445030648699*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConeIntersection", "[", 
    RowBox[{"hp_", ",", " ", "hs_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "d", ",", "rawCone", ",", "newHp", ",", "newHs", ",", "newLn", ",", 
         " ", "newRa"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"d", "=", 
         RowBox[{"DimVet", "[", 
          RowBox[{"hp", ",", "hs"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rawCone", "=", 
         RowBox[{"FullSpace", "[", "d", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}]}], "}"}], " ", "=", " ", 
         RowBox[{"AddDescriptions", "[", 
          RowBox[{"d", ",", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Hyperplanes", "@", "rawCone"}], ",", 
               RowBox[{"Halfspaces", "@", "rawCone"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Lines", "@", "rawCone"}], ",", 
               RowBox[{"Rays", "@", "rawCone"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"hp", ",", "hs"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
           " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "emptyArgs", "|", "notUniform"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FullSpace", "[", "#1", "]"}], "&"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.390068123457656*^9, 3.3900681748899937`*^9}, {
   3.390068227329979*^9, 3.3900682329851217`*^9}, {3.390068278546974*^9, 
   3.390068287514777*^9}, {3.390068325390581*^9, 3.390068326051824*^9}, {
   3.390086312620349*^9, 3.3900863674965763`*^9}, {3.390086495029533*^9, 
   3.390086495614555*^9}, {3.390086672837562*^9, 3.390086679012589*^9}, {
   3.390086792184349*^9, 3.3900868428962517`*^9}, {3.390086931987629*^9, 
   3.39008693430215*^9}, {3.390087068520255*^9, 3.390087085939064*^9}, {
   3.390087316706852*^9, 3.3900873454196243`*^9}, {3.3900875608268642`*^9, 
   3.390087578060912*^9}, {3.39008816631645*^9, 3.3900882209207783`*^9}, {
   3.390174134603784*^9, 3.3901741359269648`*^9}, {3.3901779654470577`*^9, 
   3.390178029922159*^9}, {3.3901780904522867`*^9, 3.3901780966459417`*^9}, {
   3.39017843170214*^9, 3.390178463570277*^9}, 3.390179164863806*^9, 
   3.3917296228021708`*^9, {3.395851250368433*^9, 3.395851274993548*^9}, {
   3.395851329000856*^9, 3.39585133118579*^9}, {3.3958513872608147`*^9, 
   3.395851416842154*^9}, {3.395851513465025*^9, 3.395851596898795*^9}, {
   3.399313164374967*^9, 3.3993132440798492`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConicalHull", "[", 
    RowBox[{"ln_", ",", "ra_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "d", ",", "rawCone", ",", "newHp", ",", "newHs", ",", "newLn", ",", 
         " ", "newRa"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"d", "=", 
         RowBox[{"DimVet", "[", 
          RowBox[{"ln", ",", " ", "ra"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rawCone", "=", 
         RowBox[{"ZeroCone", "[", "d", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}]}], "}"}], " ", "=", " ", 
         RowBox[{"AddDescriptions", "[", 
          RowBox[{"d", ",", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Lines", "@", "rawCone"}], ",", 
               RowBox[{"Rays", "@", "rawCone"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Hyperplanes", "@", "rawCone"}], ",", 
               RowBox[{"Halfspaces", "@", "rawCone"}]}], "}"}]}], "}"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"ln", ",", "ra"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
           " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "emptyArgs", "|", "notUniform"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ZeroCone", "[", "#1", "]"}], "&"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.390087636623701*^9, 3.390087752999186*^9}, {
   3.390088243625143*^9, 3.390088282602599*^9}, {3.3901741416550827`*^9, 
   3.390174143022777*^9}, 3.390179170827443*^9, {3.390179231220849*^9, 
   3.39017926862393*^9}, {3.391729629564765*^9, 3.391729630140018*^9}, 
   3.39585213762884*^9, {3.395852177955017*^9, 3.395852237020817*^9}, {
   3.397514380963766*^9, 3.3975144148003283`*^9}, {3.399313275747698*^9, 
   3.399313305219967*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"isTwoSided", " ", "=", " ", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isOneSided", " ", "=", " ", "False"}], ";"}]}], "Input",
 CellChangeTimes->{{3.39584831420234*^9, 3.3958483340499763`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHyperplaneToCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
     ",", " ", "constraint_"}], "]"}], " ", ":=", "\[IndentingNewLine]", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVetOne", "[", 
         RowBox[{"d", ",", "constraint"}], "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}]}], "}"}], " ", "=", 
         "\[IndentingNewLine]", 
         RowBox[{"AddDescriptor", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hp", ",", "hs"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"ln", ",", "ra"}], "}"}]}], "}"}], ",", "constraint", 
           ",", "isTwoSided"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
           " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "wrongDimension"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d", ",", "hp", ",", "hs", ",", "ln", ",", "ra"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.395848340077793*^9, 3.395848473254524*^9}, {
   3.3958486424685583`*^9, 3.395848757662437*^9}, 3.395848830506454*^9, {
   3.3958489125881767`*^9, 3.3958489217516947`*^9}, 3.395849035767342*^9, {
   3.3958491488262787`*^9, 3.3958491497039137`*^9}, {3.395850599004219*^9, 
   3.395850610548337*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHalfspaceToCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
     ",", " ", "constraint_"}], "]"}], " ", ":=", "\[IndentingNewLine]", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVetOne", "[", 
         RowBox[{"d", ",", "constraint"}], "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}]}], "}"}], " ", "=", 
         "\[IndentingNewLine]", 
         RowBox[{"AddDescriptor", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hp", ",", "hs"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"ln", ",", "ra"}], "}"}]}], "}"}], ",", "constraint", 
           ",", "isOneSided"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
           " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "wrongDimension"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d", ",", "hp", ",", "hs", ",", "ln", ",", "ra"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.395848340077793*^9, 3.395848473254524*^9}, {
   3.3958486424685583`*^9, 3.395848757662437*^9}, 3.395848830506454*^9, {
   3.3958489125881767`*^9, 3.3958489217516947`*^9}, 3.395849035767342*^9, {
   3.395849105421154*^9, 3.3958491204954453`*^9}, {3.395849153536891*^9, 
   3.39584915404014*^9}, {3.395850616628817*^9, 3.3958506245487328`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"AddConstraintGroupToCone", "[", 
     RowBox[{
      RowBox[{"ConvexCone", "[", 
       RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
      ",", "nhp_", ",", "nhs_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Catch", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", " ", "newRa"}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DimVet", "[", 
          RowBox[{"d", ",", "nhp", ",", "nhs"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"newHp", ",", "newHs"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"newLn", ",", "newRa"}], "}"}]}], "}"}], " ", "=", " ", 
          RowBox[{"AddDescriptions", "[", 
           RowBox[{"d", ",", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hp", ",", "hs"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"ln", ",", "ra"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"nhp", ",", "nhs"}], "}"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"SimplifyCone", "[", 
          RowBox[{"ConvexCone", "[", 
           RowBox[{
           "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
            " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"notLists", "|", " ", "notUniform"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ConvexCone", "[", 
       RowBox[{"d", ",", "hp", ",", "hs", ",", "ln", ",", "ra"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",\

 CellChangeTimes->{{3.390174416933728*^9, 3.390174467740336*^9}, {
   3.390174586174254*^9, 3.39017467456003*^9}, {3.390174709688683*^9, 
   3.390174781953702*^9}, 3.3901782220949793`*^9, {3.390178264238797*^9, 
   3.390178331649884*^9}, {3.390178368323695*^9, 3.3901784057248363`*^9}, 
   3.390179013592909*^9, 3.3901791736160192`*^9, 3.3958517324286823`*^9, {
   3.3958517639362698`*^9, 3.395851806668296*^9}, 3.395851840853786*^9, {
   3.395851874909625*^9, 3.39585191736554*^9}, 3.397684685114522*^9, {
   3.397684805580758*^9, 3.397684808130129*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddLineToCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
     ",", " ", "generator_"}], "]"}], ":=", " ", "\[IndentingNewLine]", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVetOne", "[", 
         RowBox[{"d", ",", " ", "generator"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}]}], "}"}], " ", "=", 
         "\[IndentingNewLine]", 
         RowBox[{"AddDescriptor", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"ln", ",", "ra"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"hp", ",", "hs"}], "}"}]}], "}"}], ",", "generator", 
           ",", "isTwoSided"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
           " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "wrongDimension"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d", ",", "hp", ",", "hs", ",", "ln", ",", "ra"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.391533592388711*^9, 3.3915336576346607`*^9}, {
  3.39153373920303*^9, 3.391533785582871*^9}, {3.391534633633226*^9, 
  3.391534788595277*^9}, {3.395849242867033*^9, 3.395849303654985*^9}, {
  3.395849361577557*^9, 3.395849378229797*^9}, {3.395849412881844*^9, 
  3.395849423529183*^9}, {3.395850642493616*^9, 3.3958506505575933`*^9}, {
  3.3995864112493973`*^9, 3.3995864231340237`*^9}, {3.399587596210291*^9, 
  3.3995876024516*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddRayToCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
     ",", " ", "generator_"}], "]"}], ":=", " ", "\[IndentingNewLine]", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVetOne", "[", 
         RowBox[{"d", ",", " ", "generator"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}]}], "}"}], " ", "=", 
         "\[IndentingNewLine]", 
         RowBox[{"AddDescriptor", "[", 
          RowBox[{"d", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"ln", ",", "ra"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"hp", ",", "hs"}], "}"}]}], "}"}], ",", "generator", 
           ",", " ", "isOneSided"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", " ", "newHp", ",", " ", "newHs", ",", " ", "newLn", ",", 
           " ", "newRa"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "wrongDimension"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d", ",", "hp", ",", "hs", ",", "ln", ",", "ra"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.391533592388711*^9, 3.3915336576346607`*^9}, {
   3.39153373920303*^9, 3.391533785582871*^9}, {3.391534633633226*^9, 
   3.391534788595277*^9}, {3.395849242867033*^9, 3.395849303654985*^9}, {
   3.395849361577557*^9, 3.395849378229797*^9}, {3.395849412881844*^9, 
   3.395849423529183*^9}, {3.395849468967532*^9, 3.395849478794051*^9}, {
   3.395850659645854*^9, 3.395850666717966*^9}, {3.39958643931218*^9, 
   3.399586470921258*^9}, {3.399586706434082*^9, 3.3995867121938953`*^9}, {
   3.3995870752109213`*^9, 3.399587110287415*^9}, 3.399587252929654*^9, {
   3.399587377094565*^9, 3.399587394648424*^9}, {3.399587617414447*^9, 
   3.3995876617079973`*^9}, {3.399589463550758*^9, 3.399589480043211*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddGeneratorGroupToCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
     ",", " ", "nln_", ",", " ", "nra_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", " ", "newRa"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"d", ",", "nln", ",", "nra"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"newLn", ",", "newRa"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"newHp", ",", "newHs"}], "}"}]}], "}"}], " ", "=", " ", 
         RowBox[{"AddDescriptions", "[", 
          RowBox[{"d", ",", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"ln", ",", "ra"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"hp", ",", "hs"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"nln", ",", "nra"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SimplifyCone", "[", 
         RowBox[{"ConvexCone", "[", 
          RowBox[{
          "d", ",", "newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], 
          "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "notUniform"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ConvexCone", "[", 
      RowBox[{"d", ",", "hp", ",", "hs", ",", "ln", ",", "ra"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.390178951159767*^9, 3.390179054325391*^9}, {
   3.3901790899746647`*^9, 3.3901792059304657`*^9}, {3.395852326070269*^9, 
   3.395852432379624*^9}, {3.397515139134061*^9, 3.397515153353237*^9}, 
   3.397683569678225*^9, {3.397683608224576*^9, 3.397683692658555*^9}, {
   3.397684714926525*^9, 3.3976847188351*^9}, {3.397684782540638*^9, 
   3.397684784795682*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformGeneratorsOfCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{
      "d_", ",", " ", "hp_", ",", " ", "hs_", ",", " ", "ln_", ",", " ", 
       "ra_"}], "]"}], ",", " ", "transformer_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"contraTrans", " ", "=", " ", 
         RowBox[{"Check", "[", 
          RowBox[{
           RowBox[{"Inverse", "@", 
            RowBox[{"Transpose", "@", "transformer"}]}], ",", 
           RowBox[{"Throw", "[", 
            RowBox[{"0", ",", "singular"}], "]"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"d", ",", "transformer", ",", 
          RowBox[{"{", "}"}]}], "]"}], ";", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"d", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"contraTrans", ".", "#1"}], ")"}], "&"}], "/@", "hp"}], 
          ",", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"contraTrans", ".", "#1"}], ")"}], "&"}], "/@", "hs"}], 
          ",", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"transformer", ".", "#1"}], ")"}], "&"}], "/@", "ln"}], 
          ",", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"transformer", ".", "#1"}], ")"}], "&"}], "/@", "ra"}]}],
          "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"notLists", "|", "wrongDimension", "|", "singular"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ConvexCone", "[", 
      RowBox[{
      "d", ",", " ", "hp", ",", " ", "hs", ",", " ", "ln", ",", " ", "ra"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.391533946380471*^9, 3.391533988176486*^9}, {
   3.391535000147884*^9, 3.391535071302558*^9}, {3.391535142947585*^9, 
   3.391535348851389*^9}, {3.3915365508025627`*^9, 3.391536681620557*^9}, {
   3.391536715478335*^9, 3.3915367582896357`*^9}, {3.3917773304575033`*^9, 
   3.391777420628098*^9}, 3.397515236129815*^9, {3.397673312652306*^9, 
   3.397673314899117*^9}, {3.3976733617709627`*^9, 3.397673388171262*^9}, {
   3.398730881576858*^9, 3.398730901919073*^9}, {3.398731029668275*^9, 
   3.3987311015627003`*^9}, {3.3987312893775873`*^9, 3.39873129086523*^9}, {
   3.3996406419740753`*^9, 3.399640643372745*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectConeAlongAxis", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{
      "d_", ",", " ", "hp_", ",", " ", "hs_", ",", " ", "ln_", ",", " ", 
       "ra_"}], "]"}], ",", " ", "axis_"}], "]"}], " ", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "newLn", ",", "newRa", ",", "newHp", ",", "newHs", ",", "cutter", ",", 
       "newCone", ",", "newDescriptor", ",", "minDim"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"newDescriptor", "=", 
       RowBox[{"UnitVector", "[", 
        RowBox[{"d", ",", "axis"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"minDim", " ", "=", " ", 
       RowBox[{"d", " ", "-", " ", 
        RowBox[{"Length", "[", "hp", "]"}], " ", "-", " ", 
        RowBox[{"Length", "[", "ln", "]"}], " ", "-", " ", "2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"newLn", ",", "newRa"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"newHp", ",", "newHs"}], "}"}]}], "}"}], " ", "=", " ", 
       RowBox[{"AddDescriptor", "[", 
        RowBox[{"d", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"ln", ",", "ra"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"hp", ",", "hs"}], "}"}]}], "}"}], ",", "newDescriptor", 
         ",", "isTwoSided"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"cutter", "=", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#1", ",", 
          RowBox[{"{", "axis", "}"}]}], "]"}], "&"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"newCone", " ", "=", 
       RowBox[{"ConvexCone", "[", 
        RowBox[{
         RowBox[{"d", "-", "1"}], ",", 
         RowBox[{"cutter", "/@", "newHp"}], ",", " ", 
         RowBox[{"cutter", "/@", "newHs"}], ",", " ", 
         RowBox[{"cutter", "/@", "newLn"}], ",", " ", 
         RowBox[{"cutter", "/@", "newRa"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SimplifyCone", "[", "newCone", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.391534013642355*^9, 3.391534040625567*^9}, {
   3.3915341586138353`*^9, 3.391534183599687*^9}, {3.391557770341957*^9, 
   3.391557953130168*^9}, {3.391558015260343*^9, 3.391558050926758*^9}, {
   3.391558088719207*^9, 3.391558194116455*^9}, {3.3915584771490593`*^9, 
   3.391558648478031*^9}, {3.3915591551048613`*^9, 3.391559192559908*^9}, {
   3.391559333942149*^9, 3.3915593372127037`*^9}, {3.391559396073792*^9, 
   3.3915593964794292`*^9}, {3.391787497465136*^9, 3.391787591226386*^9}, {
   3.3917876279306192`*^9, 3.3917877191597548`*^9}, {3.397236764830019*^9, 
   3.397236833369871*^9}, 3.3972372092856817`*^9, 3.398785213308755*^9, {
   3.399311759974869*^9, 3.399311773998889*^9}, {3.4532173928020477`*^9, 
   3.453217475743922*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IntersectConeWithHyperplane", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{
      "d_", ",", " ", "hp_", ",", " ", "hs_", ",", " ", "ln_", ",", " ", 
       "ra_"}], "]"}], ",", "axis_"}], " ", "]"}], " ", ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "newLn", ",", "newRa", ",", "newHp", ",", "newHs", ",", "cutter", ",", 
       "newCone", ",", "newDescriptor", ",", "minDim"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"newDescriptor", " ", "=", " ", 
       RowBox[{"UnitVector", "[", 
        RowBox[{"d", ",", "axis"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"minDim", " ", "=", " ", 
       RowBox[{"d", " ", "-", " ", 
        RowBox[{"Length", "[", "hp", "]"}], " ", "-", " ", 
        RowBox[{"Length", "[", "ln", "]"}], " ", "-", " ", "2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"newHp", ",", "newHs"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"newLn", ",", "newRa"}], "}"}]}], "}"}], " ", "=", 
       RowBox[{"AddDescriptor", "[", 
        RowBox[{"d", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hp", ",", "hs"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"ln", ",", "ra"}], "}"}]}], "}"}], ",", "newDescriptor", 
         ",", "isTwoSided"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"cutter", "=", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#1", ",", 
          RowBox[{"{", "axis", "}"}]}], "]"}], "&"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"newCone", " ", "=", 
       RowBox[{"ConvexCone", "[", 
        RowBox[{
         RowBox[{"d", "-", "1"}], ",", 
         RowBox[{"cutter", "/@", "newHp"}], ",", " ", 
         RowBox[{"cutter", "/@", "newHs"}], ",", " ", 
         RowBox[{"cutter", "/@", "newLn"}], ",", " ", 
         RowBox[{"cutter", "/@", "newRa"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SimplifyCone", "[", "newCone", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3915341902981987`*^9, 3.391534217376844*^9}, {
   3.3915601463903503`*^9, 3.391560290152977*^9}, 3.3915603357655478`*^9, {
   3.3917877289912777`*^9, 3.391787889148679*^9}, {3.397236839048191*^9, 
   3.3972368580029488`*^9}, 3.397237215622242*^9, 3.398785210575673*^9, 
   3.3993117873296967`*^9, {3.453217493141878*^9, 3.453217548289489*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests ", "Subsection",
 CellChangeTimes->{{3.397512987910059*^9, 3.397513016013926*^9}, 
   3.397513154988212*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConeContains", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{
      "d_", ",", " ", "hp_", ",", " ", "hs_", ",", " ", "ln_", ",", " ", 
       "ra_"}], "]"}], ",", "point_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"#1", ".", "point"}], "==", "0"}], ")"}], "&"}], "/@", 
        "hp"}], ")"}]}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"#1", ".", "point"}], "<=", "0"}], ")"}], "&"}], "/@", 
        "hs"}], ")"}]}], ")"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39751303299935*^9, 3.397513142217556*^9}, {
  3.397513322016553*^9, 3.397513366609591*^9}, {3.3975135349586353`*^9, 
  3.397513544626745*^9}, {3.397668721611113*^9, 3.3976687629430323`*^9}, {
  3.3976688328027067`*^9, 3.3976689333983*^9}, {3.398638099532545*^9, 
  3.3986381624371777`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SubCone", "[", 
    RowBox[{
     RowBox[{"ConvexCone", "[", 
      RowBox[{
      "d_", ",", " ", "hp_", ",", " ", "hs_", ",", " ", "ln_", ",", " ", 
       "ra_"}], "]"}], ",", "cone2_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ConeContains", "[", 
          RowBox[{"cone2", ",", "#1"}], "]"}], "&"}], "/@", "ln"}], ")"}]}], 
     ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ConeContains", "[", 
          RowBox[{"cone2", ",", 
           RowBox[{"-", "#1"}]}], "]"}], "&"}], "/@", "ln"}], ")"}]}], ")"}], 
    "&&", 
    RowBox[{"(", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ConeContains", "[", 
          RowBox[{"cone2", ",", "#1"}], "]"}], "&"}], "/@", "ra"}], ")"}]}], 
     ")"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397513167893373*^9, 3.3975132580436277`*^9}, {
  3.3975132980041437`*^9, 3.397513332408113*^9}, {3.397513554718665*^9, 
  3.397513567196064*^9}, {3.39766900329475*^9, 3.397669222586532*^9}, {
  3.398638182815815*^9, 3.3986382707538137`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EqualCone", "[", 
    RowBox[{"cone1_", ",", "cone2_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"SubCone", "[", 
     RowBox[{"cone1", ",", "cone2"}], "]"}], "&&", 
    RowBox[{"SubCone", "[", 
     RowBox[{"cone2", ",", "cone1"}], "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397513263356533*^9, 3.39751329002779*^9}, {
  3.3975133357810173`*^9, 3.397513337460699*^9}, {3.397513374525713*^9, 
  3.397513458932726*^9}, {3.3975135745854816`*^9, 3.397513585956078*^9}, {
  3.3976692338029537`*^9, 3.397669254166305*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Internal Operations", "Subsection",
 CellChangeTimes->{{3.389744244212472*^9, 3.389744252555757*^9}}],

Cell[CellGroupData[{

Cell["Checking of arguments to public functions for reasonability", \
"Subsubsection",
 CellChangeTimes->{{3.390174921151582*^9, 3.3901749279906797`*^9}, {
  3.391532155060244*^9, 3.3915321753884897`*^9}}],

Cell[TextData[{
 "\tDimVet[",
 StyleBox["list_1, list_2",
  FontSlant->"Italic"],
 "] checks that ",
 StyleBox["list_1",
  FontSlant->"Italic"],
 " and ",
 StyleBox["list_2 ",
  FontSlant->"Italic"],
 "are both lists, that one of them is non-empty, that their elements are all \
lists, and that all the latter lists have the same length ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ". It returns either ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " or a best guess at what ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " should be. If one of the checked requirements is violated, it makes a \
Throw with one of the tags notLists, emptyArgs, notUniform.\n\tDimVet[",
 StyleBox["d,list_1,list_2",
  FontSlant->"Italic"],
 "] checks that the second and third arguments are lists, and their members \
are lists of length ",
 StyleBox["d",
  FontSlant->"Italic"],
 ". It returns Null.\n\tDimVetOne[",
 StyleBox["d, descriptor",
  FontSlant->"Italic"],
 "] checks that ",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 " is a list of length ",
 StyleBox["d",
  FontSlant->"Italic"],
 ". It returns Null."
}], "Text",
 CellChangeTimes->{{3.390068443882251*^9, 3.3900685813907957`*^9}, 
   3.390084211091758*^9, {3.390084677320794*^9, 3.390084703647904*^9}, {
   3.390084739735112*^9, 3.390084749953596*^9}, {3.390085411394074*^9, 
   3.3900854438158503`*^9}, {3.390085854566203*^9, 3.390085862076255*^9}, {
   3.390085902821801*^9, 3.390085944111019*^9}, {3.390174183211465*^9, 
   3.3901742682004023`*^9}, {3.390174482819024*^9, 3.390174541873446*^9}, {
   3.391532192836898*^9, 3.391532223076886*^9}, {3.3915322855655527`*^9, 
   3.391532299862508*^9}, {3.397683004100338*^9, 3.397683007795288*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "notLists", ",", "emptyArgs", ",", "notUniform", ",", "wrongDimension", 
     ",", "singular"}], "}"}], ";"}], " ", 
  RowBox[{"(*", "Tags", "*)"}]}]], "Input",
 CellChangeTimes->{{3.390085952040777*^9, 3.390085978483706*^9}, {
  3.390174273286087*^9, 3.390174277572845*^9}, {3.39768344588561*^9, 
  3.397683448140524*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"3", ",", "emptyArgs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"arg1_List", ",", " ", "arg2_List"}], "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"allarg", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"arg1", ",", "arg2"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"And", "@@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"#1", ",", "_List"}], "]"}], "&"}], "/@", "allarg"}], 
         ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"All", " ", "members", " ", "are", " ", 
         RowBox[{"lists", ".", " ", "Should"}], " ", "be", " ", "of", " ", 
         "uniform", " ", "length"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"d", "=", 
           RowBox[{"Length", "@", 
            RowBox[{"First", "@", "allarg"}]}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Length", "@", "#1"}], " ", "==", " ", "d"}], ")"}], 
               "&"}], "/@", "allarg"}], ")"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"all", "'"}], "s", " ", "well"}], " ", "*)"}], "d", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Throw", "[", 
            RowBox[{"d", ",", "notUniform"}], "]"}]}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Eheu", "!"}], " ", "They", " ", 
         RowBox[{"aren", "'"}], "t", " ", "all", " ", 
         RowBox[{"Lists", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Throw", "[", 
        RowBox[{"2", ",", "notLists"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"arg1_", ",", "arg2_"}], "]"}], " ", ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"3", ",", "notLists"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.3900847597805767`*^9, 3.3900848439664087`*^9}, {
  3.390086151675681*^9, 3.390086155826805*^9}, {3.390086267382065*^9, 
  3.390086289328608*^9}, {3.391445282642131*^9, 3.39144533202842*^9}, {
  3.3914455745690937`*^9, 3.3914455884618*^9}, {3.3914456787752028`*^9, 
  3.391445730162347*^9}, {3.391445838507379*^9, 3.391445869513689*^9}, {
  3.39144605075709*^9, 3.391446067999161*^9}, {3.391446112147382*^9, 
  3.391446114705358*^9}, {3.391446154057263*^9, 3.391446193517194*^9}, {
  3.391446261861068*^9, 3.3914464403759937`*^9}, {3.391446486826127*^9, 
  3.391446487625454*^9}, {3.391446522740547*^9, 3.3914465684217377`*^9}, {
  3.391446598576583*^9, 3.391446611343994*^9}, {3.3914466446096067`*^9, 
  3.391446698180282*^9}, {3.3914467348227167`*^9, 3.3914467834158783`*^9}, {
  3.391446824953211*^9, 3.391446887645184*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"d_", ",", "arg1_List", ",", "arg2_List"}], "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"allarg", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"arg1", ",", "arg2"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"And", "@@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"#1", ",", "_List"}], "]"}], "&"}], "/@", "allarg"}], 
         ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"All", " ", "members", " ", "are", " ", 
         RowBox[{"lists", ".", " ", "Should"}], " ", "be", " ", "of", " ", 
         "length", " ", 
         RowBox[{"d", "."}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"And", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Length", "@", "#1"}], " ", "==", " ", "d"}], ")"}], 
             "&"}], "/@", "allarg"}], ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"all", "'"}], "s", " ", "well"}], " ", "*)"}], "Null", ",",
          "\[IndentingNewLine]", 
         RowBox[{"Throw", "[", 
          RowBox[{"Null", ",", "notUniform"}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "They", " ", "are", " ", "not", " ", "all", " ", "of", " ", "the", 
         " ", "right", " ", "length"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Throw", "[", 
        RowBox[{"Null", ",", "notLists"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"d_", ",", "arg1_", ",", "arg2_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Throw", "[", 
    RowBox[{"Null", ",", "notLists"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.390174293317677*^9, 3.390174350346488*^9}, {
   3.391446969351996*^9, 3.391447257180739*^9}, {3.3914473075815887`*^9, 
   3.391447356898931*^9}, {3.397682950183243*^9, 3.397682983694549*^9}, {
   3.397683485507707*^9, 3.397683487926085*^9}, 3.397683990325214*^9, {
   3.397684736730756*^9, 3.397684764066865*^9}, 3.469655253765761*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimVetOne", "[", 
    RowBox[{"d_", ",", " ", "desc_List"}], "]"}], " ", ":=", " ", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "desc", "]"}], "==", "d"}], ",", 
     "\[IndentingNewLine]", "Null", ",", "\[IndentingNewLine]", 
     RowBox[{"Throw", "[", 
      RowBox[{"Null", ",", "wrongDimension"}], "]"}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVetOne", "[", 
    RowBox[{"d_", ",", "desc_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Throw", "[", 
    RowBox[{"Null", ",", "notLists"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.391532310161154*^9, 3.391532332447928*^9}, {
  3.391639521275732*^9, 3.39163966636082*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adding to descriptions", "Subsubsection",
 CellChangeTimes->{{3.390174996419475*^9, 3.390174999729295*^9}, {
  3.3901772820602922`*^9, 3.390177292775199*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "\tAddDescriptions[",
 StyleBox["d",
  FontSlant->"Italic"],
 ", {",
 StyleBox["primary",
  FontSlant->"Italic"],
 ", ",
 StyleBox["secondary",
  FontSlant->"Italic"],
 "},",
 StyleBox["newprimary",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["primary",
  FontSlant->"Italic"],
 " and ",
 StyleBox["secondary ",
  FontSlant->"Italic"],
 "are two descriptions of a cone, and ",
 StyleBox["newprimary",
  FontSlant->"Italic"],
 " contains descriptors that are to be added to ",
 StyleBox["primary",
  FontSlant->"Italic"],
 ". Each of ",
 StyleBox["primary",
  FontSlant->"Italic"],
 ", ",
 StyleBox["secondary",
  FontSlant->"Italic"],
 ", and ",
 StyleBox["newprimary",
  FontSlant->"Italic"],
 " is a pair {",
 StyleBox["two-sided, one-sided",
  FontSlant->"Italic"],
 "} containing two possibly empty lists of descriptors.  The descriptors are \
all of dimension ",
 StyleBox["d",
  FontSlant->"Italic"],
 ".  The value returned is a pair, {",
 StyleBox["resultPrimary, resultSecondary",
  FontSlant->"Italic"],
 "}."
}], "Text",
 CellChangeTimes->{{3.390175058340887*^9, 3.390175062065062*^9}, {
  3.390175132182358*^9, 3.390175149398122*^9}, {3.390176615938992*^9, 
  3.3901766608670473`*^9}, {3.390176698781447*^9, 3.390176952056466*^9}, {
  3.390176982861587*^9, 3.390177023468144*^9}, {3.390177318934513*^9, 
  3.390177322617795*^9}, {3.453051066029767*^9, 3.4530510784167433`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddDescriptions", "[", 
    RowBox[{"d_", ",", "descriptions_", ",", 
     RowBox[{"{", 
      RowBox[{"newTwoSide_", ",", "newOneSide_"}], "}"}]}], "]"}], " ", ":=", 
   
   RowBox[{"Fold", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"AddDescriptor", "[", 
       RowBox[{"d", ",", "#1", ",", "#2", ",", "isOneSided"}], "]"}], "&"}], 
     ",", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"AddDescriptor", "[", 
         RowBox[{"d", ",", "#1", ",", "#2", ",", " ", "isTwoSided"}], "]"}], 
        "&"}], ",", "\[IndentingNewLine]", "descriptions", ",", 
       "newTwoSide"}], "]"}], ",", "\[IndentingNewLine]", "newOneSide"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.390177041211795*^9, 3.390177120962574*^9}, {
  3.3901773349373198`*^9, 3.390177337670199*^9}, {3.391640857169573*^9, 
  3.391640860447537*^9}, {3.391640915560667*^9, 3.391640947014784*^9}, {
  3.3916409777844048`*^9, 3.391641057523382*^9}, {3.3916410974039392`*^9, 
  3.3916411851699266`*^9}, {3.3958507063919477`*^9, 3.395850747056691*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "\tAddDescriptor[",
 StyleBox["d",
  FontSlant->"Italic"],
 ", {",
 StyleBox["primary",
  FontSlant->"Italic"],
 ", ",
 StyleBox["secondary",
  FontSlant->"Italic"],
 "}, ",
 StyleBox["newdescriptor,twoSidedFlag",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["primary",
  FontSlant->"Italic"],
 " and ",
 StyleBox["secondary",
  FontSlant->"Italic"],
 " are two descriptions of a cone, and ",
 StyleBox["newdescriptor",
  FontSlant->"Italic"],
 " is to be added to ",
 StyleBox["primary, ",
  FontSlant->"Italic"],
 "one-sided or two-sided depending on the value of ",
 StyleBox["twoSidedFlag",
  FontSlant->"Italic"],
 ". All the vectors are of dimension ",
 StyleBox["d",
  FontSlant->"Italic"],
 ". The resulting primary and secondary descriptions are computed and \
returned as a pair {",
 StyleBox["resultPrimary",
  FontSlant->"Italic"],
 ", ",
 StyleBox["resultSecondary",
  FontSlant->"Italic"],
 ")."
}], "Text",
 CellChangeTimes->{{3.390177369880107*^9, 3.39017768922766*^9}, 
   3.3916405912564163`*^9, {3.3958500393938417`*^9, 3.395850124508212*^9}, {
   3.3979309522250633`*^9, 3.397930971019724*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddDescriptor", "[", 
    RowBox[{"d_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"primFull_", ",", "primHalf_"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"secondFull_", ",", " ", "secondHalf_"}], "}"}]}], "}"}], ",",
      " ", "newDescriptor_", ",", " ", "twoSidedFlag_"}], "]"}], " ", ":=", 
   " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "scalarProducts", ",", "ns", ",", "minDim", ",", "removable", ",", 
       "newFull", ",", "newHalf"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "look", " ", "for", " ", "a", " ", "secondary", " ", "descriptor", " ", 
       "that", " ", "does", " ", "not", " ", "saturate", " ", 
       "newDescriptor"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"scalarProducts", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"newDescriptor", " ", ".", "#"}], ")"}], "&"}], " ", "/@", 
        " ", 
        RowBox[{"Join", "[", 
         RowBox[{"secondFull", ",", "secondHalf"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ns", " ", "=", " ", 
       RowBox[{"Pick", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "scalarProducts", "]"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", " ", "!=", " ", "0"}], ")"}], "&"}], " ", "/@", " ",
           "scalarProducts"}], ",", "True"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ns", " ", "==", " ", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "\t", 
        RowBox[{"(*", " ", 
         RowBox[{"All", " ", "secondaries", " ", 
          RowBox[{"saturate", ".", " ", "newDescriptor"}], " ", "is", " ", 
          "redundant"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"First", "[", "ns", "]"}], "<=", " ", 
         RowBox[{"Length", "[", "secondFull", "]"}]}], ",", 
        "\[IndentingNewLine]", "\t", 
        RowBox[{"(*", " ", 
         RowBox[{
         "A", " ", "full", " ", "secondary", " ", "does", " ", "not", " ", 
          "saturate"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"fns", "=", 
            RowBox[{"First", "@", "ns"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"removable", "=", 
            RowBox[{"secondFull", "[", 
             RowBox[{"[", "fns", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"!", "twoSidedFlag"}], ")"}], "&&", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"scalarProducts", "[", 
                 RowBox[{"[", "fns", "]"}], "]"}], ">", "0"}], ")"}]}], ",", 
             RowBox[{"removable", "=", 
              RowBox[{"-", "removable"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"newFull", "=", 
            RowBox[{"ShiftDescriptors", "[", 
             RowBox[{"newDescriptor", ",", "removable", ",", 
              RowBox[{"Drop", "[", 
               RowBox[{"secondFull", ",", " ", 
                RowBox[{"{", "fns", "}"}]}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"newHalf", "=", 
            RowBox[{"ShiftDescriptors", "[", 
             RowBox[{
             "newDescriptor", ",", " ", "removable", ",", "secondHalf"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{"twoSidedFlag", ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Append", "[", 
                  RowBox[{"primFull", ",", "newDescriptor"}], "]"}], ",", 
                 "primHalf"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"newFull", ",", "newHalf"}], "}"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", "else", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"primFull", ",", 
                 RowBox[{"Append", "[", 
                  RowBox[{"primHalf", ",", "newDescriptor"}], "]"}]}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"newFull", ",", 
                 RowBox[{"Append", "[", 
                  RowBox[{"newHalf", ",", "removable"}], "]"}]}], "}"}]}], 
              "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", "\t", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"All", " ", "full", " ", "secondaries", " ", "saturate"}], 
          ",", " ", 
          RowBox[{"but", " ", "not", " ", "all", " ", "Half", " ", 
           RowBox[{"s", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"minDim", " ", "=", " ", 
          RowBox[{"d", " ", "-", " ", 
           RowBox[{"Length", "[", "primFull", "]"}], "-", 
           RowBox[{"Length", "[", "secondFull", "]"}], "-", "2"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"newHalf", "=", 
          RowBox[{"FME", "[", 
           RowBox[{
           "primHalf", ",", "secondHalf", ",", "newDescriptor", ",", 
            "minDim"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{"twoSidedFlag", ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Append", "[", 
                RowBox[{"primFull", ",", "newDescriptor"}], "]"}], ",", 
               "primHalf"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"secondFull", ",", "newHalf"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", "else", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"primFull", ",", 
               RowBox[{"Append", "[", 
                RowBox[{"primHalf", ",", "newDescriptor"}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"secondFull", ",", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"Select", "[", 
                  RowBox[{"secondHalf", ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#1", ".", "newDescriptor"}], "<", "0"}], ")"}], 
                    "&"}]}], "]"}], ",", "newHalf"}], "]"}]}], "}"}]}], 
            "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.390177713010929*^9, 3.39017776047034*^9}, {
   3.391732315948222*^9, 3.391732419436366*^9}, {3.391732517654025*^9, 
   3.391732638885108*^9}, {3.391732706094274*^9, 3.3917328179484463`*^9}, {
   3.391732970874341*^9, 3.391732989282014*^9}, {3.391733058477932*^9, 
   3.3917332982410097`*^9}, {3.391774947676217*^9, 3.391775003690927*^9}, {
   3.3917750846241627`*^9, 3.391775141126946*^9}, {3.3917751843111153`*^9, 
   3.39177519972325*^9}, {3.391775244150276*^9, 3.391775250670072*^9}, {
   3.391776188872746*^9, 3.391776358706872*^9}, {3.3917765229531116`*^9, 
   3.391776610518305*^9}, {3.391776646740108*^9, 3.391776760527822*^9}, 
   3.391776796184635*^9, {3.3917778783932753`*^9, 3.3917779260242653`*^9}, {
   3.391777961731443*^9, 3.391778202011067*^9}, {3.391778235382286*^9, 
   3.391778317784483*^9}, {3.3917783577613907`*^9, 3.391778413693355*^9}, 
   3.391787958212438*^9, {3.3917879983483343`*^9, 3.391788009547102*^9}, {
   3.391788048759181*^9, 3.3917881730832043`*^9}, {3.391884714797906*^9, 
   3.391884774379374*^9}, {3.395850166174473*^9, 3.39585018301581*^9}, {
   3.397236949657357*^9, 3.397236957697358*^9}, {3.3972370103647757`*^9, 
   3.397237089160304*^9}, {3.397930664690633*^9, 3.397930665323721*^9}, {
   3.3979309920220957`*^9, 3.3979313958309107`*^9}, {3.397931469965412*^9, 
   3.3979315275903873`*^9}, {3.39793155895284*^9, 3.397931560671116*^9}, {
   3.397932049163064*^9, 3.397932111063546*^9}, 3.397932173778902*^9, {
   3.397932209470573*^9, 3.397932259299691*^9}, {3.3979323125739927`*^9, 
   3.39793231857755*^9}, {3.3979323618338537`*^9, 3.397932369357684*^9}, {
   3.469654225010016*^9, 3.469654300714562*^9}, 3.4696566352457533`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Operations on substructures of a double description", "Subsubsection",
 CellChangeTimes->{{3.3916400940244217`*^9, 3.3916401251104507`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 " \tFME[",
 StyleBox["primaryHalf, secondaryHalf, newPrimary, minDim",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["primaryHalf",
  FontSlant->"Italic"],
 " and ",
 StyleBox["secondaryHalf",
  FontSlant->"Italic"],
 " are lists of one-sided descriptors and ",
 StyleBox["newPrimary",
  FontSlant->"Italic"],
 " is a new descriptor (one or two sided) which will later be added to the \
primary description; ",
 StyleBox["minDim",
  FontSlant->"Italic"],
 " is the minimum number of saturated descriptors, used in testing for \
redundant new descriptors. FME performs Fourier-Motzkin elimination on ",
 StyleBox["secondaryHalf",
  FontSlant->"Italic"],
 " and returns the new secondary list of one-sided descriptors."
}], "Text",
 CellChangeTimes->{{3.391559455832809*^9, 3.391559501527007*^9}, {
  3.39155953348009*^9, 3.391559748417796*^9}, {3.391786987585153*^9, 
  3.391787001902124*^9}, {3.391787120788603*^9, 3.3917873693359537`*^9}, {
  3.3917874017453947`*^9, 3.39178741784098*^9}, {3.397236564045167*^9, 
  3.397236708832415*^9}, {3.4530718423956833`*^9, 3.453071867466346*^9}}],

Cell[TextData[{
 " \tIn order to economize on the number of new descriptors created by this \
function, we construct the predicate ",
 StyleBox["adjacentQ",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 " within the module. Consider two descriptors ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["secondaryHalf", "i"], TraditionalForm]],
  FontSlant->"Italic"],
 " and",
 StyleBox[" ",
  FontSlant->"Italic"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["secondaryHalf", "j"], TraditionalForm]],
  FontSlant->"Italic"],
 "; they are \"adjacent\" if the set of primary descriptors which they \
saturate is (a) big enough, as measured by minDim, and (b) not contained in \
the set which is saturated by any other secondary descriptor. adjacentQ[i,]] \
is True iff ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["secondaryHalf", "i"], TraditionalForm]],
  FontSlant->"Italic"],
 " and",
 StyleBox[" ",
  FontSlant->"Italic"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["secondaryHalf", "j"], TraditionalForm]],
  FontSlant->"Italic"],
 " are adjacent."
}], "Text",
 CellChangeTimes->{{3.391885031493178*^9, 3.391885103377697*^9}, {
   3.391885142419244*^9, 3.39188538811445*^9}, 3.395852693579308*^9, {
   3.397248615487275*^9, 3.397248770962316*^9}, {3.45307189554594*^9, 
   3.453071923910172*^9}, {3.453071979582341*^9, 3.4530719839744368`*^9}}],

Cell[TextData[{
 "The function ",
 StyleBox["combiner",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 " is also constructed within the module, in order to make the final \
expression reasonably compact.  combiner[i,j] is that combination of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["secondaryHalf", "i"], TraditionalForm]],
  FontSlant->"Italic"],
 " and",
 StyleBox[" ",
  FontSlant->"Italic"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["secondaryHalf", "j"], TraditionalForm]],
  FontSlant->"Italic"],
 " which saturates ",
 StyleBox["newPrimary",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.4530720097712727`*^9, 3.453072180061541*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FME", "[", 
    RowBox[{
    "primaryHalf_", ",", " ", "secondaryHalf_", ",", " ", "newPrimary_", ",", 
     "minDim_"}], "]"}], " ", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "combiner", ",", " ", "adjacentQ", ",", "adjacentPairs", ",", " ", 
       "ups", ",", " ", "downs", ",", "satLists"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ups", "=", 
       RowBox[{"SelectIndex", "[", 
        RowBox[{"secondaryHalf", ",", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#1", ".", "newPrimary"}], " ", ">", " ", "0"}], ")"}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"downs", "=", 
       RowBox[{"SelectIndex", "[", 
        RowBox[{"secondaryHalf", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#1", ".", "newPrimary"}], " ", "<", "0"}], ")"}], 
          "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"satLists", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"SaturationSet", "[", 
          RowBox[{
           RowBox[{"secondaryHalf", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", "primaryHalf"}], "]"}], ",", 
         
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "@", "secondaryHalf"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "predicate", " ", "of", " ", "indexes", " ", "of", " ", "two", " ", 
        "descriptors"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"adjacentQ", "[", 
        RowBox[{"i_", ",", "j_"}], "]"}], " ", ":=", " ", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"sigmaIJ", " ", "=", " ", 
           RowBox[{"Intersection", "[", 
            RowBox[{
             RowBox[{"satLists", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"satLists", "[", 
              RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Length", "[", "sigmaIJ", "]"}], ">=", "minDim"}], ")"}], 
          "&&", 
          RowBox[{"And", "@@", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"k", "==", "i"}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{"k", "==", "j"}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"Complement", "[", 
                  RowBox[{"sigmaIJ", ",", 
                   RowBox[{"satLists", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}], "]"}], ">", 
                "0"}], ")"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", 
               RowBox[{"Length", "[", "secondaryHalf", "]"}]}], "}"}]}], 
            "]"}]}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "function", " ", "used", " ", "in", " ", "making", " ", "new", " ", 
        "descriptors"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"combiner", "=", 
       RowBox[{
        RowBox[{"Regularize", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"secondaryHalf", "[", 
              RowBox[{"[", "#1", "]"}], "]"}], ".", "newPrimary"}], ")"}], 
           RowBox[{"secondaryHalf", "[", 
            RowBox[{"[", "#2", "]"}], "]"}]}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"secondaryHalf", "[", 
              RowBox[{"[", "#2", "]"}], "]"}], ".", "newPrimary"}], ")"}], 
           RowBox[{"secondaryHalf", "[", 
            RowBox[{"[", "#1", "]"}], "]"}]}]}], "]"}], "&"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"adjacentPairs", " ", "=", " ", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Outer", "[", 
            RowBox[{"List", ",", "ups", ",", "downs"}], "]"}], ",", "1"}], 
          "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"adjacentQ", "@@", "#1"}], ")"}], "&"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{"secondaryHalf", ",", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"#1", ".", "newPrimary"}], " ", "==", " ", "0"}], ")"}], 
           "&"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"combiner", "@@", "#1"}], ")"}], "&"}], " ", "/@", " ", 
         "adjacentPairs"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.391559756910421*^9, 3.391559780117609*^9}, {
   3.3917874263508253`*^9, 3.391787441606904*^9}, {3.3918129881087933`*^9, 
   3.391813015762966*^9}, {3.3918131664856863`*^9, 3.3918133766877737`*^9}, {
   3.3918134171616917`*^9, 3.39181359081828*^9}, {3.397236719539517*^9, 
   3.39723672859657*^9}, {3.397247184938128*^9, 3.397247191148793*^9}, {
   3.3972474677805033`*^9, 3.397247498318132*^9}, {3.3972475430881023`*^9, 
   3.397247547313747*^9}, {3.3972483476187*^9, 3.397248464814459*^9}, {
   3.397248587979273*^9, 3.3972485910887737`*^9}, {3.39724880884943*^9, 
   3.397248894315391*^9}, {3.397248972749793*^9, 3.397249071468738*^9}, {
   3.397249346931168*^9, 3.39724935211687*^9}, {3.397249396529625*^9, 
   3.3972494269253817`*^9}, {3.397249527576461*^9, 3.397249562854937*^9}, {
   3.3972496023803453`*^9, 3.39724970648333*^9}, {3.397487962427034*^9, 
   3.397488005380522*^9}, {3.397488045850601*^9, 3.397488070903481*^9}, {
   3.397488742479703*^9, 3.397488754301551*^9}, {3.3980984490860662`*^9, 
   3.398098449508813*^9}, 3.398098482482341*^9, 3.398195875179564*^9, {
   3.398197723826139*^9, 3.398197735271015*^9}, {3.398198102395399*^9, 
   3.398198130974839*^9}, {3.453209584429654*^9, 3.4532095906990423`*^9}, {
   3.453209644862355*^9, 3.453209708183236*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tSimplifyCone[",
 StyleBox["cone",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " is a ConvexCone. It returns a fully optimized convex cone."
}], "Text",
 CellChangeTimes->{{3.3915599206136637`*^9, 3.391560068921872*^9}, 
   3.395852641088805*^9, {3.3973184170654087`*^9, 3.397318433493146*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SimplifyCone", "[", "cone_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cone", " ", "//", " ", "FirstOptimize"}], " ", "//", " ", 
      "SecondOptimize"}], " ", "//", " ", "ThirdOptimize"}], " ", "//", " ", 
    "FullOptimize"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.391560061378063*^9, 3.391560099380705*^9}, {
  3.391812743940844*^9, 3.391812900161022*^9}, {3.391812948737885*^9, 
  3.391812992715765*^9}, {3.3973191854894648`*^9, 3.397319218739049*^9}, {
  3.397591081342677*^9, 3.3975910909108877`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 " \tFirstOptimize[",
 StyleBox["cone",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["cone ",
  FontSlant->"Italic"],
 "is a ConvexCone. It returns the first-stage optimization of ",
 StyleBox["cone.",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.397318465999124*^9, 3.39731855223389*^9}, 
   3.397318918783093*^9, {3.3973194014464703`*^9, 3.39731950239928*^9}, 
   3.3974068925764437`*^9, 3.398098680973507*^9}],

Cell[TextData[{
 StyleBox["\t",
  FontSlant->"Italic"],
 "Those rays that are fully saturated by the halfspaces are promoted to \
lines. Likewise, those halfspaces that are fully saturated by the rays are \
promoted to halfspaces."
}], "Text",
 CellChangeTimes->{{3.397318465999124*^9, 3.39731855223389*^9}, 
   3.397318918783093*^9, {3.3973194014464703`*^9, 3.39731950239928*^9}, {
   3.3974068925764437`*^9, 3.397406896576227*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FirstOptimize", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "satRays", ",", " ", "unSatRays", ",", " ", "satHs", ",", " ", 
       "unSatHs"}], "}"}], ",", 
     RowBox[{
      RowBox[{"satRays", " ", "=", " ", 
       RowBox[{"SelectIndex", "[", 
        RowBox[{"ra", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Length", "[", "hs", "]"}], " ", "==", " ", 
            RowBox[{"Length", "@", 
             RowBox[{"SaturationSet", "[", 
              RowBox[{"#1", ",", "hs"}], "]"}]}]}], ")"}], "&"}]}], "]"}]}], 
      ";", 
      RowBox[{"unSatRays", " ", "=", " ", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Range", "@", 
          RowBox[{"Length", "@", "ra"}]}], ",", "satRays"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"satHs", " ", "=", " ", 
       RowBox[{"SelectIndex", "[", 
        RowBox[{"hs", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Length", "[", "ra", "]"}], " ", "==", " ", 
            RowBox[{"Length", "@", 
             RowBox[{"SaturationSet", "[", 
              RowBox[{"#1", ",", "ra"}], "]"}]}]}], ")"}], "&"}]}], "]"}]}], 
      ";", " ", 
      RowBox[{"unSatHs", " ", "=", " ", 
       RowBox[{"Complement", "[", 
        RowBox[{
         RowBox[{"Range", "@", 
          RowBox[{"Length", "@", "hs"}]}], ",", "satHs"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ConvexCone", "[", 
       RowBox[{"d", ",", 
        RowBox[{"hp", " ", "~", " ", "Join", " ", "~", 
         RowBox[{"hs", "[", 
          RowBox[{"[", "satHs", "]"}], "]"}]}], ",", 
        RowBox[{"hs", "[", 
         RowBox[{"[", "unSatHs", "]"}], "]"}], ",", 
        RowBox[{"ln", " ", "~", " ", "Join", " ", "~", " ", 
         RowBox[{"ra", "[", 
          RowBox[{"[", "satRays", "]"}], "]"}]}], ",", 
        RowBox[{"ra", "[", 
         RowBox[{"[", "unSatRays", "]"}], "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397318565935482*^9, 3.3973185826218643`*^9}, {
   3.3973195359871807`*^9, 3.397319554164029*^9}, {3.397319666955093*^9, 
   3.397319748232444*^9}, {3.397319845085383*^9, 3.397319912248406*^9}, {
   3.397319949631715*^9, 3.397320012882691*^9}, {3.3973200437893543`*^9, 
   3.397320240124827*^9}, {3.397320355401177*^9, 3.397320359500548*^9}, {
   3.397320478497654*^9, 3.3973205714705*^9}, 3.39759109299055*^9, {
   3.398185877333233*^9, 3.398185891352062*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tSecondOptimize[",
 StyleBox["cone",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " is a first-stage optimized ConvexCone. It returns the second-stage \
optimization of ",
 StyleBox["cone",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.397318601041686*^9, 3.397318671133951*^9}, {
   3.397405972993948*^9, 3.3974060296366377`*^9}, {3.397406081494829*^9, 
   3.3974061113679743`*^9}, {3.397406181924673*^9, 3.397406247667087*^9}, {
   3.397406281781302*^9, 3.3974064054564047`*^9}, 3.397406912635228*^9, 
   3.398098643028935*^9}],

Cell["\<\
\tIt acts on the one-sided and two-sided desciptors of each description, in \
the following way. for each two-sided descriptor the index of its first \
non-zero element is found, and multiples of this descriptor are added to the \
other descriptors so that the results have zero elements at that index. A \
descriptor that is all zeroes is ignored, and eventually removed from the \
description.\
\>", "Text",
 CellChangeTimes->{{3.397318601041686*^9, 3.397318671133951*^9}, {
  3.397405972993948*^9, 3.3974060296366377`*^9}, {3.397406081494829*^9, 
  3.3974061113679743`*^9}, {3.397406181924673*^9, 3.397406247667087*^9}, {
  3.397406281781302*^9, 3.3974064054564047`*^9}, {3.397406912635228*^9, 
  3.397406917642256*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SecondOptimize", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newHp", ",", "newHs"}], "}"}], "=", 
       RowBox[{"Fold", "[", 
        RowBox[{"EliminateByRow", ",", 
         RowBox[{"{", 
          RowBox[{"hp", ",", "hs"}], "}"}], ",", 
         RowBox[{"Range", "@", 
          RowBox[{"Length", "@", "hp"}]}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"newLn", ",", "newRa"}], "}"}], "=", 
       RowBox[{"Fold", "[", 
        RowBox[{"EliminateByRow", ",", 
         RowBox[{"{", 
          RowBox[{"ln", ",", "ra"}], "}"}], ",", 
         RowBox[{"Range", "@", 
          RowBox[{"Length", "@", "ln"}]}]}], "]"}]}], ";", 
      RowBox[{"ConvexCone", "[", 
       RowBox[{"d", ",", 
        RowBox[{"Select", "[", 
         RowBox[{"newHp", ",", "IsNotZeroQ"}], "]"}], ",", 
        RowBox[{"Select", "[", 
         RowBox[{"newHs", ",", "IsNotZeroQ"}], "]"}], ",", 
        RowBox[{"Select", "[", 
         RowBox[{"newLn", ",", "IsNotZeroQ"}], "]"}], ",", 
        RowBox[{"Select", "[", 
         RowBox[{"newRa", ",", "IsNotZeroQ"}], "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397318679070841*^9, 3.397318704481645*^9}, 
   3.397406428019479*^9, {3.397406509910489*^9, 3.3974065192671003`*^9}, {
   3.397406660724372*^9, 3.3974066776719418`*^9}, {3.3974067445293617`*^9, 
   3.397406826746279*^9}, 3.3974069582399683`*^9, {3.397407121834519*^9, 
   3.397407142460374*^9}, {3.39740749048004*^9, 3.397407502127033*^9}, {
   3.3974077624374857`*^9, 3.3974078620300503`*^9}, 3.398098652341404*^9, {
   3.398112752302546*^9, 3.3981127799960747`*^9}, {3.398113872089375*^9, 
   3.398113923694364*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 " \tEliminateByRow[{",
 StyleBox["fullDesc,halfDesc",
  FontSlant->"Italic"],
 "},",
 StyleBox["i",
  FontSlant->"Italic"],
 "] finds the index ",
 StyleBox["j ",
  FontSlant->"Italic"],
 "of the first non-zero element of ",
 StyleBox["fullDesc[[i]]",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.397407184987995*^9, 3.3974074321751423`*^9}, 
   3.397407894008463*^9}],

Cell[TextData[{
 "\tIt adds multiples of ",
 StyleBox["fullDesc[[i]]",
  FontSlant->"Italic"],
 " to all the other rows of ",
 StyleBox["fullDesc",
  FontSlant->"Italic"],
 ", and to all the rows of ",
 StyleBox["halfDesc",
  FontSlant->"Italic"],
 ", so as to make their ",
 StyleBox["j",
  FontSlant->"Italic"],
 "th elements 0."
}], "Text",
 CellChangeTimes->{{3.397407184987995*^9, 3.3974074321751423`*^9}, 
   3.397407894008463*^9, {3.397407953399741*^9, 3.397407976897005*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EliminateByRow", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"fullDesc_", ",", "halfDesc_"}], "}"}], ",", "i_"}], "]"}], " ",
    ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"jl", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Range", "@", 
          RowBox[{"Length", "[", 
           RowBox[{"fullDesc", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0", " ", "!=", " ", 
            RowBox[{"fullDesc", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "#1"}], "]"}], "]"}]}], ")"}], "&"}], ",", 
         "1"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"EBR2", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"fullDesc", ",", "halfDesc"}], "}"}], ",", "i", ",", "jl"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397407443598527*^9, 3.3974074850181932`*^9}, {
   3.3974086847358932`*^9, 3.3974086898908854`*^9}, {3.397408752864605*^9, 
   3.397408844164544*^9}, {3.3979280623223953`*^9, 3.397928076829493*^9}, {
   3.397928116068509*^9, 3.397928134248057*^9}, 3.397928723732794*^9, {
   3.3979289358828783`*^9, 3.3979289611321497`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EBR2", "[", 
    RowBox[{"description_", ",", "i_", ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", "description"}], ";"}]], "Input",
 CellChangeTimes->{{3.3974088758192863`*^9, 3.3974089116646423`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EBR2", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"fullDesc_", ",", "halfDesc_"}], "}"}], ",", "i_", ",", 
     RowBox[{"{", "j_", "}"}]}], "]"}], " ", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"fullA", ",", "fullB", ",", "gauss", ",", "den", ",", "row"}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{"fullA", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"fullDesc", ",", 
         RowBox[{"i", "-", "1"}]}], "]"}]}], ";", " ", 
      RowBox[{"fullB", "=", 
       RowBox[{"Take", "[", 
        RowBox[{"fullDesc", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"i", "+", "1"}], ",", 
           RowBox[{"Length", "@", "fullDesc"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"row", "=", 
       RowBox[{"fullDesc", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"den", "=", 
       RowBox[{"row", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"gauss", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"#1", " ", "-", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"#1", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "/", "den"}], ")"}], "*", 
           "row"}]}], ")"}], "&"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"gauss", "/@", "fullA"}], ",", 
          RowBox[{"{", "row", "}"}], ",", 
          RowBox[{"gauss", "/@", "fullB"}]}], "]"}], ",", 
        RowBox[{"gauss", "/@", "halfDesc"}]}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397408970980987*^9, 3.397408998603973*^9}, {
  3.397413436617906*^9, 3.397413478524708*^9}, {3.3974136633643093`*^9, 
  3.397413719114726*^9}, {3.397413751031007*^9, 3.397413837727303*^9}, {
  3.397413878410123*^9, 3.397413903530799*^9}, {3.39741393602684*^9, 
  3.3974140144623423`*^9}, {3.397414057675325*^9, 3.3974141376798677`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tIsNotZeroQ[",
 StyleBox["desc",
  FontSlant->"Italic"],
 "] is True iff ",
 StyleBox["desc",
  FontSlant->"Italic"],
 " is not the zero vector."
}], "Text",
 CellChangeTimes->{{3.3974076528341703`*^9, 3.397407698487352*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IsNotZeroQ", "[", "desc_", "]"}], " ", ":=", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"Select", "[", 
      RowBox[{"desc", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"0", "!=", " ", "#1"}], ")"}], "&"}]}], "]"}], "]"}], " ", 
    ">", "0"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397407706722332*^9, 3.397407716867345*^9}, {
  3.397408544012968*^9, 3.397408557654915*^9}, {3.397408591085655*^9, 
  3.397408619210023*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tThirdOptimize[",
 StyleBox["cone",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " is a second-stage optimized ConvexCone. It returns the third-stage \
optimization of ",
 StyleBox["cone",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.3973187220428133`*^9, 3.397318788753625*^9}, {
   3.397318924031279*^9, 3.397318924381748*^9}, 3.398098626259763*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThirdOptimize", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", 
   RowBox[{"ConvexCone", "[", 
    RowBox[{"d", ",", "hp", ",", 
     RowBox[{"WeedOut", "@", "hs"}], ",", "ln", ",", 
     RowBox[{"WeedOut", "@", "ra"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3973188430752287`*^9, 3.397318855182684*^9}, {
   3.3974717525683193`*^9, 3.3974717867234993`*^9}, {3.3974719260439863`*^9, 
   3.397472038207486*^9}, 3.398098595891288*^9}],

Cell[CellGroupData[{

Cell[TextData[{
 " \tWeedout[",
 StyleBox["dList",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["dList",
  FontSlant->"Italic"],
 " is a list of non-zero descriptors. It finds any proportional pairs of \
descriptors and removes from ",
 StyleBox["dList",
  FontSlant->"Italic"],
 " the second member of each pair."
}], "Text",
 CellChangeTimes->{{3.397473266134674*^9, 3.3974733451970654`*^9}, {
  3.398027832987056*^9, 3.398027837073659*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WeedOut", "[", "dlist_", "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "pairs", ",", "props", ",", "drops"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"Length", "@", "dlist"}]}], ";", 
      RowBox[{"pairs", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", "j"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", 
               RowBox[{"i", "+", "1"}], ",", "n"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", "1"}], 
        "]"}]}], ";", 
      RowBox[{"props", "=", 
       RowBox[{"Select", "[", 
        RowBox[{"pairs", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ProportionalQ", "@@", 
            RowBox[{"dlist", "[", 
             RowBox[{"[", "#1", "]"}], "]"}]}], ")"}], "&"}]}], "]"}]}], ";", 
      
      RowBox[{"drops", "=", 
       RowBox[{"Union", "[", 
        RowBox[{"Last", "/@", "props"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"dlist", "[", 
       RowBox[{"[", 
        RowBox[{"Complement", "[", 
         RowBox[{
          RowBox[{"Range", "[", "n", "]"}], ",", "drops"}], "]"}], "]"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3974720439448347`*^9, 3.397472215201825*^9}, {
   3.397472344678146*^9, 3.397472357857481*^9}, {3.397472402420224*^9, 
   3.397472403187037*^9}, {3.3974724633017406`*^9, 3.397472594930579*^9}, {
   3.39747276166714*^9, 3.397472839381384*^9}, {3.3974729032890167`*^9, 
   3.397472966288196*^9}, {3.397473059201338*^9, 3.3974731765420313`*^9}, {
   3.397594021368737*^9, 3.397594021672883*^9}, {3.398027479219223*^9, 
   3.398027480309292*^9}, 3.398028367417822*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tProportionalQ[",
 StyleBox["desc1,desc2",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["desc1",
  FontSlant->"Italic"],
 " and ",
 StyleBox["desc2",
  FontSlant->"Italic"],
 " are descriptors. It returns True if and only if they are proportional."
}], "Text",
 CellChangeTimes->{{3.397471642553151*^9, 3.397471704019505*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProportionalQ", "[", 
    RowBox[{"desc1_", ",", "desc2_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"desc1", ".", "desc2"}], ")"}], "^", "2"}], " ", "==", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"desc1", ".", "desc1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"desc2", ".", "desc2"}], ")"}]}]}], ")"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397471608857172*^9, 3.397471632284309*^9}, {
  3.397481493829968*^9, 3.397481528583556*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tFullOptimize[",
 StyleBox["cone",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["cone",
  FontSlant->"Italic"],
 " is a third-stage optimized ConvexCone. It returns the fully optimzed form \
of ",
 StyleBox["cone",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.3973188707784243`*^9, 3.397318951182934*^9}, 
   3.398098621315959*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FullOptimize", "[", 
    RowBox[{"ConvexCone", "[", 
     RowBox[{"d_", ",", "hp_", ",", "hs_", ",", "ln_", ",", "ra_"}], "]"}], 
    "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"newHs", ",", "newRa", ",", "minDim"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"minDim", " ", "=", " ", 
       RowBox[{"d", " ", "-", " ", 
        RowBox[{"Length", "[", "hp", "]"}], "-", 
        RowBox[{"Length", "[", "ln", "]"}], "-", "1"}]}], ";", 
      RowBox[{"newHs", " ", "=", 
       RowBox[{"OptimizeDescList", "[", 
        RowBox[{"hs", ",", "ra", ",", "minDim"}], "]"}]}], ";", " ", 
      RowBox[{"newRa", "=", 
       RowBox[{"OptimizeDescList", "[", 
        RowBox[{"ra", ",", "hs", ",", "minDim"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ConvexCone", "[", 
       RowBox[{"d", ",", "hp", ",", "newHs", ",", "ln", ",", "newRa"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397318961234776*^9, 3.397318976122423*^9}, {
   3.3974872088813877`*^9, 3.397487223841873*^9}, {3.3974873240606318`*^9, 
   3.397487373656085*^9}, {3.397487651250537*^9, 3.397487725011894*^9}, {
   3.397488181654031*^9, 3.397488252280251*^9}, 3.39809858195746*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tOptimizeDescList[",
 StyleBox["primaryDesc,secondaryDesc_",
  FontSlant->"Italic"],
 " assumes that its two arguments are lists of one-sided descriptors. It \
returns a copy of ",
 StyleBox["primaryDesc",
  FontSlant->"Italic"],
 " trimmed of redundant members."
}], "Text",
 CellChangeTimes->{{3.397487534596978*^9, 3.3974876147663307`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OptimizeDescList", "[", 
    RowBox[{"primaryDesc_", ",", "secondaryDesc_", ",", "minDim_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"satLists", ",", "essentialIndexes"}], "}"}], ",", 
     RowBox[{
      RowBox[{"satLists", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"SaturationSet", "[", 
          RowBox[{
           RowBox[{"primaryDesc", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", "secondaryDesc"}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "@", "primaryDesc"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{"essentialIndexes", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "primaryDesc", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"satLists", "[", 
                RowBox[{"[", "#1", "]"}], "]"}], "]"}], ">=", " ", "minDim"}],
              ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"And", "@@", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"k", "==", "#1"}], ")"}], "||", 
                 RowBox[{
                  RowBox[{"Length", "[", 
                   RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{"satLists", "[", 
                    RowBox[{"[", "#1", "]"}], "]"}], ",", 
                    RowBox[{"satLists", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}], "]"}], ">", 
                  "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", 
                  RowBox[{"Length", "@", "primaryDesc"}]}], "}"}]}], "]"}]}], 
             ")"}]}], ")"}], "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"primaryDesc", "[", 
       RowBox[{"[", "essentialIndexes", "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397487411122476*^9, 3.397487454749928*^9}, 
   3.3974876620928087`*^9, {3.397487785781733*^9, 3.397487818581727*^9}, {
   3.397487849353047*^9, 3.3974878724080753`*^9}, {3.39748825726833*^9, 
   3.3974884224988947`*^9}, {3.397488482838779*^9, 3.397488647276286*^9}, {
   3.397488692563796*^9, 3.397488730658643*^9}, {3.397488831551487*^9, 
   3.3974889168814507`*^9}, {3.398031044976325*^9, 3.398031068052471*^9}, {
   3.398031110615473*^9, 3.398031177353074*^9}, {3.398032131334296*^9, 
   3.3980321654361343`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \tSaturationSet[",
 StyleBox["primeDesc,secondDescList",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["primeDesc",
  FontSlant->"Italic"],
 " is a descriptor and ",
 StyleBox["secondDesc",
  FontSlant->"Italic"],
 " is a list of descrptors. It returns a list of the indexes of those \
elements of ",
 StyleBox["secondDescList",
  FontSlant->"Italic"],
 " which saturate ",
 StyleBox["primeDesc.",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.397237470300784*^9, 3.3972376605735817`*^9}, {
  3.3972376939498997`*^9, 3.3972376948936777`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SaturationSet", "[", 
    RowBox[{"primeDesc_", ",", "secondDescList_"}], "]"}], " ", ":=", " ", 
   RowBox[{"SelectIndex", "[", 
    RowBox[{"secondDescList", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"primeDesc", ".", "#1"}], " ", "==", " ", "0"}], ")"}], 
      "&"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397237670903051*^9, 3.397237707905415*^9}, {
  3.39724763384803*^9, 3.397247648237172*^9}, {3.397247735061591*^9, 
  3.3972477920093937`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "This version of ",
 StyleBox["Select",
  FontWeight->"Bold"],
 " returns the indexes of selected elements of a list, not the elements \
themselves."
}], "Text",
 CellChangeTimes->{{3.397247129824525*^9, 3.397247174061936*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SelectIndex", "[", 
    RowBox[{"list_", ",", "crit_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"Range", "@", 
      RowBox[{"Length", "@", "list"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"crit", "[", 
        RowBox[{"list", "[", 
         RowBox[{"[", "#1", "]"}], "]"}], "]"}], ")"}], "&"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.3972469432630663`*^9, 3.397246995102459*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "ShiftDescriptors[",
 StyleBox["normal, addend, descriptorList",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["normal",
  FontSlant->"Italic"],
 " and ",
 StyleBox["addend",
  FontSlant->"Italic"],
 " are descriptors, and ",
 StyleBox["descriptorList",
  FontSlant->"Italic"],
 " is a list of descriptors. It addes to each element of ",
 StyleBox["descriptorList ",
  FontSlant->"Italic"],
 "a multiple of ",
 StyleBox["addend",
  FontSlant->"Italic"],
 ", so that the result is orthogonal to ",
 StyleBox["normal",
  FontSlant->"Italic"],
 ". It returns the list of modified descriptors."
}], "Text",
 CellChangeTimes->{{3.391777478157618*^9, 3.391777743373209*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftDescriptors", "[", 
    RowBox[{"normal_", ",", " ", "addend_", ",", " ", "descriptorList_"}], 
    "]"}], " ", ":=", 
   RowBox[{"Regularize", " ", "/@", 
    RowBox[{"(", 
     RowBox[{"descriptorList", " ", "-", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{"normal", ".", "addend"}], ")"}]}], ")"}], 
       RowBox[{"KroneckerProduct", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", ".", "normal"}], ")"}], "&"}], "/@", 
          "descriptorList"}], ",", "addend"}], "]"}]}]}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.391777751792493*^9, 3.391777779690859*^9}, {
   3.3918124930592003`*^9, 3.391812588564147*^9}, {3.397771644669557*^9, 
   3.3977716520369883`*^9}, {3.3977720388784733`*^9, 3.397772050849834*^9}, {
   3.397772561442582*^9, 3.397772603418569*^9}, 3.398291354629352*^9, {
   3.4532065103241043`*^9, 3.45320653722256*^9}, {3.453207827997501*^9, 
   3.453207834107315*^9}, {3.453208942637411*^9, 3.453208952084494*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 "Regularize[",
 StyleBox["vector",
  FontSlant->"Italic"],
 "] multiplies ",
 StyleBox["vector",
  FontSlant->"Italic"],
 " by the reciprocal of the absolute value of the last non-zero component."
}], "Text",
 CellChangeTimes->{{3.4532056054162817`*^9, 3.4532056709860086`*^9}, {
  3.45320632359199*^9, 3.453206326005999*^9}, {3.45320682617001*^9, 
  3.453206833639822*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Regularize", "[", "vector_", "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nz", "=", 
       RowBox[{"Select", "[", 
        RowBox[{"vector", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", " ", "!=", " ", "0"}], ")"}], "&"}]}], "]"}]}], "}"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "nz", "]"}], "==", "0"}], ",", 
       "\[IndentingNewLine]", "vector", ",", " ", 
       RowBox[{"(*", "else", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"Abs", "[", 
           RowBox[{"Last", "[", "nz", "]"}], "]"}]}], ")"}], "vector"}]}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.453205679788137*^9, 3.453205737095448*^9}, {
   3.453205784227537*^9, 3.453205800646714*^9}, {3.453205863463944*^9, 
   3.45320586612704*^9}, {3.45320594079038*^9, 3.453205950344949*^9}, {
   3.45320619325694*^9, 3.453206308922172*^9}, {3.453206358590625*^9, 
   3.453206361166716*^9}, 3.4532064400132427`*^9, {3.4532068761444283`*^9, 
   3.453206884960018*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.38974379552286*^9, 3.3897437981148787`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.38974380112297*^9, 3.389743806227131*^9}}]
}, Open  ]]
}, Open  ]]
},
CellGrouping->Manual,
WindowSize->{621, 769},
WindowMargins->{{Automatic, 243}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"7.0 for Mac OS X PowerPC (32-bit) (February 18, 2009)",
StyleDefinitions->"DefaultPkg.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 239, 5, 24, "Input"],
Cell[787, 27, 191, 4, 24, "Input"],
Cell[981, 33, 396, 8, 55, "Input"],
Cell[1380, 43, 627, 14, 55, "Input"],
Cell[2010, 59, 270, 7, 24, "Input"],
Cell[2283, 68, 357, 8, 24, "Input"],
Cell[2643, 78, 219, 5, 24, "Input"],
Cell[2865, 85, 1696, 38, 115, "Input"],
Cell[4564, 125, 459, 11, 40, "Input"],
Cell[5026, 138, 202, 5, 24, "Input"],
Cell[CellGroupData[{
Cell[5253, 147, 95, 1, 96, "Title"],
Cell[CellGroupData[{
Cell[5373, 152, 97, 1, 59, "Subtitle"],
Cell[5473, 155, 262, 7, 28, "Text"],
Cell[CellGroupData[{
Cell[5760, 166, 104, 1, 49, "Subsubtitle"],
Cell[5867, 169, 1084, 25, 48, "Text"],
Cell[6954, 196, 1647, 43, 35, "Text"],
Cell[8604, 241, 1203, 32, 30, "Text"],
Cell[9810, 275, 735, 27, 30, "Text"],
Cell[10548, 304, 345, 7, 45, "Text"],
Cell[10896, 313, 1167, 35, 67, "Text"],
Cell[12066, 350, 848, 24, 71, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12951, 379, 101, 1, 49, "Subsubtitle"],
Cell[13055, 382, 411, 12, 31, "Text"],
Cell[13469, 396, 961, 31, 35, "Text"],
Cell[14433, 429, 913, 30, 35, "Text"],
Cell[15349, 461, 165, 3, 29, "Text"],
Cell[15517, 466, 650, 25, 28, "Text"],
Cell[16170, 493, 543, 20, 28, "Text"],
Cell[16716, 515, 182, 4, 29, "Text"],
Cell[16901, 521, 521, 18, 32, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17459, 544, 101, 1, 49, "Subsubtitle"],
Cell[17563, 547, 975, 15, 147, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18575, 567, 161, 2, 49, "Subsubtitle"],
Cell[18739, 571, 830, 14, 113, "Text"],
Cell[19572, 587, 409, 14, 66, "Text"],
Cell[19984, 603, 453, 16, 66, "Text"],
Cell[20440, 621, 1170, 31, 151, "Text"],
Cell[21613, 654, 986, 31, 151, "Text"],
Cell[22602, 687, 924, 25, 148, "Text"],
Cell[23529, 714, 694, 19, 148, "Text"],
Cell[24226, 735, 1103, 33, 165, "Text"],
Cell[25332, 770, 802, 24, 131, "Text"],
Cell[26137, 796, 803, 24, 131, "Text"],
Cell[26943, 822, 1114, 32, 148, "Text"],
Cell[28060, 856, 1229, 35, 148, "Text"],
Cell[29292, 893, 1312, 40, 148, "Text"],
Cell[30607, 935, 1254, 38, 148, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31898, 978, 93, 1, 49, "Subsubtitle"],
Cell[31994, 981, 669, 23, 131, "Text"],
Cell[32666, 1006, 615, 21, 117, "Text"],
Cell[33284, 1029, 634, 23, 117, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33967, 1058, 124, 2, 59, "Subtitle"],
Cell[34094, 1062, 238, 5, 24, "Input"],
Cell[CellGroupData[{
Cell[34357, 1071, 170, 2, 48, "Section"],
Cell[34530, 1075, 344, 7, 55, "Input"],
Cell[CellGroupData[{
Cell[34899, 1086, 100, 1, 42, "Subsection"],
Cell[35002, 1089, 307, 6, 55, "Input"],
Cell[35312, 1097, 351, 7, 55, "Input"],
Cell[35666, 1106, 480, 9, 55, "Input"],
Cell[36149, 1117, 332, 7, 55, "Input"],
Cell[36484, 1126, 399, 9, 55, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36920, 1140, 102, 1, 42, "Subsection"],
Cell[37025, 1143, 341, 7, 55, "Input"],
Cell[37369, 1152, 297, 6, 55, "Input"],
Cell[37669, 1160, 311, 7, 55, "Input"],
Cell[37983, 1169, 277, 6, 55, "Input"],
Cell[38263, 1177, 367, 8, 55, "Input"],
Cell[38633, 1187, 357, 7, 55, "Input"],
Cell[38993, 1196, 349, 7, 70, "Input"],
Cell[39345, 1205, 370, 7, 55, "Input"],
Cell[39718, 1214, 347, 7, 55, "Input"],
Cell[40068, 1223, 342, 7, 55, "Input"],
Cell[40413, 1232, 393, 9, 70, "Input"],
Cell[40809, 1243, 371, 8, 55, "Input"],
Cell[41183, 1253, 446, 9, 70, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41666, 1267, 120, 2, 42, "Subsection"],
Cell[41789, 1271, 449, 8, 85, "Input"],
Cell[42241, 1281, 401, 8, 70, "Input"],
Cell[42645, 1291, 479, 9, 70, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43173, 1306, 99, 1, 48, "Section"],
Cell[43275, 1309, 158, 3, 24, "Input"],
Cell[43436, 1314, 194, 4, 45, "Text"],
Cell[CellGroupData[{
Cell[43655, 1322, 98, 1, 42, "Subsection"],
Cell[43756, 1325, 299, 7, 24, "Input"],
Cell[44058, 1334, 294, 7, 24, "Input"],
Cell[44355, 1343, 287, 7, 24, "Input"],
Cell[44645, 1352, 283, 7, 24, "Input"],
Cell[44931, 1361, 348, 8, 24, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45316, 1374, 102, 1, 42, "Subsection"],
Cell[CellGroupData[{
Cell[45443, 1379, 129, 1, 38, "Subsubsection"],
Cell[45575, 1382, 265, 7, 31, "Text"],
Cell[45843, 1391, 521, 12, 24, "Input"],
Cell[46367, 1405, 268, 7, 31, "Text"],
Cell[46638, 1414, 432, 11, 24, "Input"]
}, Open  ]],
Cell[47085, 1428, 3187, 67, 192, "Input"],
Cell[50275, 1497, 2490, 59, 192, "Input"],
Cell[52768, 1558, 249, 5, 40, "Input"],
Cell[53020, 1565, 2118, 51, 162, "Input"],
Cell[55141, 1618, 2162, 51, 162, "Input"],
Cell[57306, 1671, 2475, 57, 192, "Input"],
Cell[59784, 1730, 2251, 53, 162, "Input"],
Cell[62038, 1785, 2526, 56, 162, "Input"],
Cell[64567, 1843, 2198, 52, 177, "Input"],
Cell[66768, 1897, 2594, 62, 192, "Input"],
Cell[69365, 1961, 2967, 68, 190, "Input"],
Cell[72335, 2031, 2606, 63, 205, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74978, 2099, 120, 2, 42, "Subsection"],
Cell[75101, 2103, 1113, 32, 40, "Input"],
Cell[76217, 2137, 1279, 38, 70, "Input"],
Cell[77499, 2177, 579, 13, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78115, 2195, 107, 1, 42, "Subsection"],
Cell[CellGroupData[{
Cell[78247, 2200, 205, 3, 38, "Subsubsection"],
Cell[78455, 2205, 1723, 46, 130, "Text"],
Cell[80181, 2253, 392, 10, 40, "Input"],
Cell[80576, 2265, 3407, 82, 190, "Input"],
Cell[83986, 2349, 2438, 60, 160, "Input"],
Cell[86427, 2411, 777, 20, 85, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[87241, 2436, 164, 2, 38, "Subsubsection"],
Cell[CellGroupData[{
Cell[87430, 2442, 1416, 50, 96, "Text"],
Cell[88849, 2494, 1105, 26, 85, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89991, 2525, 1140, 42, 96, "Text"],
Cell[91134, 2569, 9167, 202, 730, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[100350, 2777, 146, 1, 38, "Subsubsection"],
Cell[CellGroupData[{
Cell[100521, 2782, 1112, 27, 113, "Text"],
Cell[101636, 2811, 1339, 38, 123, "Text"],
Cell[102978, 2851, 663, 23, 70, "Text"],
Cell[103644, 2876, 6318, 153, 385, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109999, 3034, 357, 10, 45, "Text"],
Cell[110359, 3046, 594, 13, 55, "Input"],
Cell[CellGroupData[{
Cell[110978, 3063, 449, 13, 45, "Text"],
Cell[111430, 3078, 433, 9, 45, "Text"],
Cell[111866, 3089, 2718, 67, 175, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114621, 3161, 608, 17, 45, "Text"],
Cell[115232, 3180, 733, 12, 96, "Text"],
Cell[115968, 3194, 2037, 48, 130, "Input"],
Cell[CellGroupData[{
Cell[118030, 3246, 403, 16, 45, "Text"],
Cell[118436, 3264, 483, 16, 45, "Text"],
Cell[118922, 3282, 1325, 34, 100, "Input"],
Cell[120250, 3318, 248, 6, 24, "Input"],
Cell[120501, 3326, 2120, 55, 145, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122658, 3386, 245, 9, 28, "Text"],
Cell[122906, 3397, 503, 14, 24, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[123458, 3417, 431, 14, 45, "Text"],
Cell[123892, 3433, 585, 13, 40, "Input"],
Cell[CellGroupData[{
Cell[124502, 3450, 452, 14, 45, "Text"],
Cell[124957, 3466, 2043, 52, 115, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127037, 3523, 355, 12, 45, "Text"],
Cell[127395, 3537, 565, 16, 40, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[128009, 3559, 378, 14, 45, "Text"],
Cell[128390, 3575, 1334, 30, 115, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129761, 3610, 363, 10, 62, "Text"],
Cell[130127, 3622, 2731, 65, 175, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[132907, 3693, 580, 19, 62, "Text"],
Cell[133490, 3714, 541, 14, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134068, 3733, 244, 7, 45, "Text"],
Cell[134315, 3742, 497, 15, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134849, 3762, 693, 24, 79, "Text"],
Cell[135545, 3788, 1130, 27, 70, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[136714, 3820, 391, 11, 45, "Text"],
Cell[137108, 3833, 1231, 31, 70, "Input"],
Cell[138342, 3866, 136, 3, 24, "Input"]
}, Open  ]],
Cell[138493, 3872, 141, 3, 24, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
