(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     81817,       2430]
NotebookOptionsPosition[     74860,       2218]
NotebookOutlinePosition[     75226,       2234]
CellTagsIndexPosition[     75183,       2231]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "ConvexPolyhedra"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "Functions", " ", "for", " ", "constructing", " ", "convex", " ", 
      "polyhedra", " ", "of", "\[IndentingNewLine]", "          ", 
      "arbitrary", " ", "dimension"}]}]}], ",", " ", 
   RowBox[{"manipulating", " ", "them"}], ",", " ", "\[IndentingNewLine]", 
   "             ", 
   RowBox[{"and", " ", "extracting", " ", "their", " ", 
    RowBox[{"attributes", "."}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", 
     RowBox[{"1.0", ".1"}]}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.453072268537938*^9, 3.453072269833147*^9}, {3.453135992466434*^9, 
  3.4531360000140142`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{
     RowBox[{
     "and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", "Library", 
      "\[IndentingNewLine]", "\t\t   ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"http", ":"}], "//", 
         RowBox[{
          RowBox[{"www", ".", "cs", ".", "unipr", ".", "it"}], "/", "ppl"}]}],
         ")"}], ".", "\[IndentingNewLine]", "          ", "1.0"}], ".1"}], 
     ":", " ", 
     RowBox[{"June", " ", "2009.", " ", "Minor", " ", 
      RowBox[{"changes", "."}]}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}, 
   3.4530723086489983`*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell[CellGroupData[{

Cell["Convex Polyhedra", "Title",
 CellChangeTimes->{{3.398885657616342*^9, 3.398885669806036*^9}, 
   3.399035536291541*^9}],

Cell[CellGroupData[{

Cell["Introductory", "Subtitle",
 CellChangeTimes->{{3.389744082409287*^9, 3.38974408783501*^9}}],

Cell[TextData[{
 "An exposition titled",
 StyleBox[" ",
  FontSlant->"Italic"],
 "\"Some Elementary Theory of Convex Polyhedra\" accompanies this package. "
}], "Text",
 CellChangeTimes->{{3.398986353705883*^9, 3.398986448627446*^9}, 
   3.3989865805688257`*^9}],

Cell[CellGroupData[{

Cell["A Convex Polyhedron", "Subsubtitle",
 CellChangeTimes->{{3.398886605229947*^9, 3.398886632900875*^9}}],

Cell[TextData[{
 "A (closed) convex polyhedron in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 " may be defined in two ways. First, it is the intersection of finitely \
manyclosed halfspaces. (Note that a hyperplane, in particular, is the \
intersection of two closed halfspaces.) Second, it is the convex hull of a \
finite set of points, plus the conical hull of a finite set of rays. It is \
not really obvious that these two definitions are equivalent; the notes \
mentioned above contain a proof.\n\nThis package contains functions for \
constructing a convex polyhedron from either kind of description, or from a \
mixture of the two, and some other simple operations. The generators and the \
constraints may be accessed by various \"attribute\" functions, and tests for \
containment and equality are provided."
}], "Text",
 CellChangeTimes->{{3.3990356198696136`*^9, 3.399035679834299*^9}, {
  3.399035738045285*^9, 3.399035818822783*^9}, {3.399035987848343*^9, 
  3.399036066626396*^9}, {3.399036205938324*^9, 3.399036214651767*^9}, {
  3.39903625312423*^9, 3.399036443130972*^9}, {3.399036727562993*^9, 
  3.3990368633256483`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Attributes", "Subsubtitle",
 CellChangeTimes->{{3.398886667950358*^9, 3.398886670781992*^9}}],

Cell[TextData[{
 "If ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 " is a convex polyhedron in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ", then its ",
 StyleBox["generators",
  FontWeight->"Bold"],
 " are ",
 StyleBox["points,",
  FontWeight->"Bold"],
 " ",
 StyleBox["rays",
  FontWeight->"Bold"],
 ", and ",
 StyleBox["lines",
  FontWeight->"Bold"],
 ". The ",
 StyleBox["descriptor",
  FontWeight->"Bold"],
 " of a point, ray, or line is a ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 "-length List. The ",
 StyleBox["constraints",
  FontWeight->"Bold"],
 " of ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 " are ",
 StyleBox["halfspaces",
  FontWeight->"Bold"],
 " and ",
 StyleBox["hyperplanes",
  FontWeight->"Bold"],
 ". The descriptor of a halfspace or hyperplane is a List of length ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "+", "1"}], TraditionalForm]]],
 ". The list ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["c", "1"], ",", "...", ",", " ", 
     SubscriptBox["c", "d"], ",", " ", 
     SubscriptBox["c", 
      RowBox[{"d", "+", "1"}]]}], "}"}], TraditionalForm]]],
 " used as a descriptor of a halfspace stands for"
}], "Text",
 CellChangeTimes->{{3.399037026447679*^9, 3.3990371621667128`*^9}, {
  3.3990372208847723`*^9, 3.399037552177401*^9}, {3.399037585908202*^9, 
  3.399037605884782*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "\[Element]", 
      SuperscriptBox["\[DoubleStruckCapitalR]", "d"]}], " ", "|", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["c", "1"], 
        SubscriptBox["x", "1"]}], "+", " ", "\[CenterEllipsis]", " ", "+", 
       " ", 
       RowBox[{
        SubscriptBox["c", "d"], 
        SubscriptBox["x", "d"]}], "+", 
       SubscriptBox["c", 
        RowBox[{"d", "+", "1"}]]}], " ", "\[LessEqual]", " ", "0"}]}], " ", 
    "}"}], TraditionalForm]]],
 ","
}], "Text",
 CellChangeTimes->{{3.399037677057035*^9, 3.399037707916267*^9}, {
  3.399037786901059*^9, 3.399037844340641*^9}, {3.399037885789275*^9, 
  3.399037985434649*^9}},
 TextAlignment->Center],

Cell["and if used as a descriptor of a hyperplane stands for", "Text",
 CellChangeTimes->{{3.3990380083541803`*^9, 3.3990380291136303`*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", " ", "\[Element]", 
       SuperscriptBox["\[DoubleStruckCapitalR]", "d"]}], " ", "|", " ", 
      RowBox[{
       RowBox[{
        SubscriptBox["c", "1"], 
        SubscriptBox["x", "1"]}], "+", " ", "\[CenterEllipsis]", " ", "+", 
       " ", 
       RowBox[{
        SubscriptBox["c", "d"], 
        SubscriptBox["x", "d"]}], "+", 
       SubscriptBox["c", 
        RowBox[{"d", "+", "1"}]]}]}], " ", "=", " ", "0"}], " ", "}"}], 
   TraditionalForm]]],
 ","
}], "Text",
 CellChangeTimes->{{3.399037677057035*^9, 3.399037707916267*^9}, {
   3.399037786901059*^9, 3.399037844340641*^9}, {3.399037885789275*^9, 
   3.399037985434649*^9}, 3.399038040455935*^9},
 TextAlignment->Center],

Cell["These attributes are defined:", "Text",
 CellChangeTimes->{{3.399038109142373*^9, 3.3990381216996803`*^9}}],

Cell[TextData[{
 StyleBox["\[Paragraph]",
  FontWeight->"Bold"],
 " ",
 StyleBox["Points",
  FontWeight->"Bold"],
 ": a list of the point generators."
}], "Text",
 CellChangeTimes->{{3.3990381394096537`*^9, 3.399038236687101*^9}}],

Cell[TextData[{
 "\[Paragraph] Rays",
 StyleBox[": a list of the ray generators.",
  FontWeight->"Plain"]
}], "Text",
 CellChangeTimes->{{3.3990382629845867`*^9, 3.399038301465106*^9}},
 FontWeight->"Bold"],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["Lines",
  FontWeight->"Bold"],
 ": a list of the line generators."
}], "Text",
 CellChangeTimes->{{3.3990383957056026`*^9, 3.39903841721245*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["Halfspaces",
  FontWeight->"Bold"],
 ": a list of the halfspace constraints."
}], "Text",
 CellChangeTimes->{{3.399038470860279*^9, 3.399038498215041*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["Hyperplanes",
  FontWeight->"Bold"],
 ": a list of the hyperplane constraints."
}], "Text",
 CellChangeTimes->{
  3.399038505125031*^9, {3.399038611082806*^9, 3.399038626179018*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AmbientDimension: ",
  FontWeight->"Bold"],
 "the dimension ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " of the space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 " in which the polyhedron is defined."
}], "Text",
 CellChangeTimes->{{3.3990388887445927`*^9, 3.399038967810215*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["LinealityDimension",
  FontWeight->"Bold"],
 ": the dimension of the ",
 StyleBox["lineality space",
  FontSlant->"Italic"],
 " of the polyhedron; for a closed convex polyhedron ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 ", this is"
}], "Text",
 CellChangeTimes->{{3.39903899707589*^9, 3.3990390470633507`*^9}, {
  3.3990392091151*^9, 3.39903924795813*^9}}],

Cell[TextData[{
 "lineal",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "P", ")"}], " ", ":=", " ", 
    RowBox[{"{", " ", 
     RowBox[{
      RowBox[{
       StyleBox["y",
        FontWeight->"Bold"], " ", "\[Element]", 
       SuperscriptBox["\[DoubleStruckCapitalR]", "d"]}], " ", "|", " ", 
      RowBox[{
       RowBox[{
        StyleBox["x",
         FontWeight->"Bold"], " ", "+", " ", 
        StyleBox[
         RowBox[{"t", 
          StyleBox["y",
           FontWeight->"Bold"]}]]}], " ", "\[Element]", " ", "P", " "}]}]}]}],
    TraditionalForm]]],
 "for all ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold"], 
       StyleBox[" ",
        FontWeight->"Bold"], 
       StyleBox[
        RowBox[{"\[Element]", " ", "P"}],
        FontWeight->"Plain"]}], 
      StyleBox[",",
       FontWeight->"Plain"], 
      StyleBox[" ",
       FontWeight->"Plain"], 
      RowBox[{
       StyleBox["t",
        FontWeight->"Plain"], 
       StyleBox[" ",
        FontWeight->"Plain"], 
       StyleBox["\[Element]",
        FontWeight->"Plain"], "\[DoubleStruckCapitalR]"}]}], " ", "}"}], " ", 
    ".", 
    StyleBox[" ",
     FontWeight->"Bold"]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.399039263638132*^9, 3.3990395119627943`*^9}},
 TextAlignment->Center],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["SpanDimension",
  FontWeight->"Bold"],
 ": the dimension of the smallest affine subspace containing the polyhedron."
}], "Text",
 CellChangeTimes->{{3.399039567557053*^9, 3.399039631505143*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Optimization", "Subsubtitle",
 CellChangeTimes->{{3.398984853243517*^9, 3.398984857585017*^9}}],

Cell["\<\
\tIn general, many different sets of attributes may define the same cone. \
This package keeps the descriptions optimized in the following ways:
\t1.  If two or more halfspace constraints imply a hyperplane constraint, \
then these halfspace constraints are merged into  the list of hyperplanes. \
Likewise, two or more rays that imply the existence of a line generator are \
merged with the list of lines.
\t2. The hyperplane constraints are linearly independent. Likewise, the line \
generators are linearly independent.
\t3. All redundant halfspace constraints and ray or point generators are \
removed.\
\>", "Text",
 CellChangeTimes->{{3.398984880216825*^9, 3.398984919242486*^9}, {
   3.398985041502904*^9, 3.398985081583918*^9}, {3.398985138170204*^9, 
   3.398985257261743*^9}, {3.3989852884980183`*^9, 3.398985373097127*^9}, {
   3.3989854242600613`*^9, 3.39898547844473*^9}, {3.399044118829006*^9, 
   3.399044125449729*^9}, {3.3990441978533297`*^9, 3.39904421270024*^9}, {
   3.399044325046998*^9, 3.399044330071508*^9}, 3.399045019552514*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors based on simpler parts", "Subsubtitle",
 CellChangeTimes->{{3.39888668509767*^9, 3.398886713951441*^9}}],

Cell[TextData[{
 "\tThese functions can be used to construct convex polyhedra.\n\tTo \
construct a polyhedron with ambient dimension ",
 StyleBox["d",
  FontSlant->"Italic"],
 ", the generators must be of length ",
 StyleBox["d",
  FontSlant->"Italic"],
 " and the descriptors of constraints must be of length ",
 StyleBox["d+1",
  FontSlant->"Italic"],
 ". If these rules are not followed, an error result is returned. It is \
expected that the components of the descriptors are Integer or Rational; \
reasonable behavior is not guaranteed if this rule is not followed."
}], "Text",
 CellChangeTimes->{{3.3990449632878*^9, 3.399045184432807*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["FullSpacePolyhedron",
  FontWeight->"Bold"],
 "\n\tFullSpacePolyhedron[",
 StyleBox["d",
  FontSlant->"Italic"],
 "]\n\tThis function returns a ConvexPolyhedron occupying the entire space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.399044436788398*^9, 3.399044554808827*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["EmptyPolyhedron",
  FontWeight->"Bold"],
 "\n\tEmptyPolyhedron[",
 StyleBox["d",
  FontSlant->"Italic"],
 "]\n\tThis function returns a ConvexPolyhedron denoting the empty set; the \
ambient space is ",
 " ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.399044581509857*^9, 3.3990446590151577`*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["PolyhedronIntersection",
  FontWeight->"Bold"],
 "\n\tPolyhedronIntersection[",
 StyleBox["hyperplanes, halfspaces",
  FontSlant->"Italic"],
 "]\n\tThe arguments ",
 StyleBox["hyperplanes",
  FontSlant->"Italic"],
 " and ",
 StyleBox["halfspaces",
  FontSlant->"Italic"],
 " must be lists of descriptors, at least one list being non-empty. The \
descriptors must all have the same strictly positive length, which will be 1 \
more than the ambient dimension. \n\tThe convex cone defined as the \
intersection of the corresponding hyperplanes and halfspaces is returned. \n\t\
Error result: FullSpacePolyhedron[",
 StyleBox["d",
  FontSlant->"Italic"],
 "], where ",
 StyleBox["d",
  FontSlant->"Italic"],
 " is a best guess at the intended ambient dimension."
}], "Text",
 CellChangeTimes->{{3.399044750872197*^9, 3.399044941401548*^9}, {
   3.399045220410758*^9, 3.39904531167677*^9}, 3.399045670022068*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["PolyhedronHull",
  FontWeight->"Bold"],
 "\n\tPolyhedronHull[",
 StyleBox["lines, rays, points",
  FontSlant->"Italic"],
 "]\n\tThe arguments are lists of descriptors, specifying the lines, rays and \
points which generate the convex cone. ",
 StyleBox["The list ",
  FontWeight->"Bold"],
 StyleBox["points",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 StyleBox[" must be non-empty.",
  FontWeight->"Bold"],
 " The descriptors must all be the same length, which is the ambient \
dimension of the result.\n\tError result: EmptyPolyhedron[",
 StyleBox["d",
  FontSlant->"Italic"],
 "], where ",
 StyleBox["d",
  FontSlant->"Italic"],
 " is a best guess at the ambient dimension."
}], "Text",
 CellChangeTimes->{{3.399045339626626*^9, 3.39904536407036*^9}, {
  3.399045521851021*^9, 3.399045645502743*^9}, {3.399045680923115*^9, 
  3.39904572664922*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors based on a convex polyhedron", "Subsubtitle",
 CellChangeTimes->{{3.398886720018126*^9, 3.398886745114079*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddPointToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddPointToPolyhedron[",
 StyleBox["polyhedron, generator",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron. The second must be a \
descriptor of length equal to the ambient dimension of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ". \n\tThe value returned is a convex polyhedron with the same generators as \
",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " plus the given point generator."
}], "Text",
 CellChangeTimes->{{3.399045776112123*^9, 3.399045984881261*^9}, {
   3.399046017008144*^9, 3.399046051819334*^9}, 3.399046300195447*^9}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddRayToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddRayToPolyhedron[",
 StyleBox["polyhedron, generator",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be a \
descriptor of length equal to the ambient dimension of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ".\n\tThe value returned is a convex polyhedron with the same generators as \
",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " plus the given ray generator."
}], "Text",
 CellChangeTimes->{{3.39904607127639*^9, 3.399046092764237*^9}, {
  3.399046193821608*^9, 3.3990463107389717`*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddLineToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddLineToPolyhedron[",
 StyleBox["polyhedron, generator",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be a \
descriptor of length equal to the ambient dimension of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ".\n\tThe value returned is a convex polyhedron with the same generators as \
",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " plus the given line generator."
}], "Text",
 CellChangeTimes->{{3.39904607127639*^9, 3.399046092764237*^9}, {
  3.399046193821608*^9, 3.3990463107389717`*^9}, {3.399049999402979*^9, 
  3.399050020306444*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddHalfspaceToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddHalfspaceToPolyhedron[",
 StyleBox["polyhedron, constraint",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be a \
descriptor of length equal to 1 + the ambient dimension of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ".\n\tThe value returned is a convex polyhedron with the same constraints as \
",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " plus the given halfspace constraint."
}], "Text",
 CellChangeTimes->{{3.39904607127639*^9, 3.399046092764237*^9}, {
  3.399046193821608*^9, 3.3990463107389717`*^9}, {3.399050047724297*^9, 
  3.399050099660762*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddHyperplaneToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddHyperplaneToPolyhedron[",
 StyleBox["polyhedron, constraint",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be a \
descriptor of length equal to 1 + the ambient dimension of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ".\n\tThe value returned is a convex polyhedron with the same constraints as \
",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " plus the given hyperplane constraint."
}], "Text",
 CellChangeTimes->{{3.39904607127639*^9, 3.399046092764237*^9}, {
  3.399046193821608*^9, 3.3990463107389717`*^9}, {3.399050047724297*^9, 
  3.39905013425388*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddGeneratorsToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddGeneratorsToPolyhedron[",
 StyleBox["polyhedron,lines,rays,points",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron. The others must be \
lists of descriptors; each descriptor must be of length equal to the ambient \
dimension of the polyhedron.\n\tIf the polyhedron is empty, then ",
 StyleBox["points",
  FontSlant->"Italic"],
 " must contain at least one descriptor.\n\tThe value returned is a convex \
polyhedron with the same generators as ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ", plus the given line, ray, and point generators."
}], "Text",
 CellChangeTimes->{{3.399071198116143*^9, 3.3990712472726707`*^9}, {
  3.399071289250073*^9, 3.399071455486888*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["AddConstraintsToPolyhedron",
  FontWeight->"Bold"],
 "\n\tAddConstraintsToPolyhedron[",
 StyleBox["polyhedron, hyperplanes, halfspaces",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron. The second and third \
must be lists of descriptors; each descriptor must be of length 1 + the \
ambient dimension of the polyhedron.\n\tThe value returned is a convex \
polyhedron with the same constraints as ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ", plus the given hyperplane and halfspace constraints."
}], "Text",
 CellChangeTimes->{{3.399071479359407*^9, 3.399071663861165*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Transformations", "Subsubtitle",
 CellChangeTimes->{{3.398886759751186*^9, 3.398886763608922*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["TransformGeneratorsOfPolyhedron",
  FontWeight->"Bold"],
 "\n\tTransformGeneratorsOfPolyhedron[",
 StyleBox["polyhedron, transform, translation",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron. If its ambient \
dimension is ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ", then ",
 StyleBox["transform",
  FontSlant->"Italic"],
 " must be a non-singular ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", " ", "\[Times]", " ", "d"}], TraditionalForm]]],
 " matrix, and ",
 StyleBox["translation",
  FontSlant->"Italic"],
 " must be a descriptor of length ",
 StyleBox["d",
  FontSlant->"Italic"],
 ". \n\tThe result returned is a polyhedron whose generators are the result \
of acting on the line and ray generators of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " with ",
 StyleBox["transform",
  FontSlant->"Italic"],
 ", and on the point generators with the following transformation:"
}], "Text",
 CellChangeTimes->{{3.399073633242058*^9, 3.399073857279728*^9}, {
  3.399073917413731*^9, 3.399074038565153*^9}}],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{"x", " ", "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     StyleBox["transform",
      FontWeight->"Plain"], 
     StyleBox[" ",
      FontWeight->"Plain"], "x"}], 
    StyleBox[" ",
     FontWeight->"Plain"], 
    StyleBox["+",
     FontWeight->"Plain"], 
    StyleBox[" ",
     FontWeight->"Plain"], 
    StyleBox["translation",
     FontWeight->"Plain",
     FontSlant->"Italic"]}]}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.399074077020906*^9, 3.399074080046125*^9}, {
  3.399074197976531*^9, 3.399074266811076*^9}},
 TextAlignment->Center,
 FontWeight->"Bold"],

Cell[TextData[{
 " \tError result: ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " unchanged."
}], "Text",
 CellChangeTimes->{{3.399074337371866*^9, 3.399074354286592*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["ProjectPolyhedronAlongAxis",
  FontWeight->"Bold"],
 ":\n\tProjectPolyhedronAlongAxis[",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ", ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be an \
integer in the range from ",
 Cell[BoxData[
  FormBox["1", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is the ambient dimension of the polyhedron.\n\tThe value returned is a \
polyhedron of dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 ", the result of projecting the given cone along the specified axis, and \
removing the ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "-th component from all vectors.\n\t\n\tError result: a polyhedron with no \
constraints, and dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.389898125661627*^9, 3.389898153770748*^9}, {
  3.389898186988223*^9, 3.389898188622521*^9}, {3.389898234869429*^9, 
  3.389898366841839*^9}, {3.389898473032501*^9, 3.389898617974494*^9}, {
  3.389911442611115*^9, 3.389911473761935*^9}, {3.399074369477768*^9, 
  3.399074400712845*^9}, {3.399074581806007*^9, 3.399074647360449*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["IntersectPolyhedronWithHyperplane",
  FontWeight->"Bold"],
 ":\n\tIntersectPolyhedronWithHyperplane[",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ", ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be an \
integer in the range from ",
 Cell[BoxData[
  FormBox["1", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is the ambient dimension of the polyhedron.\n\tThe value returned is a \
polyhedron of dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 ", the intersection with the hyperplane on which the ",
 StyleBox["axis",
  FontSlant->"Italic"],
 "-th component is 0.  This component is removed from all vectors.\n\t\n\t\
Error result: a polyhedron with no generators, and dimension ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "-", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.389898735044035*^9, 3.389898917051111*^9}, {
  3.389911494284849*^9, 3.389911508954722*^9}, {3.397515624759365*^9, 
  3.397515638282683*^9}, {3.399074473484407*^9, 3.399074474795923*^9}, {
  3.399074690790894*^9, 3.3990747888930902`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsubtitle",
 CellChangeTimes->{{3.398886780471662*^9, 3.398886781921465*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["PolyhedronContainsPoint",
  FontWeight->"Bold"],
 "\n\tPolyhedronContainsPoint[",
 StyleBox["polyhedron,point",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be a \
vector, of length equal to the ambient dimension of the polyhedron.\n\tReturn \
True if ",
 StyleBox["point",
  FontSlant->"Italic"],
 " is contained in ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ", False otherwise."
}], "Text",
 CellChangeTimes->{{3.3991300639541807`*^9, 3.399130225777854*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["PolyhedronContainsRay",
  FontWeight->"Bold"],
 "\n\tPolyhedronContainsRay[",
 StyleBox["polyhedron, ray",
  FontSlant->"Italic"],
 "]\n\tThe first argument must be a convex polyhedron.  The second must be a \
vector, of length equal to the ambient dimenson of the polyhedton.\n\tReturn \
True if a ray parallel to ",
 StyleBox["ray",
  FontSlant->"Italic"],
 " issuing from any point of ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 " is contained in ",
 StyleBox["polyhedron",
  FontSlant->"Italic"],
 ", False otherwise."
}], "Text",
 CellChangeTimes->{{3.399130237061158*^9, 3.399130380038745*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["SubPolyhedron",
  FontWeight->"Bold"],
 "\n\tSubPolyhedron[",
 StyleBox["polyhedron1, polyhedron2",
  FontSlant->"Italic"],
 "]\n\tThe two arguments must be convex polyhedra of equal ambient dimension \
",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ".\n\tReturn True if (as sets of points in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ") ",
 StyleBox["polyhedron1",
  FontSlant->"Italic"],
 " is a subset of ",
 StyleBox["polyhedron2",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.399130523331534*^9, 3.399130662298833*^9}, {
  3.399130763102909*^9, 3.399130797265066*^9}}],

Cell[TextData[{
 "\[Paragraph] ",
 StyleBox["EqualPolyhedron",
  FontWeight->"Bold"],
 "\n\tEqualPolyhedron[",
 StyleBox["polyhedron1, polyhedron2",
  FontSlant->"Italic"],
 "]\n\tThe two arguments must be convex polyhedra of equal ambient dimension \
",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ".\n\tReturn True if (as sets of points in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 ") ",
 StyleBox["polyhedron1",
  FontSlant->"Italic"],
 " is equal to ",
 StyleBox["polyhedron2",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.399130676320219*^9, 3.399130681080402*^9}, {
  3.399130717353263*^9, 3.399130885674439*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package ", "Subtitle",
 CellChangeTimes->{{3.3897441099085817`*^9, 3.3897441262903833`*^9}, 
   3.390088763935296*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<Convex`ConvexPolyhedra`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<Global`\>\"", ",", "\"\<Convex`ConvexCones`\>\""}], "}"}]}],
    "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.398885066526297*^9, 3.398885136866289*^9}, 
   3.3990355447045794`*^9}],

Cell[CellGroupData[{

Cell["Declarations: Usage specifications", "Section",
 CellChangeTimes->{{3.389744148052143*^9, 3.389744155475335*^9}, {
  3.3900888102627993`*^9, 3.390088814224888*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConvexPolyhedron", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<ConvexPolyhedron is the head of an expression denoting a closed \
convex polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.398886441908154*^9, 3.3988865004944677`*^9}, {
  3.399131066828603*^9, 3.399131069018262*^9}}],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 CellChangeTimes->{{3.398886667950358*^9, 3.398886670781992*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Points", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Points[polyhedron] returns the list of vectors specifying point \
generators of the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991312573085938`*^9, 3.399131324659477*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rays", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Rays[polyhedron] returns the list of vectors specifying ray \
generators of the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399131335531682*^9, 3.399131379982793*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lines", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Lines[polyhedron] returns the list of vectors specifying line \
generators of the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991313935353527`*^9, 3.399131434970603*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Halfspaces", "::", "usage"}], " ", "=", "\[IndentingNewLine]", 
   "\"\<Halfspaces[polyhedron] returns the list of descriptors specifying \
halfspace constraints on the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991314745519753`*^9, 3.399131517808806*^9}, {
  3.399131589731904*^9, 3.399131592347447*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hyperplanes", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Hyperplanes[polyhedron] returns the list of descriptors specifying \
hyperplane constraints on the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991315528452578`*^9, 3.399131618303837*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AmbientDimension", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<AmbientDimension[polyhedron] returns the dimension of the vector \
space in which polyhedron is situated.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399131635042652*^9, 3.399131705151162*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LinealityDimension", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<LinealityDimension[polyhedron] returns the dimension of the lineality \
space of the polyhedron; this is the dimension of a maximal affine subspace \
that is contained in the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399131744676363*^9, 3.399131825299472*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpanDimension", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<SpanDimension[polyhedron] returns the dimension of the smallest \
affine subspace containing the polyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399131841237544*^9, 3.39913187885992*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors based on simpler parts", "Subsection",
 CellChangeTimes->{{3.39888668509767*^9, 3.398886713951441*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FullSpacePolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<FullSpacePolyhedron[d] returns a ConvexPolyhedron occupying the \
entire d-dimensional vector space.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399135888187015*^9, 3.399135947037264*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EmptyPolyhedron", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<emptyPolyhedron[d] returns a ConvexPolyhedron which is empty, \
understood to be contained in d-dimensional vector space.\>\""}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.3991359560146933`*^9, 3.39913601198701*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronIntersection", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<PolyhedronIntersection[hyperplanes, halfspaces] constructs a \
ConvexPolyhedron defined by the given constraints.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399136023482242*^9, 3.399136091935318*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronHull", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<PolyhedronHull[lines, rays, points] constructs a ConvexPolyhedron \
defined by the given generators.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399136104705035*^9, 3.399136153226804*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors based on a convex polyhedron", "Subsection",
 CellChangeTimes->{{3.398886720018126*^9, 3.398886745114079*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddPointToPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddPointToPolyhedron[polyhedron, generator] interprets 'generator' as \
a point, and constructs a new ConvexPolyhedron from the old one by adding the \
new point.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399136256005876*^9, 3.399136338373816*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddRayToPolyhedron", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<AddRayToPolyhedron[polyhedron, generator] interprets 'generator' as a \
ray, and constructs a new ConvexPolyhedron from the given one by adding the \
new ray.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.39913635142058*^9, 3.399136423154723*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddLineToPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddLineToPolyhedron[polyhedron, genrator] interprets 'generator' as a \
line, and constructs a new ConvexPolyhedron from the given one by ading the \
new line.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399136441487247*^9, 3.399136510480484*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHalfspaceToPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddHalfspaceToPolyhedron[polyhedron, constraint] interprets \
'constraint' as the descriptor of a halfspace, and returns a new \
ConvexPolyhedron which represents the intersection of the given polyhedron \
with the halfspace.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.39913688436206*^9, 3.3991369711806583`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHyperplaneToPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddHyperplaneToPolyhedron[polyhedron, constraint' interprets \
'constraint' as the descriptor of a hyperplane, and returns a new \
ConvexPolyhedron which represents the intersection of the given polyhedron \
with the hyperplane.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991369890917673`*^9, 3.399137089561805*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddGeneratorsToPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddGeneratorsToPolyhedron[polyhedron, lines, rays, points] returns a \
new ConvexPolyhedron constructed from the given oneby adding the generators \
listed as 'lines,' 'rays,' and 'points.'\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991394125471992`*^9, 3.399139454321796*^9}, {
  3.399139502946566*^9, 3.399139593964253*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddConstraintsToPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<AddConstraintsToPolyhedron[polyhedron, hyperplanes, halfspaces] \
returns a new ConvexPolyhedron constructed from the given one by imposing the \
constraints listed as 'halfspaces' and 'hyperplanes.'\>\""}], ";"}]], "Input",\

 CellChangeTimes->{{3.399139655538031*^9, 3.399139756069992*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Transformations", "Subsection",
 CellChangeTimes->{{3.398886759751186*^9, 3.398886763608922*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformGeneratorsOfPolyhedron", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<TransformGeneratorsOfPolyhedron[polyhedron, transform, translation] \
transforms the generators of 'polyhedron' to return a new ConvexPolyhedron.  \
The line and ray generators are acted on by the linear transformation \
'transform'. The point generators are acted on by an affine transformation - \
'transform' followed by the adding of 'translation'.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991401242998466`*^9, 3.399140199310567*^9}, {
  3.399140235711768*^9, 3.399140341550267*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectPolyhedronAlongAxis", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<ProjectPolyhedronAlongAxis[polyhedron,axis] returns a new \
ConvexPolyhedron constructed from the given one by projecting along the given \
'axis.' The component indexed by 'axis' is dropped from the \
descriptors.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991404165075693`*^9, 3.3991404881521177`*^9}, {
  3.399140568635235*^9, 3.399140582736527*^9}, {3.399140764965089*^9, 
  3.399140801242509*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IntersectPolyhedronWithHyperplane", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<IntersectPolyhedronWithHyperplane[polyhedron, axis] constructs a new \
ConvexPolyhedron from the given one by intersecting it with the hyperplane on \
which the component of index 'axis' is 0. This component is dropped from the \
descriptors.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.39914090293041*^9, 3.399141011154385*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.398886780471662*^9, 3.398886781921465*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronContainsPoint", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<PolyhedronContainsPoint[polyhedron, point] returns True iff the given \
'point' is contained in the given ConvexPolyhedron.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991412107164373`*^9, 3.399141249594739*^9}, {
   3.399141328861705*^9, 3.399141357737638*^9}, 3.399141450853161*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronContainsRay", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<PolyhedronContainsRay[polyhedron,ray] returns True iff a ray with the \
given direction, issuing from an arbitrary point in the given \
ConvexPolyhedron, is contained in it.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.3991413686042013`*^9, 3.399141390823243*^9}, {
  3.399141437792877*^9, 3.399141504695613*^9}, {3.3991415460536127`*^9, 
  3.399141558988282*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SubPolyhedron", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<SubPolyhedron[polyhedron1, polyhedron2] compares two convex polyhedra \
as point sets, and returns True iff the first is a subset of the \
second.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399141572713813*^9, 3.399141629165473*^9}, 
   3.399142793601349*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EqualPolyhedron", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<EqualPolyhedron[polyhedron1,polyhedron2] compares to convex polyhedra \
as point sets, and returns True iff they are equal.\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.399142250377699*^9, 3.399142255971356*^9}, {
  3.399142764347774*^9, 3.399142821170805*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation", "Section",
 CellChangeTimes->{{3.389744184717228*^9, 3.389744188636415*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.389743766322904*^9, 3.389743790154894*^9}}],

Cell[TextData[{
 "\tAn expression representing a convex polyhedron ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " is of the form ConvexPolyhedron[cone], where 'cone' represents a convex \
cone ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 ". Here, ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 " is the \"closed cone over ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 "\" as described in the accompanying Notes.\n\tThe ambient space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", "d"], TraditionalForm]]],
 " of ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]]],
 " will sometimes be called \"lower\" space, and the ambient space ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[DoubleStruckCapitalR]", 
    RowBox[{"d", "+", "1"}]], TraditionalForm]]],
 "of ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 " will, analogously, be called \"upper\" space.  (This is a purely local \
usage, and I would love to be able to think of a better one.)"
}], "Text",
 CellChangeTimes->{{3.3991431147454567`*^9, 3.39914316855132*^9}, {
  3.399143249473819*^9, 3.39914325233622*^9}, {3.399143306794291*^9, 
  3.399143413661536*^9}, {3.399149229445668*^9, 3.399149237612927*^9}, {
  3.399149440056168*^9, 3.399149605068305*^9}}],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 CellChangeTimes->{{3.398886667950358*^9, 3.398886670781992*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Points", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"coneRays", "=", 
       RowBox[{"Rays", "@", "k"}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"finiteRays", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"coneRays", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Last", "[", "#1", "]"}], ">", "0"}], ")"}], "&"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"ToLowerSpace", "/@", "finiteRays"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399147411471284*^9, 3.3991474506193047`*^9}, 
   3.399147657067645*^9, {3.399148274155068*^9, 3.3991483498815737`*^9}, {
   3.399148391091346*^9, 3.399148447062223*^9}, {3.399148492677868*^9, 
   3.3991485006617317`*^9}, {3.399148537461122*^9, 3.39914855397069*^9}, {
   3.3991487600568523`*^9, 3.399148763034409*^9}, {3.399148802874691*^9, 
   3.399148816605219*^9}, {3.3991488713078814`*^9, 3.399148880882724*^9}, {
   3.3991499301268263`*^9, 3.399149934511587*^9}, 3.399150016066868*^9, {
   3.39915046631081*^9, 3.399150471073242*^9}, {3.39920495487752*^9, 
   3.399204956797256*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rays", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"coneRays", "=", 
       RowBox[{"Rays", "@", "k"}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"infiniteRays", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"coneRays", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Last", "[", "#1", "]"}], "==", "0"}], ")"}], "&"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"Truncate", "/@", "infiniteRays"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399147468014551*^9, 3.399147471026164*^9}, 
   3.3991475266639338`*^9, 3.399147657107903*^9, {3.399150038595483*^9, 
   3.399150148021702*^9}, {3.39915018411299*^9, 3.399150217953499*^9}, {
   3.399150307580606*^9, 3.399150314141564*^9}, {3.3991504802390633`*^9, 
   3.39915048387318*^9}, {3.399207168345634*^9, 3.399207170199836*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Lines", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"coneLines", " ", "=", " ", 
       RowBox[{"Lines", "@", "k"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#1", ",", 
          RowBox[{"-", "1"}]}], "]"}], "&"}], ")"}], "/@", "coneLines"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399147537918681*^9, 3.399147544297366*^9}, 
   3.399147657134952*^9, {3.399150376593615*^9, 3.399150416003311*^9}, {
   3.399150452505981*^9, 3.399150458837151*^9}, {3.399150511735368*^9, 
   3.3991505368915167`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Halfspaces", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"Halfspaces", "[", "k", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399147553546011*^9, 3.39914755663472*^9}, 
   3.399147626836452*^9, 3.3991476571622562`*^9, {3.39917046691599*^9, 
   3.399170472371381*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Hyperplanes", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"Hyperplanes", "[", "k", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399147566391326*^9, 3.399147572002976*^9}, 
   3.399147657187846*^9, {3.399170488348421*^9, 3.3991704935481977`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AmbientDimension", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"AmbientDimension", "[", "k", "]"}], "-", "1"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.399147581230054*^9, 3.399147586059243*^9}, 
   3.399147657214549*^9, {3.3991705072296658`*^9, 3.399170512820929*^9}, {
   3.3994139875893717`*^9, 3.399413988466812*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LinealityDimension", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"Length", "@", 
    RowBox[{"Lines", "@", "k"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399147592053618*^9, 3.399147597131838*^9}, 
   3.399147657241941*^9, {3.399170535942005*^9, 3.39917054225356*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpanDimension", "[", 
    RowBox[{"ConvexPolyhedron", "[", "k_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"AmbientDimension", "@", "k"}], "-", 
    RowBox[{"Length", "@", 
     RowBox[{"Hyperplanes", "@", "k"}]}], "-", "1"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39914760649835*^9, 3.3991476137717943`*^9}, 
   3.3991476572683992`*^9, {3.3991705649509363`*^9, 3.399170588314411*^9}, {
   3.399414051683476*^9, 3.399414052037663*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors based on simpler parts", "Subsection",
 CellChangeTimes->{{3.39888668509767*^9, 3.398886713951441*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FullSpacePolyhedron", "[", "d_", "]"}], " ", ":=", " ", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"ConeIntersection", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"-", 
        RowBox[{"UnitVector", "[", 
         RowBox[{
          RowBox[{"d", "+", "1"}], ",", 
          RowBox[{"d", "+", "1"}]}], "]"}]}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399204716942102*^9, 3.399204768746707*^9}, {
  3.399204807706388*^9, 3.399204879479623*^9}, {3.3992050838861303`*^9, 
  3.39920511534382*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EmptyPolyhedron", "[", "d_", "]"}], " ", ":=", " ", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"ZeroCone", "[", 
     RowBox[{"d", "+", "1"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3992051421749563`*^9, 3.3992051765518713`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronIntersection", "[", 
    RowBox[{"hyperplanes_", ",", "halfspaces_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"d1", "=", 
         RowBox[{"DimVet", "[", 
          RowBox[{"hyperplanes", ",", "halfspaces"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ConvexPolyhedron", "[", 
        RowBox[{"ConeIntersection", "[", 
         RowBox[{"hyperplanes", ",", 
          RowBox[{"Join", "[", 
           RowBox[{"halfspaces", ",", 
            RowBox[{"{", 
             RowBox[{"-", 
              RowBox[{"UnitVector", "[", 
               RowBox[{"d1", ",", "d1"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{
     "notLists", " ", "|", " ", "emptyArgs", " ", "|", " ", "notUniform"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FullSpacePolyhedron", "[", 
       RowBox[{"#1", "-", "1"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399205478889409*^9, 3.3992055094331837`*^9}, {
  3.3992057767193727`*^9, 3.3992061265974207`*^9}, {3.399481646962778*^9, 
  3.399481647758814*^9}, {3.39948254807049*^9, 3.3994825973264017`*^9}, {
  3.3995002620313873`*^9, 3.39950030747407*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronHull", "[", 
    RowBox[{"lines_", ",", "rays_", ",", "points_"}], "]"}], ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"d", "=", 
         RowBox[{"DimVet", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", "points"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"d", ",", "lines", ",", "rays"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ConvexPolyhedron", "[", 
         RowBox[{"ConicalHull", "[", 
          RowBox[{
           RowBox[{"ToUpperSpace0", "/@", "lines"}], ",", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"ToUpperSpace0", "/@", "rays"}], ",", 
             RowBox[{"ToUpperSpace", "/@", "points"}]}], "]"}]}], "]"}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{
     "notLists", "|", "emptyArgs", "|", "notUniform", "|", "wrongDimension"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"EmptyPolyhedron", "[", "#1", "]"}], "&"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399206190514224*^9, 3.3992062308875*^9}, {
  3.399206377645361*^9, 3.399206583247064*^9}, {3.399206622822057*^9, 
  3.399206657370367*^9}, {3.399206720169444*^9, 3.399206734174541*^9}, {
  3.399206774503408*^9, 3.399206806904628*^9}, {3.399207529077579*^9, 
  3.399207538720649*^9}, {3.399207568840891*^9, 3.399207647997265*^9}, {
  3.3994835133202057`*^9, 3.399483522268909*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors based on a convex polyhedron", "Subsection",
 CellChangeTimes->{{3.398886720018126*^9, 3.398886745114079*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddPointToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "generator_"}], 
    "]"}], ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddRayToCone", "[", 
     RowBox[{"cone", ",", 
      RowBox[{"ToUpperSpace", "@", "generator"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399207805940741*^9, 3.39920787941997*^9}, {
  3.399207914961074*^9, 3.3992079620383387`*^9}, {3.399585179519435*^9, 
  3.399585186748361*^9}, {3.3995860926106*^9, 3.399586101249744*^9}, {
  3.399587814980773*^9, 3.399587915629147*^9}, {3.399589407748744*^9, 
  3.399589412437437*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddRayToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "generator_"}], 
    "]"}], ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddRayToCone", "[", 
     RowBox[{"cone", ",", 
      RowBox[{"ToUpperSpace0", "@", "generator"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399207805940741*^9, 3.39920787941997*^9}, {
  3.399207914961074*^9, 3.3992079620383387`*^9}, {3.3992080110056763`*^9, 
  3.399208023880348*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddLineToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "generator_"}], 
    "]"}], ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddLineToCone", "[", 
     RowBox[{"cone", ",", 
      RowBox[{"ToUpperSpace0", "@", "generator"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399207805940741*^9, 3.39920787941997*^9}, {
  3.399207914961074*^9, 3.3992079620383387`*^9}, {3.399208073943084*^9, 
  3.399208095626647*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHalfspaceToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "generator_"}], 
    "]"}], ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddHalfspaceToCone", "[", 
     RowBox[{"cone", ",", "generator"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399207805940741*^9, 3.39920787941997*^9}, {
  3.399207914961074*^9, 3.3992079620383387`*^9}, {3.399208174433936*^9, 
  3.399208209710298*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddHyperplaneToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "generator_"}], 
    "]"}], ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddHyperplaneToCone", "[", 
     RowBox[{"cone", ",", "generator"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399207805940741*^9, 3.39920787941997*^9}, {
  3.399207914961074*^9, 3.3992079620383387`*^9}, {3.399208174433936*^9, 
  3.399208209710298*^9}, {3.3992082402940197`*^9, 3.399208256494565*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddGeneratorsToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "lines_", ",", 
     "rays_", ",", "points_"}], "]"}], ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddGeneratorGroupToCone", "[", 
     RowBox[{"cone", ",", 
      RowBox[{"ToUpperSpace0", "/@", "lines"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"ToUpperSpace0", "/@", "rays"}], ",", 
        RowBox[{"ToUpperSpace", "/@", "points"}]}], "]"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.3992082976095037`*^9, 3.399208358053279*^9}, {
  3.399208393552545*^9, 3.399208504385639*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AddConstraintsToPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "hyperplanes_", 
     ",", "halfspaces_"}], "]"}], ":=", "  ", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"AddConstraintGroupToCone", "[", 
     RowBox[{"cone", ",", "hyperplanes", ",", "halfspaces"}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399208557146451*^9, 3.399208634857649*^9}, {
  3.3992086743639183`*^9, 3.39920869246819*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Transformations", "Subsection",
 CellChangeTimes->{{3.398886759751186*^9, 3.398886763608922*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformGeneratorsOfPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "transform_", ",", 
     "translation_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"uT1", "=", 
       RowBox[{"ToUpperSpace0", "/@", 
        RowBox[{"(", 
         RowBox[{"Transpose", "@", "transform"}], ")"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"uT0", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"uT1", ",", 
           RowBox[{"{", 
            RowBox[{"ToUpperSpace", "@", "translation"}], "}"}]}], "]"}]}], 
        "}"}], ",", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"upperTrans", "=", 
           RowBox[{"Transpose", "@", "uT0"}]}], "}"}], ",", 
         RowBox[{"ConvexPolyhedron", "[", 
          RowBox[{"TransformGeneratorsOfCone", "[", 
           RowBox[{"cone", ",", "upperTrans"}], "]"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399238892698155*^9, 3.399239028263208*^9}, {
  3.399239190755588*^9, 3.3992392324875317`*^9}, {3.39923927814634*^9, 
  3.399239388488174*^9}, {3.399239426024088*^9, 3.399239469688057*^9}, {
  3.399240288512281*^9, 3.399240289898479*^9}, {3.399640366507557*^9, 
  3.399640372339773*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectPolyhedronAlongAxis", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "axis_"}], "]"}], 
   " ", ":=", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"ProjectConeAlongAxis", "[", 
     RowBox[{"cone", ",", "axis"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399239557043377*^9, 3.399239587990202*^9}, {
  3.399239690374919*^9, 3.39923972077837*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IntersectPolyhedronWithHyperplane", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "axis_"}], "]"}], ":=",
    " ", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"IntersectConeWithHyperplane", "[", 
     RowBox[{"cone", ",", "axis"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3992397311809673`*^9, 3.39923979552864*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.398886780471662*^9, 3.398886781921465*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronContainsPoint", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "point_"}], "]"}], 
   ":=", 
   RowBox[{"ConeContains", "[", 
    RowBox[{"cone", ",", 
     RowBox[{"ToUpperSpace", "@", "point"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399239901341386*^9, 3.399239979839994*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolyhedronContainsRay", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone_", "]"}], ",", "ray_"}], "]"}], ":=",
    " ", 
   RowBox[{"ConeContains", "[", 
    RowBox[{"cone", ",", 
     RowBox[{"ToUpperSpace0", "@", "ray"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399239994984715*^9, 3.399240067124195*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SubPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone1_", "]"}], ",", 
     RowBox[{"ConvexPolyhedron", "[", "cone2_", "]"}]}], "]"}], ":=", 
   RowBox[{"SubCone", "[", 
    RowBox[{"cone1", ",", "cone2"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399240075127606*^9, 3.3992401227664537`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EqualPolyhedron", "[", 
    RowBox[{
     RowBox[{"ConvexPolyhedron", "[", "cone1_", "]"}], ",", 
     RowBox[{"ConvexPolyhedron", "[", "cone2_", "]"}]}], "]"}], ":=", 
   RowBox[{"EqualCone", "[", 
    RowBox[{"cone1", ",", "cone2"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399240172675832*^9, 3.3992402183476954`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Internal operations", "Subsection",
 CellChangeTimes->{{3.399148919551894*^9, 3.399148926318123*^9}}],

Cell[CellGroupData[{

Cell["Checking of arguments to public functions for reasonability", \
"Subsubsection",
 CellChangeTimes->{{3.390174921151582*^9, 3.3901749279906797`*^9}, {
  3.391532155060244*^9, 3.3915321753884897`*^9}}],

Cell[TextData[{
 "\tDimVet[",
 StyleBox["list_1, list_2",
  FontSlant->"Italic"],
 "] checks that ",
 StyleBox["list_1",
  FontSlant->"Italic"],
 " and ",
 StyleBox["list_2 ",
  FontSlant->"Italic"],
 "are both lists, that one of them is non-empty, that their elements are all \
lists, and that all the latter lists have the same length ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 ". It returns either ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " or a best guess at what ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " should be. If one of the checked requirements is violated, it makes a \
Throw with one of the tags notLists, emptyArgs, notUniform.\n\tDimVet[",
 StyleBox["d,list_1,list_2",
  FontSlant->"Italic"],
 "] checks that the second and third arguments are lists, and their members \
are lists of length ",
 StyleBox["d",
  FontSlant->"Italic"],
 ". It returns Null.\n\tDimVetOne[",
 StyleBox["d, descriptor",
  FontSlant->"Italic"],
 "] checks that ",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 " is a list of length ",
 StyleBox["d",
  FontSlant->"Italic"],
 ". It returns Null."
}], "Text",
 CellChangeTimes->{{3.390068443882251*^9, 3.3900685813907957`*^9}, 
   3.390084211091758*^9, {3.390084677320794*^9, 3.390084703647904*^9}, {
   3.390084739735112*^9, 3.390084749953596*^9}, {3.390085411394074*^9, 
   3.3900854438158503`*^9}, {3.390085854566203*^9, 3.390085862076255*^9}, {
   3.390085902821801*^9, 3.390085944111019*^9}, {3.390174183211465*^9, 
   3.3901742682004023`*^9}, {3.390174482819024*^9, 3.390174541873446*^9}, {
   3.391532192836898*^9, 3.391532223076886*^9}, {3.3915322855655527`*^9, 
   3.391532299862508*^9}, {3.397683004100338*^9, 3.397683007795288*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "notLists", ",", "emptyArgs", ",", "notUniform", ",", "wrongDimension", 
     ",", "singular"}], "}"}], ";"}], " ", 
  RowBox[{"(*", "Tags", "*)"}]}]], "Input",
 CellChangeTimes->{{3.390085952040777*^9, 3.390085978483706*^9}, {
  3.390174273286087*^9, 3.390174277572845*^9}, {3.39768344588561*^9, 
  3.397683448140524*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"3", ",", "emptyArgs"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"arg1_List", ",", " ", "arg2_List"}], "]"}], " ", ":=", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"allarg", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"arg1", ",", "arg2"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"And", "@@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"#1", ",", "_List"}], "]"}], "&"}], "/@", "allarg"}], 
         ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"All", " ", "members", " ", "are", " ", 
         RowBox[{"lists", ".", " ", "Should"}], " ", "be", " ", "of", " ", 
         "uniform", " ", "length"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"d", "=", 
           RowBox[{"Length", "@", 
            RowBox[{"First", "@", "allarg"}]}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Length", "@", "#1"}], " ", "==", " ", "d"}], ")"}], 
               "&"}], "/@", "allarg"}], ")"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"all", "'"}], "s", " ", "well"}], " ", "*)"}], "d", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Throw", "[", 
            RowBox[{"d", ",", "notUniform"}], "]"}]}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Eheu", "!"}], " ", "They", " ", 
         RowBox[{"aren", "'"}], "t", " ", "all", " ", 
         RowBox[{"Lists", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Throw", "[", 
        RowBox[{"2", ",", "notLists"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"arg1_", ",", "arg2_"}], "]"}], " ", ":=", 
   RowBox[{"Throw", "[", 
    RowBox[{"3", ",", "notLists"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.3900847597805767`*^9, 3.3900848439664087`*^9}, {
  3.390086151675681*^9, 3.390086155826805*^9}, {3.390086267382065*^9, 
  3.390086289328608*^9}, {3.391445282642131*^9, 3.39144533202842*^9}, {
  3.3914455745690937`*^9, 3.3914455884618*^9}, {3.3914456787752028`*^9, 
  3.391445730162347*^9}, {3.391445838507379*^9, 3.391445869513689*^9}, {
  3.39144605075709*^9, 3.391446067999161*^9}, {3.391446112147382*^9, 
  3.391446114705358*^9}, {3.391446154057263*^9, 3.391446193517194*^9}, {
  3.391446261861068*^9, 3.3914464403759937`*^9}, {3.391446486826127*^9, 
  3.391446487625454*^9}, {3.391446522740547*^9, 3.3914465684217377`*^9}, {
  3.391446598576583*^9, 3.391446611343994*^9}, {3.3914466446096067`*^9, 
  3.391446698180282*^9}, {3.3914467348227167`*^9, 3.3914467834158783`*^9}, {
  3.391446824953211*^9, 3.391446887645184*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"d_", ",", "arg1_List", ",", "arg2_List"}], "]"}], " ", ":=", " ",
    
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"allarg", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"arg1", ",", "arg2"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"And", "@@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"#1", ",", "_List"}], "]"}], "&"}], "/@", "allarg"}], 
         ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"All", " ", "members", " ", "are", " ", 
         RowBox[{"lists", ".", " ", "Should"}], " ", "be", " ", "of", " ", 
         "length", " ", 
         RowBox[{"d", "."}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"And", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Length", "@", "#1"}], " ", "==", " ", "d"}], ")"}], 
             "&"}], "/@", "allarg"}], ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"all", "'"}], "s", " ", "well"}], " ", "*)"}], "Null", ",",
          "\[IndentingNewLine]", 
         RowBox[{"Throw", "[", 
          RowBox[{"Null", ",", "notUniform"}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "They", " ", "are", " ", "not", " ", "all", " ", "of", " ", "the", 
         " ", "right", " ", "length"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Throw", "[", 
        RowBox[{"Null", ",", "notLists"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVet", "[", 
    RowBox[{"d_", ",", "arg1_", ",", "arg2_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Throw", "[", 
    RowBox[{"Null", ",", "notLists"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.390174293317677*^9, 3.390174350346488*^9}, {
   3.391446969351996*^9, 3.391447257180739*^9}, {3.3914473075815887`*^9, 
   3.391447356898931*^9}, {3.397682950183243*^9, 3.397682983694549*^9}, {
   3.397683485507707*^9, 3.397683487926085*^9}, 3.397683990325214*^9, {
   3.397684736730756*^9, 3.397684764066865*^9}, 3.4530723957856894`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DimVetOne", "[", 
    RowBox[{"d_", ",", " ", "desc_List"}], "]"}], " ", ":=", " ", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "desc", "]"}], "==", "d"}], ",", 
     "\[IndentingNewLine]", "Null", ",", "\[IndentingNewLine]", 
     RowBox[{"Throw", "[", 
      RowBox[{"Null", ",", "wrongDimension"}], "]"}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DimVetOne", "[", 
    RowBox[{"d_", ",", "desc_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Throw", "[", 
    RowBox[{"Null", ",", "notLists"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.391532310161154*^9, 3.391532332447928*^9}, {
  3.391639521275732*^9, 3.39163966636082*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \t",
 StyleBox["ToLowerSpace",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 "[",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "] assumes that ",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 " is a vector in the \"upper\" space. It finds the vector ",
 StyleBox["v",
  FontWeight->"Bold"],
 " in \"lower\" space such that the line through ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"\[Iota]", 
     StyleBox["v",
      FontWeight->"Bold",
      FontSlant->"Plain"]}]], TraditionalForm]]],
 " passes through ",
 StyleBox["descriptor.",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.39914912939452*^9, 3.3991491815740643`*^9}, {
   3.399149622814983*^9, 3.399149769221429*^9}, 3.399204932805255*^9, 
   3.399206916165056*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToLowerSpace", "[", "desc_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Drop", "[", 
     RowBox[{"desc", ",", 
      RowBox[{"-", "1"}]}], "]"}], "/", 
    RowBox[{"Last", "[", "desc", "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399149790904655*^9, 3.399149806358962*^9}, 
   3.3992049387553997`*^9, {3.3992403177835913`*^9, 3.399240335524761*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \t",
 StyleBox["Truncate",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 "[",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "] removes the last coordinate from ",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.3992069288907413`*^9, 3.3992071029181433`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Truncate", "[", "descriptor_", "]"}], " ", ":=", " ", 
   RowBox[{"Drop", "[", 
    RowBox[{"descriptor", ",", 
     RowBox[{"-", "1"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399207110781517*^9, 3.399207134108878*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \t",
 StyleBox["ToUpperSpace",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 "[",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "] appends a 1 to ",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.399207220401486*^9, 3.399207284811528*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToUpperSpace", "[", "descriptor_", "]"}], " ", ":=", " ", 
   RowBox[{"Append", "[", 
    RowBox[{"descriptor", ",", "1"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399207290164618*^9, 3.399207316127157*^9}, {
  3.3992074166062326`*^9, 3.3992074259323893`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 " \t",
 StyleBox["ToUpperSpace0",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 "[",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "] appends a 0 to ",
 StyleBox["descriptor",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{{3.399207220401486*^9, 3.399207284811528*^9}, {
  3.3992074524642563`*^9, 3.399207455473885*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToUpperSpace0", "[", "descriptor_", "]"}], " ", ":=", " ", 
   RowBox[{"Append", "[", 
    RowBox[{"descriptor", ",", "0"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399207290164618*^9, 3.399207316127157*^9}, {
   3.3992074166062326`*^9, 3.3992074259323893`*^9}, 3.399207458326338*^9, 
   3.399311413174268*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.38974379552286*^9, 3.3897437981148787`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.38974380112297*^9, 3.389743806227131*^9}}]
}, Open  ]]
}, Open  ]]
},
CellGrouping->Manual,
WindowSize->{640, 750},
WindowMargins->{{332, Automatic}, {Automatic, 18}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"DefaultPkg.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 222, 5, 24, "Input"],
Cell[793, 28, 191, 4, 24, "Input"],
Cell[987, 34, 396, 8, 55, "Input"],
Cell[1386, 44, 607, 14, 55, "Input"],
Cell[1996, 60, 270, 7, 24, "Input"],
Cell[2269, 69, 335, 8, 24, "Input"],
Cell[2607, 79, 219, 5, 24, "Input"],
Cell[2829, 86, 1093, 28, 85, "Input"],
Cell[3925, 116, 459, 11, 40, "Input"],
Cell[4387, 129, 228, 5, 24, "Input"],
Cell[CellGroupData[{
Cell[4640, 138, 125, 2, 96, "Title"],
Cell[CellGroupData[{
Cell[4790, 144, 97, 1, 59, "Subtitle"],
Cell[4890, 147, 262, 7, 28, "Text"],
Cell[CellGroupData[{
Cell[5177, 158, 108, 1, 49, "Subsubtitle"],
Cell[5288, 161, 1198, 20, 183, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6523, 186, 99, 1, 49, "Subsubtitle"],
Cell[6625, 189, 1433, 55, 83, "Text"],
Cell[8061, 246, 776, 24, 35, "Text"],
Cell[8840, 272, 140, 1, 28, "Text"],
Cell[8983, 275, 790, 24, 35, "Text"],
Cell[9776, 301, 113, 1, 28, "Text"],
Cell[9892, 304, 230, 8, 28, "Text"],
Cell[10125, 314, 206, 6, 28, "Text"],
Cell[10334, 322, 190, 6, 28, "Text"],
Cell[10527, 330, 200, 6, 28, "Text"],
Cell[10730, 338, 227, 7, 28, "Text"],
Cell[10960, 347, 393, 13, 30, "Text"],
Cell[11356, 362, 413, 13, 45, "Text"],
Cell[11772, 377, 1366, 51, 35, "Text"],
Cell[13141, 430, 239, 6, 28, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13417, 441, 101, 1, 49, "Subsubtitle"],
Cell[13521, 444, 1064, 17, 147, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14622, 466, 123, 1, 49, "Subsubtitle"],
Cell[14748, 469, 647, 15, 96, "Text"],
Cell[15398, 486, 415, 13, 64, "Text"],
Cell[15816, 501, 435, 15, 64, "Text"],
Cell[16254, 518, 952, 26, 164, "Text"],
Cell[17209, 546, 899, 27, 113, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18145, 578, 130, 1, 49, "Subsubtitle"],
Cell[18278, 581, 680, 18, 113, "Text"],
Cell[18961, 601, 652, 18, 113, "Text"],
Cell[19616, 621, 704, 19, 113, "Text"],
Cell[20323, 642, 726, 19, 113, "Text"],
Cell[21052, 663, 728, 19, 113, "Text"],
Cell[21783, 684, 812, 19, 130, "Text"],
Cell[22598, 705, 657, 15, 113, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23292, 725, 104, 1, 49, "Subsubtitle"],
Cell[23399, 728, 1100, 34, 130, "Text"],
Cell[24502, 764, 622, 21, 28, "Text"],
Cell[25127, 787, 178, 6, 28, "Text"],
Cell[25308, 795, 1375, 40, 147, "Text"],
Cell[26686, 837, 1293, 38, 147, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28016, 880, 94, 1, 49, "Subsubtitle"],
Cell[28113, 883, 565, 17, 96, "Text"],
Cell[28681, 902, 653, 20, 113, "Text"],
Cell[29337, 924, 702, 24, 81, "Text"],
Cell[30042, 950, 703, 24, 81, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30794, 980, 124, 2, 59, "Subtitle"],
Cell[30921, 984, 326, 8, 24, "Input"],
Cell[CellGroupData[{
Cell[31272, 996, 170, 2, 48, "Section"],
Cell[31445, 1000, 346, 7, 55, "Input"],
Cell[CellGroupData[{
Cell[31816, 1011, 98, 1, 42, "Subsection"],
Cell[31917, 1014, 298, 6, 55, "Input"],
Cell[32218, 1022, 290, 6, 55, "Input"],
Cell[32511, 1030, 295, 6, 55, "Input"],
Cell[32809, 1038, 369, 7, 55, "Input"],
Cell[33181, 1047, 318, 6, 55, "Input"],
Cell[33502, 1055, 316, 6, 55, "Input"],
Cell[33821, 1063, 399, 7, 70, "Input"],
Cell[34223, 1072, 315, 6, 55, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34575, 1083, 122, 1, 42, "Subsection"],
Cell[34700, 1086, 318, 7, 55, "Input"],
Cell[35021, 1095, 335, 7, 55, "Input"],
Cell[35359, 1104, 334, 7, 55, "Input"],
Cell[35696, 1113, 309, 6, 55, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36042, 1124, 129, 1, 42, "Subsection"],
Cell[36174, 1127, 381, 8, 70, "Input"],
Cell[36558, 1137, 370, 7, 70, "Input"],
Cell[36931, 1146, 377, 8, 70, "Input"],
Cell[37311, 1156, 449, 9, 85, "Input"],
Cell[37763, 1167, 454, 9, 85, "Input"],
Cell[38220, 1178, 464, 9, 85, "Input"],
Cell[38687, 1189, 426, 9, 85, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39150, 1203, 103, 1, 42, "Subsection"],
Cell[39256, 1206, 633, 11, 130, "Input"],
Cell[39892, 1219, 541, 11, 85, "Input"],
Cell[40436, 1232, 473, 9, 85, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40946, 1246, 93, 1, 42, "Subsection"],
Cell[41042, 1249, 419, 8, 55, "Input"],
Cell[41464, 1259, 495, 10, 70, "Input"],
Cell[41962, 1271, 380, 8, 70, "Input"],
Cell[42345, 1281, 382, 7, 55, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42776, 1294, 99, 1, 48, "Section"],
Cell[42878, 1297, 158, 3, 24, "Input"],
Cell[43039, 1302, 1284, 35, 117, "Text"],
Cell[CellGroupData[{
Cell[44348, 1341, 98, 1, 42, "Subsection"],
Cell[44449, 1344, 1323, 31, 70, "Input"],
Cell[45775, 1377, 1069, 27, 70, "Input"],
Cell[46847, 1406, 741, 20, 40, "Input"],
Cell[47591, 1428, 364, 8, 24, "Input"],
Cell[47958, 1438, 342, 7, 24, "Input"],
Cell[48303, 1447, 431, 10, 24, "Input"],
Cell[48737, 1459, 365, 8, 24, "Input"],
Cell[49105, 1469, 498, 11, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49640, 1485, 122, 1, 42, "Subsection"],
Cell[49765, 1488, 616, 17, 40, "Input"],
Cell[50384, 1507, 299, 7, 24, "Input"],
Cell[50686, 1516, 1413, 34, 115, "Input"],
Cell[52102, 1552, 1681, 40, 145, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53820, 1597, 129, 1, 42, "Subsection"],
Cell[53952, 1600, 675, 16, 40, "Input"],
Cell[54630, 1618, 534, 14, 40, "Input"],
Cell[55167, 1634, 534, 14, 40, "Input"],
Cell[55704, 1650, 502, 12, 40, "Input"],
Cell[56209, 1664, 552, 12, 40, "Input"],
Cell[56764, 1678, 690, 17, 70, "Input"],
Cell[57457, 1697, 514, 12, 70, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58008, 1714, 103, 1, 42, "Subsection"],
Cell[58114, 1717, 1476, 37, 115, "Input"],
Cell[59593, 1756, 449, 11, 40, "Input"],
Cell[60045, 1769, 416, 10, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60498, 1784, 93, 1, 42, "Subsection"],
Cell[60594, 1787, 378, 10, 40, "Input"],
Cell[60975, 1799, 378, 10, 40, "Input"],
Cell[61356, 1811, 372, 9, 40, "Input"],
Cell[61731, 1822, 376, 9, 40, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62144, 1836, 107, 1, 42, "Subsection"],
Cell[CellGroupData[{
Cell[62276, 1841, 205, 3, 38, "Subsubsection"],
Cell[62484, 1846, 1723, 46, 130, "Text"],
Cell[64210, 1894, 392, 10, 40, "Input"],
Cell[64605, 1906, 3407, 82, 190, "Input"],
Cell[68015, 1990, 2444, 61, 160, "Input"],
Cell[70462, 2053, 777, 20, 85, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71276, 2078, 773, 28, 45, "Text"],
Cell[72052, 2108, 408, 10, 24, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72497, 2123, 320, 13, 28, "Text"],
Cell[72820, 2138, 277, 7, 24, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73134, 2150, 302, 13, 28, "Text"],
Cell[73439, 2165, 315, 7, 24, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73791, 2177, 354, 14, 28, "Text"],
Cell[74148, 2193, 365, 8, 24, "Input"]
}, Open  ]]
}, Open  ]],
Cell[74540, 2205, 136, 3, 24, "Input"]
}, Open  ]],
Cell[74691, 2211, 141, 3, 24, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
