(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     16509,        463]
NotebookOptionsPosition[     15225,        422]
NotebookOutlinePosition[     15565,        437]
CellTagsIndexPosition[     15522,        434]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestAddGroups"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779238537509*^9, 3.4007792409786987`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "functions", " ", "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779250252404*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.453207178459165*^9, 3.453207180075732*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook tests the constructors which add groups of descriptors.
ConeIntersection, ConicalHull, AddConsttraintGroupToCone, and \
AddGeneratorGroupToCone are tested.\
\>", "Text",
 CellChangeTimes->{{3.3986063461365623`*^9, 3.398606428977456*^9}, 
   3.398632575691009*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.398604574326457*^9, 3.3986046111226187`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.398604628714024*^9, 3.398604630035698*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullSpace", " ", "=", " ", 
   RowBox[{"FullSpace", "[", "d", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39860463374934*^9, 3.398604651881769*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"foldConeG", " ", "=", " ", 
   RowBox[{"AddConstraintGroupToCone", "[", 
    RowBox[{"fullSpace", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398632053690468*^9, 3.398632191787858*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"foldConeG", " ", "\[Equal]", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], ",",
           
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: AddConstraintGroupToCone gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 1: AddConstraintGroupToCone gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 1: AddConstraintGroupToCone unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398632226306121*^9, 
   3.398632259625531*^9}, {3.398632292190506*^9, 3.3986323101021633`*^9}, 
   3.39863238263136*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"emptyCone", " ", "=", " ", 
   RowBox[{"ZeroCone", "[", "d", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398551027340701*^9, 3.398551030508849*^9}, {
  3.398551169503271*^9, 3.398551176210004*^9}, {3.3985514541705637`*^9, 
  3.398551458570862*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eightPoints", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398552771120901*^9, 3.3985528937230577`*^9}, 
   3.398553492247326*^9, 3.3985535423597803`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"myCubeG", "=", 
   RowBox[{"AddGeneratorGroupToCone", "[", 
    RowBox[{"emptyCone", ",", 
     RowBox[{"{", "}"}], ",", "eightPoints"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398632548098227*^9, 3.398632598132769*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"myCubeG", "==", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 2: AddGeneratorGroup gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: AddGeneratorGroup gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: AddGeneratorGroup unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.3986326143824368`*^9, 
   3.39863267961799*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"foldConeH", "=", 
   RowBox[{"ConeIntersection", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398632779394452*^9, 3.398632826278377*^9}, 
   3.398633017244007*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"foldConeH", "\[Equal]", "foldConeG"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 3: ConeIntersection gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: ConeIntersection gives unexpected result.\>\""}], "]"}],
      ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: ConeIntersection unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398632843741541*^9, 
   3.398632894530757*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"myCubeH", " ", "=", " ", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "eightPoints"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398633080821329*^9, 3.398633112332828*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"myCubeH", "\[Equal]", "myCubeG"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 4: ConicalHull gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: ConicalHull gives unexpected result.\>\""}], "]"}], ",",
      "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: ConicalHull unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.3986331285426617`*^9, 
   3.3986331644828033`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3", ",", "Test4"}], "}"}]], "Input",\

 CellChangeTimes->{{3.398632266919286*^9, 3.39863226954493*^9}, {
  3.398632687302396*^9, 3.398632689265739*^9}, {3.398632900551344*^9, 
  3.398632902277557*^9}, {3.398633178165855*^9, 3.3986331797103567`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: AddConstraintGroupToCone gives expected result.\"\>",
    ",", "\<\"! Test 2: AddGeneratorGroup gives expected result.\"\>", 
   ",", "\<\"! Test 3: ConeIntersection gives expected result.\"\>", 
   ",", "\<\"! Test 4: ConicalHull gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.3986322780380497`*^9, 3.398632314080017*^9, 3.3986323861130123`*^9, 
   3.39863270286395*^9, 3.398632907870083*^9, 3.398633025680089*^9, {
   3.3986331715507*^9, 3.3986331804309263`*^9}, 3.399313375442464*^9, 
   3.4532072029497633`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9}]
},
WindowSize->{640, 750},
WindowMargins->{{12, Automatic}, {Automatic, 24}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 322, 6, 27, "Input"],
Cell[893, 29, 191, 4, 27, "Input"],
Cell[1087, 35, 396, 8, 58, "Input"],
Cell[1486, 45, 394, 9, 27, "Input"],
Cell[1883, 56, 270, 7, 27, "Input"],
Cell[2156, 65, 262, 6, 27, "Input"],
Cell[2421, 73, 219, 5, 27, "Input"],
Cell[2643, 80, 654, 15, 58, "Input"],
Cell[3300, 97, 459, 11, 43, "Input"],
Cell[3762, 110, 228, 5, 27, "Input"],
Cell[3993, 117, 287, 6, 41, "Text"],
Cell[4283, 125, 172, 4, 27, "Input"],
Cell[4458, 131, 133, 3, 27, "Input"],
Cell[4594, 136, 187, 4, 27, "Input"],
Cell[4784, 142, 583, 16, 43, "Input"],
Cell[5370, 160, 1763, 44, 133, "Input"],
Cell[7136, 206, 287, 6, 27, "Input"],
Cell[7426, 214, 1142, 30, 163, "Input"],
Cell[8571, 246, 264, 6, 27, "Input"],
Cell[8838, 254, 2524, 60, 178, "Input"],
Cell[11365, 316, 573, 17, 27, "Input"],
Cell[11941, 335, 741, 17, 88, "Input"],
Cell[12685, 354, 244, 6, 27, "Input"],
Cell[12932, 362, 726, 17, 88, "Input"],
Cell[CellGroupData[{
Cell[13683, 383, 321, 6, 27, "Input"],
Cell[14007, 391, 598, 11, 73, "Output"]
}, Open  ]],
Cell[14620, 405, 601, 15, 88, "Input"]
}
]
*)

(* End of internal cache information *)
