(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     13561,        380]
NotebookOptionsPosition[     12431,        343]
NotebookOutlinePosition[     12773,        358]
CellTagsIndexPosition[     12730,        355]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestAddSingleConstraints"}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", "  ", "functions", " ", "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.453207221715777*^9, 3.4532072233706083`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains tests of functions which add single constraints to a \
cone.
Fullspace is used. AddHyperplaneToCone and AddHalfspaceToCone are tested.\
\>", "Text",
 CellChangeTimes->{{3.3986044985483007`*^9, 3.3986045708779716`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.398604574326457*^9, 3.3986046111226187`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.398604628714024*^9, 3.398604630035698*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullSpace", " ", "=", " ", 
   RowBox[{"FullSpace", "[", "d", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39860463374934*^9, 3.398604651881769*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"fullSpace", "\[Equal]", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: FullSpace gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: FullSpace gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: FullSpace unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398604823799736*^9, 
   3.398604836742137*^9}, {3.3986048755418997`*^9, 3.3986049048542957`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"flatCone", "=", 
   RowBox[{"AddHyperplaneToCone", "[", 
    RowBox[{"fullSpace", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"foldCone0", "=", 
   RowBox[{"AddHalfspaceToCone", "[", 
    RowBox[{"flatCone", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"foldCone", " ", "=", " ", 
   RowBox[{"AddHalfspaceToCone", "[", 
    RowBox[{"foldCone0", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.398605060038731*^9, 3.398605076913672*^9}, {
  3.3986051092244387`*^9, 3.398605281364908*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"flatCone", "==", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 2: AddHyperplaneToCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: AddHyperplaneToCone gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: AddHyperplaneToCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398605473464283*^9, 
   3.398605481411117*^9}, {3.398605543442916*^9, 3.398605597339807*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"foldCone", "==", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 3: AddHalfspaceToCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: AddHalfspaceToCone gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: AddHalfspaceToCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398605661294153*^9, 
   3.398605713322276*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3"}], "}"}]], "Input",
 CellChangeTimes->{{3.398604911064568*^9, 3.3986049159479103`*^9}, {
  3.39860561464178*^9, 3.398605616498472*^9}, {3.3986057177734528`*^9, 
  3.3986057215497932`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: FullSpace gives expected result.\"\>", 
   ",", "\<\"! Test 2: AddHyperplaneToCone gives expected result.\"\>", 
   ",", "\<\"! Test 3: AddHalfspaceToCone gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.3986049248200607`*^9, 3.398605646925496*^9, 
  3.398605727979117*^9, 3.453207229872381*^9, 3.469655642910871*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"emptyCone", " ", "=", " ", 
   RowBox[{"ZeroCone", "[", "d", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emptyCone2", " ", "=", " ", 
   RowBox[{"AddHalfspaceToCone", "[", 
    RowBox[{"emptyCone", ",", " ", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "5", ",", "7"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.469649376918435*^9, 3.469649414301074*^9}, {
   3.469649449093378*^9, 3.469649535967696*^9}, 3.469655654199288*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9}]
},
WindowSize->{640, 750},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"7.0 for Mac OS X PowerPC (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 336, 7, 27, "Input"],
Cell[884, 29, 191, 4, 27, "Input"],
Cell[1078, 35, 396, 8, 58, "Input"],
Cell[1477, 45, 395, 9, 27, "Input"],
Cell[1875, 56, 270, 7, 27, "Input"],
Cell[2148, 65, 264, 6, 27, "Input"],
Cell[2415, 73, 219, 5, 27, "Input"],
Cell[2637, 80, 654, 15, 58, "Input"],
Cell[3294, 97, 459, 11, 43, "Input"],
Cell[3756, 110, 228, 5, 27, "Input"],
Cell[3987, 117, 251, 5, 41, "Text"],
Cell[4241, 124, 172, 4, 27, "Input"],
Cell[4416, 130, 133, 3, 27, "Input"],
Cell[4552, 135, 187, 4, 27, "Input"],
Cell[4742, 141, 1366, 31, 133, "Input"],
Cell[6111, 174, 839, 23, 58, "Input"],
Cell[6953, 199, 1408, 32, 133, "Input"],
Cell[8364, 233, 1646, 41, 133, "Input"],
Cell[10013, 276, 601, 15, 88, "Input"],
Cell[CellGroupData[{
Cell[10639, 295, 263, 5, 27, "Input"],
Cell[10905, 302, 395, 7, 58, "Output"]
}, Open  ]],
Cell[11315, 312, 508, 12, 43, "Input"],
Cell[11826, 326, 601, 15, 88, "Input"]
}
]
*)

(* End of internal cache information *)
