(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     17402,        483]
NotebookOptionsPosition[     16157,        443]
NotebookOutlinePosition[     16495,        458]
CellTagsIndexPosition[     16452,        455]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestAddSingleGenerators"}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.400779845228372*^9, 
   3.40077984735846*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", "  ", "functions", " ", "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.4532069655235577`*^9, 3.4532069667077436`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains tests of some of the visible functions in \
ConvexCone.nb.  ZeroCone is used.  AddLineToCone and AddRayToCone are tested.\
\
\>", "Text",
 CellChangeTimes->{{3.3985508486515636`*^9, 3.398550940696095*^9}, {
  3.398551146536337*^9, 3.398551152046979*^9}, {3.398551434438241*^9, 
  3.398551447352001*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397770787542433*^9, 3.397770806006796*^9}}],

Cell["Set up empty cone within 4-space.", "Text",
 CellChangeTimes->{{3.398550967200097*^9, 3.398550991425252*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.398550996484873*^9, 3.398550998956213*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"emptyCone", " ", "=", " ", 
   RowBox[{"ZeroCone", "[", "d", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398551027340701*^9, 3.398551030508849*^9}, {
  3.398551169503271*^9, 3.398551176210004*^9}, {3.3985514541705637`*^9, 
  3.398551458570862*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"emptyCone", " ", "==", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",",
           
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: ZeroCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: ZeroCone gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: ZeroCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.39855207035002*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"oneLine", " ", "=", " ", 
   RowBox[{"AddLineToCone", "[", 
    RowBox[{"emptyCone", ",", " ", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0", ",", "1"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.398551504853928*^9, 3.3985515706709642`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"oneLine", " ", "==", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "2"}], ",", "0", ",", "0", ",", "2"}], "}"}], ",", 
            
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", 
               FractionBox["1", "2"]}], ",", "0", ",", "1"}], "}"}]}], "}"}], 
          ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "0", ",", "1"}], "}"}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 2: AddLineToCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: AddLineToCone gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: AddLineToCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.39855207035002*^9}, {
  3.3985521589437113`*^9, 3.39855221190866*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"oneRay", "=", 
   RowBox[{"AddRayToCone", "[", 
    RowBox[{"emptyCone", ",", " ", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0", ",", "1"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.3985515824418993`*^9, 3.398551607608142*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"oneRay", " ", "\[Equal]", " ", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["1", "2"]}], ",", "0", ",", "0", ",", "1"}], "}"}],
             ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", 
             RowBox[{"-", "2"}]}], "}"}], "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "0", ",", "1"}], "}"}], "}"}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 3: AddRayToCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: AddRayToCone gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: AddRayToCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, {
   3.398552250184219*^9, 3.398552258137142*^9}, {3.398552414533168*^9, 
   3.398552448436522*^9}, 3.398552502183104*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eightPoints", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398552771120901*^9, 3.3985528937230577`*^9}, 
   3.398553492247326*^9, 3.3985535423597803`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"a", " ", "self"}], "-", 
    RowBox[{"consciously", " ", "retro", " ", "construction"}]}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"myCube", " ", "=", " ", "emptyCone"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", " ", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "eightPoints", "]"}]}], ",", " ", 
      RowBox[{"i", " ", "=", " ", 
       RowBox[{"i", "+", "1"}]}], ",", "\[IndentingNewLine]", " ", 
      RowBox[{"myCube", " ", "=", " ", 
       RowBox[{"AddRayToCone", "[", 
        RowBox[{"myCube", ",", 
         RowBox[{"eightPoints", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
     "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.39855292386998*^9, 3.398552977121765*^9}, {
  3.398553013466865*^9, 3.398553124362302*^9}, {3.398553232650826*^9, 
  3.3985532355475883`*^9}, {3.3985534429027433`*^9, 3.398553500254216*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"myCube", "==", 
        RowBox[{"ConvexCone", "[", 
         RowBox[{"4", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 4: AddRayToCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: AddRayToCone gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: AddRayToCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.3985536127252283`*^9, 
   3.398553664727162*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3", ",", "Test4"}], "}"}]], "Input",\

 CellChangeTimes->{{3.3985520813107367`*^9, 3.3985520841410437`*^9}, {
  3.398552226208987*^9, 3.398552230097769*^9}, {3.398552472625887*^9, 
  3.398552474965255*^9}, {3.398553681181321*^9, 3.398553682757608*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: ZeroCone gives expected result.\"\>", 
   ",", "\<\"! Test 2: AddLineToCone gives expected result.\"\>", 
   ",", "\<\"! Test 3: AddRayToCone gives expected result.\"\>", 
   ",", "\<\"! Test 4: AddRayToCone gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.398552096924275*^9, 3.3985524901046953`*^9, 3.398552530445918*^9, {
   3.398553674296488*^9, 3.398553683607472*^9}, {3.4532069593159733`*^9, 
   3.453206976170229*^9}, 3.453207253730772*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9}]
},
WindowSize->{640, 750},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 384, 8, 27, "Input"],
Cell[955, 31, 191, 4, 27, "Input"],
Cell[1149, 37, 396, 8, 58, "Input"],
Cell[1548, 47, 395, 9, 27, "Input"],
Cell[1946, 58, 270, 7, 27, "Input"],
Cell[2219, 67, 266, 6, 27, "Input"],
Cell[2488, 75, 219, 5, 27, "Input"],
Cell[2710, 82, 654, 15, 58, "Input"],
Cell[3367, 99, 459, 11, 43, "Input"],
Cell[3829, 112, 228, 5, 27, "Input"],
Cell[4060, 119, 336, 7, 41, "Text"],
Cell[4399, 128, 170, 4, 27, "Input"],
Cell[4572, 134, 115, 1, 26, "Text"],
Cell[4690, 137, 133, 3, 27, "Input"],
Cell[4826, 142, 287, 6, 27, "Input"],
Cell[5116, 150, 1222, 30, 148, "Input"],
Cell[6341, 182, 306, 8, 27, "Input"],
Cell[6650, 192, 1385, 35, 195, "Input"],
Cell[8038, 229, 294, 8, 27, "Input"],
Cell[8335, 239, 1583, 39, 195, "Input"],
Cell[9921, 280, 1142, 30, 163, "Input"],
Cell[11066, 312, 1080, 27, 88, "Input"],
Cell[12149, 341, 2508, 60, 178, "Input"],
Cell[CellGroupData[{
Cell[14682, 405, 324, 6, 27, "Input"],
Cell[15009, 413, 528, 10, 73, "Output"]
}, Open  ]],
Cell[15552, 426, 601, 15, 88, "Input"]
}
]
*)

(* End of internal cache information *)
