(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     16262,        436]
NotebookOptionsPosition[     15055,        397]
NotebookOutlinePosition[     15395,        412]
CellTagsIndexPosition[     15352,        409]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestCPAttributes"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.4007799481359367`*^9, 
   3.400779951401919*^9}, {3.4007800475468597`*^9, 3.400780049493029*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "functions", " ", "of", " ", 
     RowBox[{"ConvexPolyhedra", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9, {3.4007799573634567`*^9, 3.4007799663949213`*^9}, 
   3.400780057254305*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.4532072936840267`*^9, 3.4532072950986643`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], ",", " ", 
   "\[IndentingNewLine]", "                ", 
   RowBox[{"Convex`ConvexPolyhedra", ".", "nb"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}, {
  3.40077997488339*^9, 3.400780011865028*^9}}],

Cell["\<\
This notebook contains tests for the internal functions of \
convexPolyhedroa.nb.\
\>", "Text",
 CellChangeTimes->{{3.399309980422974*^9, 3.399310002750619*^9}}],

Cell["\<\
This notebook contains tests of the attributes of convex polyhedra.\
\>", "Text",
 CellChangeTimes->{{3.399412681992756*^9, 3.3994127070570087`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexPolyhedra`\>\"", "]"}], ";", 
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.399412715538001*^9, 3.399412760597102*^9}, {
  3.399413372208364*^9, 3.399413377160315*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mypoly", " ", "=", " ", 
   RowBox[{"ConvexPolyhedron", "[", 
    RowBox[{"ConicalHull", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
       "}"}]}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3994128689982862`*^9, 3.399412954877881*^9}, 
   3.399413279862962*^9, {3.39941339897862*^9, 3.3994134014804783`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Points", "[", "mypoly", "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ",",
        "\[IndentingNewLine]", 
       "\"\<! Test 1: Points gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: Points gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: Points unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399412989316382*^9, 3.3994130584698153`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Rays", "[", "mypoly", "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], "}"}]}], ",", 
       "\[IndentingNewLine]", "\"\<! Test 2: Rays gives expected result.\>\"",
        ",", "\[IndentingNewLine]", 
       "\"\<? Test 2: Rays gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: Rays unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.3994130862075167`*^9, 3.399413142007049*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Lines", "[", "mypoly", "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 3: Lines gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: Lines gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: Lines unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399413188067127*^9, 3.399413230529476*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Hyperplanes", "[", "mypoly", "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", "1"}], "}"}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 4: Hyperplanes gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: Hyperplanes gives unexpected result.\>\""}], "]"}], ",",
      "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: Hyperplanes unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399413462996191*^9, 3.399413517698502*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Halfspaces", "[", "mypoly", "]"}], " ", "\[Equal]", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}]}], 
         "}"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 5: Halfspaces gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 5: Halfspaces gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: Halfspaces unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.3994135963448763`*^9, 3.399413640625016*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"AmbientDimension", "[", "mypoly", "]"}], "\[Equal]", "4"}], 
       ",", "\[IndentingNewLine]", 
       "\"\<! Test 6: AmbientDimension gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 6: AmbientDimension gives unexpected result.\>\""}], "]"}],
      ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 6: AmbientDimension unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399413786215043*^9, 3.399413837507636*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test7", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"LinealityDimension", "[", "mypoly", "]"}], "\[Equal]", "1"}],
        ",", "\[IndentingNewLine]", 
       "\"\<! Test 7: LinealityDimension gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 7: LinealityDimension gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 7: LinealityDimension unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399413840768655*^9, 3.399413892373211*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test8", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SpanDimension", "[", "mypoly", "]"}], "\[Equal]", "3"}], ",",
        "\[IndentingNewLine]", 
       "\"\<! Test 8: SpanDimension gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 8: SpanDimension gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 8: SpanDimension unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399413897030253*^9, 3.3994139400940657`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
   "Test6", ",", "Test7", ",", "Test8"}], "}"}]], "Input",
 CellChangeTimes->{{3.39941323948219*^9, 3.399413245354473*^9}, {
  3.399413733332699*^9, 3.399413736885159*^9}, {3.399413943303883*^9, 
  3.399413949736971*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: Points gives expected result.\"\>", 
   ",", "\<\"! Test 2: Rays gives expected result.\"\>", 
   ",", "\<\"! Test 3: Lines gives expected result.\"\>", 
   ",", "\<\"! Test 4: Hyperplanes gives expected result.\"\>", 
   ",", "\<\"! Test 5: Halfspaces gives expected result.\"\>", 
   ",", "\<\"! Test 6: AmbientDimension gives expected result.\"\>", 
   ",", "\<\"! Test 7: LinealityDimension gives expected result.\"\>", 
   ",", "\<\"! Test 8: SpanDimension gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.399413249005273*^9, {3.3994133830853653`*^9, 3.3994134051900263`*^9}, 
   3.399413742446643*^9, 3.399413951434812*^9, 3.3994140930312557`*^9, 
   3.453207299181149*^9}]
}, Open  ]]
},
WindowSize->{640, 750},
WindowMargins->{{12, Automatic}, {Automatic, 24}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 425, 7, 27, "Input"],
Cell[996, 30, 191, 4, 27, "Input"],
Cell[1190, 36, 396, 8, 58, "Input"],
Cell[1589, 46, 474, 10, 27, "Input"],
Cell[2066, 58, 270, 7, 27, "Input"],
Cell[2339, 67, 266, 6, 27, "Input"],
Cell[2608, 75, 219, 5, 27, "Input"],
Cell[2830, 82, 654, 15, 58, "Input"],
Cell[3487, 99, 459, 11, 43, "Input"],
Cell[3949, 112, 400, 9, 43, "Input"],
Cell[4352, 123, 171, 4, 26, "Text"],
Cell[4526, 129, 159, 3, 26, "Text"],
Cell[4688, 134, 291, 6, 27, "Input"],
Cell[4982, 142, 651, 16, 88, "Input"],
Cell[5636, 160, 794, 20, 58, "Input"],
Cell[6433, 182, 1012, 24, 88, "Input"],
Cell[7448, 208, 880, 20, 88, "Input"],
Cell[8331, 230, 891, 21, 88, "Input"],
Cell[9225, 253, 952, 22, 88, "Input"],
Cell[10180, 277, 1259, 30, 133, "Input"],
Cell[11442, 309, 820, 18, 88, "Input"],
Cell[12265, 329, 834, 18, 88, "Input"],
Cell[13102, 349, 815, 18, 88, "Input"],
Cell[CellGroupData[{
Cell[13942, 371, 334, 7, 27, "Input"],
Cell[14279, 380, 760, 14, 133, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
