(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     32178,        810]
NotebookOptionsPosition[     30720,        765]
NotebookOutlinePosition[     31058,        780]
CellTagsIndexPosition[     31015,        777]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestCPIncrementalConstructors"}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.4007799481359367`*^9, 
   3.400779951401919*^9}, {3.4007800893164062`*^9, 3.400780094294427*^9}, {
   3.4007801302855473`*^9, 3.4007801327758083`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "functions", " ", "of", " ", 
     RowBox[{"ConvexPolyhedra", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9, {3.4007799573634567`*^9, 3.4007799663949213`*^9}, 
   3.400780102391849*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.453207340749172*^9, 3.453207343306823*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], ",", " ", 
   "\[IndentingNewLine]", "                ", 
   RowBox[{"Convex`ConvexPolyhedra", ".", "nb"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}, {
  3.40077997488339*^9, 3.400780011865028*^9}}],

Cell["\<\
This notebook contains tests of the convexPolyhedron constructors that take \
another convex polyhedron and add one or more descriptors: 
\tAddPointToPolyhedron
\tAddRayToPolyhedron
\tAddLineToPolyhedron
\tAddHalfspaceToPolyhedron
\tAddHyperplaneToPolyhedron
\tAddGeneratorsToPolyhedron
\tAddConstraintsToPolyhedron\
\>", "Text",
 CellChangeTimes->{{3.399575739145632*^9, 3.399575867827036*^9}, 
   3.39957813620207*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexPolyhedra`\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399412715538001*^9, 3.399412760597102*^9}, {
   3.399413372208364*^9, 3.399413377160315*^9}, 3.3995761137200727`*^9}],

Cell["\<\
AddPointToPolyhedron
\t1: The dimension of the polyhedron grows as a result
\t2: One or more points is \"shadowed\" by the new point
\t3: The new point is redundant\
\>", "Text",
 CellChangeTimes->{{3.3995759670569687`*^9, 3.399576061169389*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddPointToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronIntersection", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", 
                RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], " ", "\[Equal]", " ", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 1: AddPointToPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: AddPointToPolyhedron gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: AddPointToPolyhedron Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399576071915765*^9, {3.399576129828429*^9, 
   3.399576230584301*^9}, {3.399576274407102*^9, 3.399576478295196*^9}, {
   3.3995771998578157`*^9, 3.399577200764226*^9}, 3.399577879899014*^9, {
   3.3995893358905277`*^9, 3.399589355405237*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddPointToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 2: AddPointToPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: AddPointToPolyhedron gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: AddPointToPolyhedron unexpectedly Throws.\>\""}], "]"}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399576074561569*^9, {3.399576512333202*^9, 
   3.399576739872752*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddPointToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], " ", "\[Equal]", " ", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 3: AddPointToPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: AddPointToPolyhedron result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: AddPointToPolyhedron Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.3995760773137693`*^9, {3.399576812029361*^9, 
   3.399576829258102*^9}, {3.39957699783209*^9, 3.39957713093999*^9}}],

Cell["AddRayToPolyhedron", "Text",
 CellChangeTimes->{{3.399589616251515*^9, 3.399589622100892*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddRayToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronIntersection", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 4: AddRayToPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: AddRayToPolyhedron gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: AddRayToPolyhedron unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399589632164942*^9, 3.399589713265415*^9}, {
   3.399589797996162*^9, 3.39959000282918*^9}, {3.399590065198449*^9, 
   3.399590076735959*^9}, 3.399590167082036*^9}],

Cell["AddLineToPolyhedron", "Text",
 CellChangeTimes->{{3.399590213779355*^9, 3.399590220703348*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddLineToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"PolyhedronIntersection", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 5: AddLineToPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 5: AddLineToPolyhedron gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: AddLineToPolyhedron unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399590227029705*^9, 3.399590251809744*^9}, {
   3.399590319131371*^9, 3.399590351069648*^9}, {3.399590387083501*^9, 
   3.399590533966936*^9}}],

Cell["AddHalfspaceToPolyhedron", "Text",
 CellChangeTimes->{{3.399590602678052*^9, 3.399590609251795*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddHalfspaceToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 6: AddHalfspaceToPolyhedron gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 6: AddHalfspaceToPolyhedron gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 6: AddHalfspaceToPolyhedron unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399590259487378*^9, 3.399590276369134*^9}, 
   3.3995906214330053`*^9, {3.399590683484385*^9, 3.399590700240155*^9}, {
   3.399590776706696*^9, 3.399590953888839*^9}}],

Cell["AddHyperplaneToPolyhedron", "Text",
 CellChangeTimes->{{3.399591000432047*^9, 3.399591008240587*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test7", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddHyperplaneToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 7: AddHyperplaneToPolyhedron gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 7: AddHyperplaneToPolyhedron gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 7: AddHyperplaneToPolyhedron unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.3995906552395277`*^9, 3.399590673302012*^9}, {
   3.399591018341199*^9, 3.3995911637076187`*^9}}],

Cell["AddGeneratorsToPolyhedron", "Text",
 CellChangeTimes->{{3.399591293154752*^9, 3.399591299865673*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test8", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddGeneratorsToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], 
               "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", 
               RowBox[{"-", "2"}]}], "}"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", 
               RowBox[{"1", "/", "3"}], ",", "0"}], "}"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1", ",", "0", ",", "0"}], "}"}], "}"}]}], 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"PolyhedronIntersection", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", 
                RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0", ",", "0"}], 
               "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}], ",", "0", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 8: AddGeneratorsToPolyhedron gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 8: AddGeneratorsToPolyhedron gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 8: AddGeneratorsToPolyhedron unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.3995912231210423`*^9, {3.3995913290277042`*^9, 
   3.3995913627409487`*^9}, {3.399591414212974*^9, 3.399591415287011*^9}, {
   3.399591474166462*^9, 3.39959166558869*^9}, {3.3995916984765368`*^9, 
   3.399591776293159*^9}, {3.399591807494897*^9, 3.39959189602809*^9}, {
   3.399592125376575*^9, 3.399592126728539*^9}}],

Cell["AddConstraintsToPolyhedron", "Text",
 CellChangeTimes->{{3.399592171530314*^9, 3.399592180790296*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test9", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AddConstraintsToPolyhedron", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronIntersection", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", 
                  RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1", ",", "1", ",", 
               RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "1", ",", 
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}]}], "}"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"1", "/", "2"}], ",", "0", ",", 
                RowBox[{"1", "/", "2"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"1", "/", "2"}], ",", 
                RowBox[{"1", "/", "2"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 9: AddConstraintsToPolyhedron gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 9: AddConstraintsToPolyhedron gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 9: AddConstraintsToPolyhedron unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399591056628365*^9, {3.399592226399418*^9, 
   3.399592285909369*^9}, {3.39959238622589*^9, 3.399592634983253*^9}, {
   3.399592719705035*^9, 3.399592720001659*^9}, {3.399592873246266*^9, 
   3.399592874438555*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{"ufb", ",", "\[IndentingNewLine]", "ufb"}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", "\"\<! Test *: ufb gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399592192960168*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
   "Test6", ",", "Test7", ",", "Test8", ",", "Test9"}], "}"}]], "Input",
 CellChangeTimes->{{3.399577136957561*^9, 3.399577142493595*^9}, {
  3.3995900172619677`*^9, 3.3995900187401237`*^9}, {3.399590548831357*^9, 
  3.399590550237001*^9}, {3.399590962258288*^9, 3.3995909640025682`*^9}, {
  3.399591174811701*^9, 3.3995911765214376`*^9}, {3.39959190308449*^9, 
  3.399591905777438*^9}, {3.3995926492830143`*^9, 3.399592650945016*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: AddPointToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 2: AddPointToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 3: AddPointToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 4: AddRayToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 5: AddLineToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 6: AddHalfspaceToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 7: AddHyperplaneToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 8: AddGeneratorsToPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 9: AddConstraintsToPolyhedron gives expected \
result.\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.399577174410071*^9, 3.399578145872991*^9, 
  3.39958529382262*^9, 3.399589372795751*^9, 3.3995895190132313`*^9, 
  3.399590024112052*^9, 3.3995900802046843`*^9, 3.399590170483758*^9, 
  3.39959055199788*^9, 3.399590967990777*^9, 3.3995911785010433`*^9, 
  3.399591908245823*^9, 3.399592133210712*^9, 3.399592652884389*^9, 
  3.399592725151556*^9, 3.399592878408167*^9, 3.4532073491370697`*^9}]
}, Open  ]]
},
WindowSize->{620, 830},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 495, 9, 27, "Input"],
Cell[1066, 32, 191, 4, 27, "Input"],
Cell[1260, 38, 396, 8, 58, "Input"],
Cell[1659, 48, 474, 10, 27, "Input"],
Cell[2136, 60, 270, 7, 27, "Input"],
Cell[2409, 69, 262, 6, 27, "Input"],
Cell[2674, 77, 219, 5, 27, "Input"],
Cell[2896, 84, 654, 15, 73, "Input"],
Cell[3553, 101, 459, 11, 43, "Input"],
Cell[4015, 114, 400, 9, 43, "Input"],
Cell[4418, 125, 430, 12, 146, "Text"],
Cell[4851, 139, 249, 5, 27, "Input"],
Cell[5103, 146, 256, 6, 71, "Text"],
Cell[5362, 154, 2552, 59, 178, "Input"],
Cell[7917, 215, 2258, 55, 163, "Input"],
Cell[10178, 272, 2283, 55, 163, "Input"],
Cell[12464, 329, 100, 1, 26, "Text"],
Cell[12567, 332, 2032, 48, 163, "Input"],
Cell[14602, 382, 101, 1, 26, "Text"],
Cell[14706, 385, 2103, 50, 178, "Input"],
Cell[16812, 437, 106, 1, 26, "Text"],
Cell[16921, 440, 2358, 56, 178, "Input"],
Cell[19282, 498, 107, 1, 26, "Text"],
Cell[19392, 501, 2210, 53, 178, "Input"],
Cell[21605, 556, 107, 1, 26, "Text"],
Cell[21715, 559, 3318, 75, 193, "Input"],
Cell[25036, 636, 108, 1, 26, "Text"],
Cell[25147, 639, 2966, 70, 193, "Input"],
Cell[28116, 711, 863, 19, 133, "Input"],
Cell[CellGroupData[{
Cell[29004, 734, 548, 9, 27, "Input"],
Cell[29555, 745, 1149, 17, 148, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
