(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     12667,        359]
NotebookOptionsPosition[     11471,        320]
NotebookOutlinePosition[     11809,        335]
CellTagsIndexPosition[     11766,        332]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestCPInternals"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.4007799481359367`*^9, 
   3.400779951401919*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "internal", " ", "functions", " ", 
     "of", " ", 
     RowBox[{"ConvexPolyhedra", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9, {3.4007799573634567`*^9, 3.4007799663949213`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.453207370900428*^9, 3.4532073718662167`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], ",", " ", 
   "\[IndentingNewLine]", "                ", 
   RowBox[{"Convex`ConvexPolyhedra", ".", "nb"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}, {
  3.40077997488339*^9, 3.400780011865028*^9}}],

Cell["\<\
This notebook contains tests for the internal functions of \
convexPolyhedroa.nb.\
\>", "Text",
 CellChangeTimes->{{3.399309980422974*^9, 3.399310002750619*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexPolyhedra`\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399310029264763*^9, 3.399310056211431*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", "=", 
   RowBox[{"Prepend", "[", 
    RowBox[{"$ContextPath", ",", "\"\<Convex`ConvexPolyhedra`Private`\>\""}], 
    " ", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399310062337722*^9, 3.399310102965436*^9}, {
  3.399310164036252*^9, 3.39931017089633*^9}, {3.399310217029313*^9, 
  3.399310221212981*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"upper1", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"5", ",", "4", ",", "3", ",", "2"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399310302255801*^9, 3.399310316043777*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"lower1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"5", "/", "2"}], ",", "2", ",", 
     RowBox[{"3", "/", "2"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399310322420567*^9, 3.3993103386526546`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToLowerSpace", "[", "upper1", "]"}], "\[Equal]", "lower1"}], 
       ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: ToLowerSpace gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: ToLowerSpace gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: ToLowerSpace unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399310368310656*^9, 3.3993104426856813`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"upper2", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lower2", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.399311130428484*^9, 3.39931115393246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Truncate", "[", "upper2", "]"}], "\[Equal]", "lower2"}], ",",
        "\[IndentingNewLine]", 
       "\"\<! Test 2: Truncate gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: Truncate gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: Truncate unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399311181593845*^9, 3.399311236246929*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lower3", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"upper3", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "1"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.399311277980199*^9, 3.3993112931727943`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToUpperSpace", "[", "lower3", "]"}], "\[Equal]", "upper3"}], 
       ",", "\[IndentingNewLine]", 
       "\"\<! Test 3: ToUpperSpace gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: ToUpperSpace gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: ToUpperSpace unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399311314749786*^9, 3.399311362723722*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lower4", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"upper4", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "0"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.399311277980199*^9, 3.3993112931727943`*^9}, {
  3.39931160183466*^9, 3.399311606161626*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToUpperSpace0", "[", "lower4", "]"}], "\[Equal]", "upper4"}],
        ",", "\[IndentingNewLine]", 
       "\"\<! Test 4: ToUpperSpace0 gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: ToUpperSpace0 gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: ToUpperSpace0 unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399311314749786*^9, 3.399311362723722*^9}, {
   3.3993116115550003`*^9, 3.399311635755766*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3", ",", "Test4"}], "}"}]], "Input",\

 CellChangeTimes->{{3.399310448167511*^9, 3.39931045106326*^9}, {
  3.399311257256959*^9, 3.399311258969331*^9}, {3.399311370548524*^9, 
  3.399311372949299*^9}, {3.399311645078371*^9, 3.399311646461957*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: ToLowerSpace gives expected result.\"\>", 
   ",", "\<\"! Test 2: Truncate gives expected result.\"\>", 
   ",", "\<\"! Test 3: ToUpperSpace gives expected result.\"\>", 
   ",", "\<\"! Test 4: ToUpperSpace0 gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.399310467082448*^9, 3.399310953693501*^9, 3.399311068992692*^9, {
   3.399311251926146*^9, 3.399311259564589*^9}, 3.3993113783748217`*^9, 
   3.3993115843206053`*^9, 3.399311650924127*^9, 3.453207375453906*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}}]
},
WindowSize->{640, 750},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 376, 7, 27, "Input"],
Cell[947, 30, 191, 4, 27, "Input"],
Cell[1141, 36, 396, 8, 58, "Input"],
Cell[1540, 46, 471, 10, 27, "Input"],
Cell[2014, 58, 270, 7, 27, "Input"],
Cell[2287, 67, 264, 6, 27, "Input"],
Cell[2554, 75, 219, 5, 27, "Input"],
Cell[2776, 82, 654, 15, 58, "Input"],
Cell[3433, 99, 459, 11, 43, "Input"],
Cell[3895, 112, 400, 9, 43, "Input"],
Cell[4298, 123, 171, 4, 26, "Text"],
Cell[4472, 129, 175, 4, 27, "Input"],
Cell[4650, 135, 360, 8, 27, "Input"],
Cell[5013, 145, 217, 5, 27, "Input"],
Cell[5233, 152, 251, 7, 27, "Input"],
Cell[5487, 161, 816, 18, 88, "Input"],
Cell[6306, 181, 363, 10, 43, "Input"],
Cell[6672, 193, 798, 18, 88, "Input"],
Cell[7473, 213, 346, 10, 43, "Input"],
Cell[7822, 225, 814, 18, 88, "Input"],
Cell[8639, 245, 394, 11, 43, "Input"],
Cell[9036, 258, 870, 19, 88, "Input"],
Cell[CellGroupData[{
Cell[9931, 281, 319, 6, 27, "Input"],
Cell[10253, 289, 548, 10, 73, "Output"]
}, Open  ]],
Cell[10816, 302, 651, 16, 88, "Input"]
}
]
*)

(* End of internal cache information *)
