(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     17148,        459]
NotebookOptionsPosition[     15896,        419]
NotebookOutlinePosition[     16234,        434]
CellTagsIndexPosition[     16191,        431]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestCPTests"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.4007799481359367`*^9, 
   3.400779951401919*^9}, {3.4007800893164062`*^9, 3.400780094294427*^9}, {
   3.400780155166551*^9, 3.400780156216282*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "functions", " ", "of", " ", 
     RowBox[{"ConvexPolyhedra", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9, {3.4007799573634567`*^9, 3.4007799663949213`*^9}, 
   3.400780102391849*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.453207403852276*^9, 3.453207404946691*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], ",", " ", 
   "\[IndentingNewLine]", "                ", 
   RowBox[{"Convex`ConvexPolyhedra", ".", "nb"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}, {
  3.40077997488339*^9, 3.400780011865028*^9}}],

Cell["\<\
This notebook ontains tests of PolyhedronContainsPoint, \
PolyhedronContainsRay, SubPolyhedron, and EqualPolyhedron.\
\>", "Text",
 CellChangeTimes->{{3.3994986567481413`*^9, 3.3994987135486383`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexPolyhedra`\>\"", "]"}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"polygen", " ", "=", " ", 
   RowBox[{"PolyhedronHull", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399498931830188*^9, 3.399498961350781*^9}, {
  3.399499010184286*^9, 3.399499057933175*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"polycon", " ", "=", " ", 
   RowBox[{"PolyhedronIntersection", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399499065085177*^9, 3.399499135732931*^9}, {
  3.3994991662777853`*^9, 3.399499299077187*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PolyhedronContainsPoint", "[", 
         RowBox[{"polygen", ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"1", "/", "2"}], ",", "0", ",", "0"}], "}"}]}], "]"}], 
        "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: PolyhedronContainsPoint gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test : PolyhedronContainsPoint gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test : PolyhedronContainsPoint unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399499362100605*^9, 3.399499463198204*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PolyhedronContainsPoint", "[", 
         RowBox[{"polygen", ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"3", "/", "2"}], ",", "0", ",", "0"}], "}"}]}], "]"}], 
        "\[Equal]", "False"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 2: PolyhedronContainsPoint gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 2: PolyhedronContainsPoint gives unexpected result.\>\""}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: PolyhedronContainsPoint unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.39949948051091*^9, 3.3994995261524*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PolyhedronContainsRay", "[", 
         RowBox[{"polygen", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "]"}], 
        "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 3: PolyhedronContainsRay gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: PolyhedronContainsRay gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: PolyhedronContainsRay unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399499547315503*^9, 3.399499617987254*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PolyhedronContainsRay", "[", 
         RowBox[{"polygen", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"1", "/", "10"}], ",", "1", ",", "0"}], "}"}]}], "]"}], 
        "\[Equal]", "False"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 4: PolyhedronContainsRay gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: PolyhedronContainsRay gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: PolyhedronContainsRay unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399499629176724*^9, 3.3994997098139153`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"squib", " ", "=", " ", 
   RowBox[{"PolyhedronHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399499739163612*^9, 3.39949975238398*^9}, {
  3.399499791830614*^9, 3.3994998104835176`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SubPolyhedron", "[", 
         RowBox[{"squib", ",", "polygen"}], "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 5: SubPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 5: SubPolyhedron gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: SubPolyhedron unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399499730852579*^9, 3.3994997333310747`*^9}, {
   3.399499828596404*^9, 3.39949988674684*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SubPolyhedron", "[", 
         RowBox[{"polygen", ",", "squib"}], "]"}], "\[Equal]", "False"}], ",",
        "\[IndentingNewLine]", 
       "\"\<! Test 6: SubPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 6: SubPolyhedron gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 6: SubPolyhedron unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399499898201639*^9, 3.399499945053355*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test7", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", 
         RowBox[{"polygen", ",", "polycon"}], "]"}], "\[Equal]", "True"}], 
       ",", "\[IndentingNewLine]", 
       "\"\<! Test 7: EqualPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 7: EqualPolyhedron gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 7: EqualPolyhedron unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.399499954168357*^9, 3.399499996398107*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test8", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", 
         RowBox[{"squib", ",", "polycon"}], "]"}], "\[Equal]", "False"}], ",",
        "\[IndentingNewLine]", 
       "\"\<! Test 8: EqualPolyhedron gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 8: EqualPolyhedron gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 8: EqualPolyhedron unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.3994999997097807`*^9, 3.399500049696323*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
   "Test6", ",", "Test7", ",", "Test8"}], "}"}]], "Input",
 CellChangeTimes->{{3.399500052115732*^9, 3.399500066544457*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: PolyhedronContainsPoint gives expected result.\"\>", 
   ",", "\<\"! Test 2: PolyhedronContainsPoint gives expected result.\"\>", 
   ",", "\<\"! Test 3: PolyhedronContainsRay gives expected result.\"\>", 
   ",", "\<\"! Test 4: PolyhedronContainsRay gives expected result.\"\>", 
   ",", "\<\"! Test 5: SubPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 6: SubPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 7: EqualPolyhedron gives expected result.\"\>", 
   ",", "\<\"! Test 8: EqualPolyhedron gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.3995000754805803`*^9, 3.399501164348461*^9, 
  3.399502205762802*^9, 3.453207409042429*^9}]
}, Open  ]]
},
WindowSize->{611, 752},
WindowMargins->{{8, Automatic}, {Automatic, 3}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 470, 8, 27, "Input"],
Cell[1041, 31, 191, 4, 27, "Input"],
Cell[1235, 37, 396, 8, 58, "Input"],
Cell[1634, 47, 474, 10, 27, "Input"],
Cell[2111, 59, 270, 7, 27, "Input"],
Cell[2384, 68, 262, 6, 27, "Input"],
Cell[2649, 76, 219, 5, 27, "Input"],
Cell[2871, 83, 654, 15, 73, "Input"],
Cell[3528, 100, 459, 11, 43, "Input"],
Cell[3990, 113, 400, 9, 43, "Input"],
Cell[4393, 124, 210, 4, 41, "Text"],
Cell[4606, 130, 109, 3, 27, "Input"],
Cell[4718, 135, 651, 16, 88, "Input"],
Cell[5372, 153, 689, 19, 43, "Input"],
Cell[6064, 174, 799, 22, 43, "Input"],
Cell[6866, 198, 1005, 22, 103, "Input"],
Cell[7874, 222, 1005, 22, 103, "Input"],
Cell[8882, 246, 966, 21, 88, "Input"],
Cell[9851, 269, 1003, 22, 103, "Input"],
Cell[10857, 293, 528, 15, 27, "Input"],
Cell[11388, 310, 902, 20, 88, "Input"],
Cell[12293, 332, 852, 19, 88, "Input"],
Cell[13148, 353, 861, 19, 88, "Input"],
Cell[14012, 374, 862, 19, 88, "Input"],
Cell[CellGroupData[{
Cell[14899, 397, 237, 5, 27, "Input"],
Cell[15139, 404, 741, 12, 133, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
