(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     15810,        431]
NotebookOptionsPosition[     14648,        393]
NotebookOutlinePosition[     14986,        408]
CellTagsIndexPosition[     14943,        405]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestCPTransform"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.4007799481359367`*^9, 
   3.400779951401919*^9}, {3.4007800893164062`*^9, 3.400780094294427*^9}, {
   3.400780180791087*^9, 3.400780182393476*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "functions", " ", "of", " ", 
     RowBox[{"ConvexPolyhedra", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9, {3.4007799573634567`*^9, 3.4007799663949213`*^9}, 
   3.400780102391849*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.4532074297397003`*^9, 3.453207430634886*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], ",", " ", 
   "\[IndentingNewLine]", "                ", 
   RowBox[{"Convex`ConvexPolyhedra", ".", "nb"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}, {
  3.40077997488339*^9, 3.400780011865028*^9}}],

Cell["\<\
This notebook contains test of TransformGeneratorsOfPolyhedron, \
ProjectPolyhedonAlongAxis, and IntersectPolyhedronWithHyperplane.\
\>", "Text",
 CellChangeTimes->{{3.3996390875622597`*^9, 3.399639148426566*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexPolyhedra`\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399412715538001*^9, 3.399412760597102*^9}, {
   3.399413372208364*^9, 3.399413377160315*^9}, 3.3995761137200727`*^9}],

Cell["TransformGeneratorsOfPolyhedron", "Text",
 CellChangeTimes->{{3.399639205658124*^9, 3.399639214570704*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"slot", "=", 
   RowBox[{"PolyhedronHull", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399639616024603*^9, 3.3996397118879423`*^9}, {
  3.39963977196769*^9, 3.399639786161558*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"transform", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.399639799217536*^9, 3.399639831924241*^9}, {
  3.399640505369481*^9, 3.3996405172820177`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"translate", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.399639836659647*^9, 3.399639845930625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"newSlot", "=", 
   RowBox[{"PolyhedronIntersection", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", 
         RowBox[{"-", "3"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", "0", ",", "0", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39963985821813*^9, 3.399639942454957*^9}, {
  3.399639984422059*^9, 3.399639992667678*^9}, {3.3996401610715322`*^9, 
  3.399640211457816*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TransformGeneratorsOfPolyhedron", "[", 
           RowBox[{"slot", ",", "transform", ",", "translate"}], "]"}], ",", 
          "\[IndentingNewLine]", "newSlot"}], "\[IndentingNewLine]", "]"}], 
        "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: TransformGeneratorsOfPolyhedron gives expected \
result.\>\"", ",", "\[IndentingNewLine]", 
       "\"\<? Test 1: TransformGeneratorsOfPolyhedron gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 1: TransformGeneratorsOfPolyhedronb unexpectedly \
Throws.\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399592192960168*^9, {3.399640236385434*^9, 
   3.399640305850232*^9}, 3.399640571310725*^9}],

Cell["ProjectPolyhedronAlongAxis", "Text",
 CellChangeTimes->{{3.399640878014112*^9, 3.399640887864367*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ProjectPolyhedronAlongAxis", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "0", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
            ",", "\[IndentingNewLine]", "3"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 2: ProjectPolyhedronAlongAxis gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 2: ProjectPolyhedronAlongAxis gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 2: ProjectPolyhedronAlongAxis unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399592192960168*^9, {3.399640935558298*^9, 
   3.399640961060314*^9}, {3.3996410235069237`*^9, 3.3996412615672092`*^9}}],

Cell["IntersectPolyhedronWithHyperplane", "Text",
 CellChangeTimes->{{3.399641338421173*^9, 3.399641347735063*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualPolyhedron", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "IntersectPolyhedronWithHyperplane", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PolyhedronHull", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "2"}], ",", "0", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "0", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"-", "2"}], ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "2", ",", "1"}], "}"}]}], "}"}]}], "]"}], 
            ",", "\[IndentingNewLine]", "3"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PolyhedronHull", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 3: IntersectPolyhedronWithHyperplane gives expected \
result.\>\"", ",", "\[IndentingNewLine]", 
       "\"\<? Test 3: IntersectPolyhedronWithHyperplane gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 3: IntersectPolyhedronWithHyperplane unexpectedly \
Throws.\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, 3.399592192960168*^9, {3.3996413607300043`*^9, 
   3.3996413788654423`*^9}, {3.3996414545368633`*^9, 3.3996415881936407`*^9}}],\


Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3"}], "}"}]], "Input",
 CellChangeTimes->{{3.399640311293621*^9, 3.399640313788053*^9}, {
  3.399641268727429*^9, 3.3996412710236893`*^9}, {3.399641591393922*^9, 
  3.399641593016203*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: TransformGeneratorsOfPolyhedron gives expected \
result.\"\>", 
   ",", "\<\"! Test 2: ProjectPolyhedronAlongAxis gives expected result.\"\>",
    ",", "\<\"! Test 3: IntersectPolyhedronWithHyperplane gives expected \
result.\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.399640331715282*^9, 3.399640415428298*^9, 
  3.399640523638411*^9, 3.399640794254044*^9, 3.39964127503519*^9, 
  3.3996415954257927`*^9, 3.4532074368612823`*^9}]
}, Open  ]]
},
WindowSize->{626, 765},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 474, 8, 27, "Input"],
Cell[1045, 31, 191, 4, 27, "Input"],
Cell[1239, 37, 396, 8, 58, "Input"],
Cell[1638, 47, 474, 10, 27, "Input"],
Cell[2115, 59, 270, 7, 27, "Input"],
Cell[2388, 68, 264, 6, 27, "Input"],
Cell[2655, 76, 219, 5, 27, "Input"],
Cell[2877, 83, 654, 15, 58, "Input"],
Cell[3534, 100, 459, 11, 43, "Input"],
Cell[3996, 113, 400, 9, 43, "Input"],
Cell[4399, 124, 223, 4, 41, "Text"],
Cell[4625, 130, 249, 5, 27, "Input"],
Cell[4877, 137, 113, 1, 26, "Text"],
Cell[4993, 140, 677, 19, 43, "Input"],
Cell[5673, 161, 579, 16, 27, "Input"],
Cell[6255, 179, 210, 5, 27, "Input"],
Cell[6468, 186, 879, 24, 43, "Input"],
Cell[7350, 212, 1155, 24, 163, "Input"],
Cell[8508, 238, 108, 1, 26, "Text"],
Cell[8619, 241, 2508, 60, 178, "Input"],
Cell[11130, 303, 115, 1, 26, "Text"],
Cell[11248, 306, 2606, 63, 208, "Input"],
Cell[CellGroupData[{
Cell[13881, 374, 260, 5, 27, "Input"],
Cell[14144, 381, 488, 9, 58, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
