(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     41386,       1042]
NotebookOptionsPosition[     38173,        940]
NotebookOutlinePosition[     38535,        956]
CellTagsIndexPosition[     38492,        953]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestDimVet"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}}],\


Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "internal", " ", "functions", " ", 
     "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains tests of the functions DimVet and DimVetOne in \
ConvexCones`Private.\
\>", "Text",
 CellChangeTimes->{{3.397669851412466*^9, 3.397669889136904*^9}, {
  3.397770754556603*^9, 3.397770775363179*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.3976702929669533`*^9, 3.397670329250162*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SaveContextPath", " ", "=", " ", "$ContextPath"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397670949157873*^9, 3.39767096293219*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", "=", 
   RowBox[{"Append", "[", 
    RowBox[{"$ContextPath", ",", "\"\<Convex`ConvexCones`Private`\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397670343821027*^9, 3.397670391460298*^9}}],

Cell[CellGroupData[{

Cell["\<\
Test 1. If the first argument is not a list, then DimVet should Throw[2, \
notLists].\
\>", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976736130603867`*^9, 3.397673664286235*^9}, {
   3.397673708010441*^9, 3.397673732701839*^9}, 3.39767985524791*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"17", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"4", ",", "5", ",", "6"}], "}"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\"\<? Test 1: DimVet did not throw.\>\""}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "3"}], ")"}], ",", 
           "\"\<! Test 1: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           "\"\<? Test 1: DimVet did not throw expected value\>\""}], "]"}], 
         ")"}], "&"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, 3.397679937891914*^9, {3.397680081404677*^9, 
   3.397680145991152*^9}, {3.3976802016066008`*^9, 3.39768020868049*^9}, 
   3.3976803055267477`*^9, 3.397680407380739*^9, 3.397682460102992*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 2. If the first argument is not a list, then DimVet should Throw[2, \
notLists].\
\>", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976736130603867`*^9, 3.397673664286235*^9}, {
  3.397673708010441*^9, 3.397673732701839*^9}, {3.39767985524791*^9, 
  3.39767989053297*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", "17"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        "\"\<? Test 2: DimVet did not throw.\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "3"}], ")"}], ",", 
           "\"\<! Test 2: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           "\"\<? Test 2: DimVet did not throw expected value\>\""}], "]"}], 
         ")"}], "&"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.3976800266964893`*^9, 
   3.397680029587291*^9}, {3.397680221184318*^9, 3.397680311766818*^9}, 
   3.39768041092507*^9, 3.3976824790334597`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 3. If both arguments are empty, then DimVet shoulf Throw[3, emptyArgs].\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\"\<? Test3: DimVet did not throw.\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "emptyArgs", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "3"}], ")"}], ",", 
           "\"\<! Test 3: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           "\"\<? Test 3: DimVet did not throw expected value\>\""}], "]"}], 
         ")"}], "&"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 4. If some contents of an argument is not a list, DimVet should \
Throw[2,notLists].\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}, {
  3.397680630126205*^9, 3.3976806902811823`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{
          RowBox[{"{", "17", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", "}"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\"\<? Test4: DimVet did not throw.\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "2"}], ")"}], ",", 
           "\"\<! Test 4: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           "\"\<? Test 4: DimVet did not throw expected value\>\""}], "]"}], 
         ")"}], "&"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680697110141*^9, 
   3.397680746247211*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 5. If contents of lists are not of uniform length, DimVet should \
Throw[d,notUniform]
where d is derived from the first element of the first argument.\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}, {
   3.397680888194809*^9, 3.397680955710836*^9}, 3.397681126597241*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "1", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\"\<? Test5: DimVet did not throw.\>\""}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "notUniform", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "2"}], ")"}], ",", 
           "\"\<! Test 5: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 5: DimVet did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.3976831893854113`*^9, 3.397683193095949*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 6. If contents are of uniform length, DimVet should return that length.\
\>", "Text",
 CellChangeTimes->{{3.3976811013889837`*^9, 3.39768113769162*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"3", "==", 
        RowBox[{"DimVet", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"4", ",", "5", ",", "6"}], "}"}]}], "}"}]}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       "\"\<! Test 6: DimVet gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 6: DimVet gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 6: DimVet unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 7. In 3-argument call, if second argument is not a list, \
Throw[Null,notList]\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}, {
   3.397680888194809*^9, 3.397680955710836*^9}, 3.397681126597241*^9, {
   3.3976828460090227`*^9, 3.397682885223411*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test7", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"2", ",", "17", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "1", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\"\<? Test 7: DimVet did not throw.\>\""}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "===", "Null"}], ")"}], ",", 
           "\"\<! Test 7: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 7: DimVet did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 7: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.397682893371056*^9, 3.397682914221439*^9}, {
   3.397683021775069*^9, 3.39768304312991*^9}, {3.397683156183303*^9, 
   3.397683160429929*^9}, {3.3976841096817217`*^9, 3.3976841116892853`*^9}, {
   3.3976844361868677`*^9, 3.397684440371502*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 8. In 3-argument call, if third argument is not a list, \
Throw[Null,notList].\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}, {
   3.397680888194809*^9, 3.397680955710836*^9}, 3.397681126597241*^9, {
   3.397683058613516*^9, 3.397683082389464*^9}, 3.397684034668119*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test8", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", "17"}], "]"}], ";",
         "\[IndentingNewLine]", "\"\<? Test8: DimVet did not throw.\>\""}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "Null"}], ")"}], ",", 
           "\"\<! Test 8: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 8: DimVet did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 8: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.3976830919833803`*^9, 3.397683133644682*^9}, {
   3.397683166030559*^9, 3.397683171118684*^9}, {3.397684083097556*^9, 
   3.397684092278241*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 9. In 3-argument call, if some element of second or third argument is \
not a list, Throw[Null,notList].\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}, {
   3.397680888194809*^9, 3.397680955710836*^9}, 3.397681126597241*^9, {
   3.397683058613516*^9, 3.397683082389464*^9}, {3.3976832567862473`*^9, 
   3.397683282548398*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test9", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", "12"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "1", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\"\<? Test 9: DimVet did not throw.\>\""}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "Null"}], ")"}], ",", 
           "\"\<! Test 9: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 9: DimVet did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 9: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.3976830919833803`*^9, 3.397683133644682*^9}, {
   3.397683166030559*^9, 3.397683171118684*^9}, {3.3976840082677727`*^9, 
   3.3976840132789097`*^9}, {3.397684055491106*^9, 3.39768406148874*^9}, {
   3.397684120643236*^9, 3.3976841375962753`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 10. In 3-argument call, if some element of second or third argument is \
not of length d, Throw[Null,notUniform].\
\>", "Text",
 CellChangeTimes->{{3.397679959619302*^9, 3.397680009873975*^9}, {
   3.397680888194809*^9, 3.397680955710836*^9}, 3.397681126597241*^9, {
   3.397683058613516*^9, 3.397683082389464*^9}, {3.3976832567862473`*^9, 
   3.397683282548398*^9}, {3.3976841700301657`*^9, 3.3976841988873568`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test10", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVet", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "1", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\"\<? Test 10: DimVet did not throw.\>\""}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "notUniform", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "Null"}], ")"}], ",", 
           "\"\<! Test 10: DimVet acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 10: DimVet did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 10: DimVet did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.3976830919833803`*^9, 3.397683133644682*^9}, {
   3.397683166030559*^9, 3.397683171118684*^9}, {3.3976840082677727`*^9, 
   3.3976840132789097`*^9}, {3.397684055491106*^9, 3.39768406148874*^9}, {
   3.397684120643236*^9, 3.3976841375962753`*^9}, {3.3976842063592367`*^9, 
   3.397684237414588*^9}, {3.397684825056238*^9, 3.397684831176777*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 11. If contents are of uniform length d, DimVet should return Null.\
\>", "Text",
 CellChangeTimes->{{3.3976811013889837`*^9, 3.39768113769162*^9}, {
  3.397684271272591*^9, 3.39768428077814*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test11", " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Null", "==", 
        RowBox[{"DimVet", "[", 
         RowBox[{"3", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"4", ",", "5", ",", "6"}], "}"}]}], "}"}]}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       "\"\<! Test 11: DimVet gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 11: DimVet gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 11: DimVet unexpectedly Threw.\>\""}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
  3.3976842908463287`*^9, 3.397684317149678*^9}}]
}, Open  ]],

Cell["Tests of DimVetOne", "Text",
 CellChangeTimes->{{3.397768315119253*^9, 3.397768321360503*^9}}],

Cell[CellGroupData[{

Cell["\<\
Test 12. If the second argument is not a list, Throw[Null, notLists]\
\>", "Text",
 CellChangeTimes->{{3.397768330253305*^9, 3.397768360969824*^9}, 
   3.39776850102346*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test12", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVetOne", "[", 
         RowBox[{"2", ",", "17"}], "]"}], ";", "\[IndentingNewLine]", 
        "\"\<? Test 12: DimVetOne did not throw.\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "notLists", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "Null"}], ")"}], ",", 
           "\"\<! Test 12: DimVetOne acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 12: DimVetOne did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 12: DimVetOne did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.3976830919833803`*^9, 3.397683133644682*^9}, {
   3.397683166030559*^9, 3.397683171118684*^9}, {3.3976840082677727`*^9, 
   3.3976840132789097`*^9}, {3.397684055491106*^9, 3.39768406148874*^9}, {
   3.397684120643236*^9, 3.3976841375962753`*^9}, {3.3976842063592367`*^9, 
   3.397684237414588*^9}, {3.397684825056238*^9, 3.397684831176777*^9}, {
   3.397768383914866*^9, 3.3977684665853653`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 13. If the second argument is the wrong length, Throw[Null, \
wrongDimension]\
\>", "Text",
 CellChangeTimes->{{3.397768330253305*^9, 3.397768360969824*^9}, {
  3.397768497077372*^9, 3.397768538576627*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test13", ":=", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Catch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"DimVetOne", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        "\"\<? Test 13: DimVetOne did not throw.\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "wrongDimension", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "Null"}], ")"}], ",", 
           "\"\<! Test 13: DimVetOne acted as expected\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<? Test 13: DimVetOne did not throw expected value\>\"", ",", 
             "#1"}], "}"}]}], "]"}], ")"}], "&"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 13: DimVetOne did not throw expected tag\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3976737418821373`*^9, 3.397673800682355*^9}, {
   3.3976792342327223`*^9, 3.397679351632247*^9}, {3.397679422715376*^9, 
   3.397679540295742*^9}, {3.397679737531513*^9, 3.397679822850795*^9}, 
   3.3976798552482224`*^9, {3.3976798955711737`*^9, 3.397679901564145*^9}, {
   3.3976799329651012`*^9, 3.397679941793643*^9}, {3.397680039170103*^9, 
   3.397680044624761*^9}, {3.3976803165808153`*^9, 3.397680424003656*^9}, {
   3.397680467600896*^9, 3.397680507988858*^9}, {3.397680855414795*^9, 
   3.397680880330633*^9}, {3.397680965085209*^9, 3.3976809917103777`*^9}, {
   3.397682111432983*^9, 3.3976821291191177`*^9}, {3.397682574618984*^9, 
   3.3976825773157997`*^9}, {3.3976830919833803`*^9, 3.397683133644682*^9}, {
   3.397683166030559*^9, 3.397683171118684*^9}, {3.3976840082677727`*^9, 
   3.3976840132789097`*^9}, {3.397684055491106*^9, 3.39768406148874*^9}, {
   3.397684120643236*^9, 3.3976841375962753`*^9}, {3.3976842063592367`*^9, 
   3.397684237414588*^9}, {3.397684825056238*^9, 3.397684831176777*^9}, {
   3.397768383914866*^9, 3.3977684665853653`*^9}, {3.397768545468216*^9, 
   3.397768595014638*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Test 14. If contents are of correct length, DimVetOne should return Null.\
\>", "Text",
 CellChangeTimes->{{3.3976811013889837`*^9, 3.39768113769162*^9}, {
  3.397684271272591*^9, 3.39768428077814*^9}, {3.397768700003625*^9, 
  3.3977687187410927`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test14", " ", ":=", " ", 
   RowBox[{"Catch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Null", "===", 
        RowBox[{"DimVetOne", "[", 
         RowBox[{"3", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 14: DimVetOne gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 14: DimVetOne gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 14: DimVet unexpectedly Threw.\>\""}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
  3.3976842908463287`*^9, 3.397684317149678*^9}, {3.397768727552236*^9, 
  3.397768774672081*^9}, {3.397768824825625*^9, 3.397768844400436*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{"{", 
   RowBox[{
   "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
    "Test6", ",", "\[IndentingNewLine]", "Test7", ",", "Test8", ",", "Test9", 
    ",", "Test10", ",", "Test11", ",", "\[IndentingNewLine]", "Test12", ",", 
    "Test13", ",", "Test14"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.397682005352992*^9, 3.397682040586699*^9}, {
  3.39768432410524*^9, 3.397684338881534*^9}, {3.397768780844515*^9, 
  3.397768788504578*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"! Test 1: DimVet acted as expected\"\>"},
     {"\<\"! Test 2: DimVet acted as expected\"\>"},
     {"\<\"! Test 3: DimVet acted as expected\"\>"},
     {"\<\"! Test 4: DimVet acted as expected\"\>"},
     {"\<\"! Test 5: DimVet acted as expected\"\>"},
     {"\<\"! Test 6: DimVet gave expected result.\"\>"},
     {"\<\"! Test 7: DimVet acted as expected\"\>"},
     {"\<\"! Test 8: DimVet acted as expected\"\>"},
     {"\<\"! Test 9: DimVet acted as expected\"\>"},
     {"\<\"! Test 10: DimVet acted as expected\"\>"},
     {"\<\"! Test 11: DimVet gave expected result.\"\>"},
     {"\<\"! Test 12: DimVetOne acted as expected\"\>"},
     {"\<\"! Test 13: DimVetOne acted as expected\"\>"},
     {"\<\"! Test 14: DimVetOne gave expected result.\"\>"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.397682050664913*^9, 3.397682150510647*^9, 3.397682363091023*^9, 
   3.3976826119887447`*^9, 3.397684361677104*^9, 3.3976845593011007`*^9, 
   3.39768485522278*^9, 3.397768798200591*^9, {3.39776883375909*^9, 
   3.397768858472921*^9}, 3.397769023612939*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", " ", "=", " ", "SaveContextPath"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397670969824622*^9, 3.39767098391678*^9}}]
},
CellGrouping->Manual,
WindowSize->{640, 750},
WindowMargins->{{12, Automatic}, {Automatic, 24}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 267, 5, 27, "Input"],
Cell[840, 29, 191, 4, 27, "Input"],
Cell[1034, 35, 396, 8, 58, "Input"],
Cell[1433, 45, 391, 9, 27, "Input"],
Cell[1827, 56, 270, 7, 27, "Input"],
Cell[2100, 65, 202, 5, 27, "Input"],
Cell[2305, 72, 219, 5, 27, "Input"],
Cell[2527, 79, 654, 15, 58, "Input"],
Cell[3184, 96, 459, 11, 43, "Input"],
Cell[3646, 109, 228, 5, 27, "Input"],
Cell[3877, 116, 231, 5, 26, "Text"],
Cell[4111, 123, 172, 4, 27, "Input"],
Cell[4286, 129, 169, 4, 27, "Input"],
Cell[4458, 135, 253, 6, 27, "Input"],
Cell[CellGroupData[{
Cell[4736, 145, 301, 6, 26, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5040, 153, 1746, 38, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[6823, 196, 326, 7, 26, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[7152, 205, 1812, 40, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[9001, 250, 166, 3, 26, "Text"],
Cell[9170, 255, 1637, 35, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[10844, 295, 230, 5, 26, "Text"],
Cell[11077, 302, 1724, 37, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[12838, 344, 318, 6, 41, "Text"],
Cell[13159, 352, 2268, 49, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[15464, 406, 167, 3, 26, "Text"],
Cell[15634, 411, 1141, 29, 118, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16812, 445, 297, 6, 26, "Text"],
Cell[17112, 453, 2278, 46, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[19427, 504, 317, 6, 26, "Text"],
Cell[19747, 512, 2217, 46, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[22001, 563, 373, 7, 26, "Text"],
Cell[22377, 572, 2415, 50, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[24829, 627, 432, 7, 41, "Text"],
Cell[25264, 636, 2586, 53, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[27887, 694, 211, 4, 26, "Text"],
Cell[28101, 700, 1209, 30, 118, "Input"]
}, Open  ]],
Cell[29325, 733, 100, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[29450, 738, 183, 4, 26, "Text"],
Cell[29636, 744, 2282, 43, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[31955, 792, 221, 5, 26, "Text"],
Cell[32179, 799, 2419, 47, 193, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[34635, 851, 263, 5, 26, "Text"],
Cell[34901, 858, 943, 21, 118, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35881, 884, 518, 10, 58, "Input"],
Cell[36402, 896, 1583, 35, 263, "Output"]
}, Open  ]],
Cell[38000, 934, 169, 4, 27, "Input"]
}
]
*)

(* End of internal cache information *)
