(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     50555,       1216]
NotebookOptionsPosition[     48447,       1147]
NotebookOutlinePosition[     48807,       1163]
CellTagsIndexPosition[     48764,       1160]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestMajor"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779137870203*^9, 3.400779139343587*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "internal", " ", "functions", " ", 
     "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains unit tests for major functions inn ConvexCone.nb. FME, \
AddDescriptor, and AddDescriptions are tested.\
\>", "Text",
 CellChangeTimes->{{3.398029343051496*^9, 3.398029387455433*^9}, {
  3.39819375304007*^9, 3.398193764129745*^9}, {3.399312053962125*^9, 
  3.3993120594407997`*^9}, {3.3993121110313873`*^9, 3.3993121250981903`*^9}, {
  3.399312423991268*^9, 3.3993124247242126`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397770787542433*^9, 3.397770806006796*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SaveContextPath", " ", "=", " ", "$ContextPath"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397670949157873*^9, 3.39767096293219*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", "=", 
   RowBox[{"Prepend", "[", 
    RowBox[{"$ContextPath", ",", "\"\<Convex`ConvexCones`Private`\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397670343821027*^9, 3.397670391460298*^9}, {
  3.397770853039165*^9, 3.397770853752977*^9}}],

Cell[CellGroupData[{

Cell["FME", "Text",
 CellChangeTimes->{{3.398099010555131*^9, 3.398099016854254*^9}, {
  3.3980990518212967`*^9, 3.398099093737174*^9}, {3.398194942332872*^9, 
  3.398194943543046*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"primaryHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2", ",", "1", ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "2"}], ",", "0", ",", "1", ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "2"}], ",", "1", ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0", ",", "1", ",", 
              RowBox[{"-", "3"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}], ",", "0", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", 
              RowBox[{"-", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", 
              RowBox[{"-", "2"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"secondaryHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2", ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "2"}], ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "2"}], ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newPrimary", "=", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"result", " ", "=", " ", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "/", "2"}], ",", 
               RowBox[{"3", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "/", "2"}], ",", 
               RowBox[{"1", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}], ",", 
               RowBox[{"3", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], "/", "2"}], ",", 
               RowBox[{"1", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "3"}], "/", "2"}], ",", 
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}], ",", "0", ",", "1"}], "}"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}], ",", 
               RowBox[{
                RowBox[{"-", "3"}], "/", "2"}], ",", "0", ",", "1"}], "}"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "/", "2"}], ",", 
               RowBox[{
                RowBox[{"-", "3"}], "/", "2"}], ",", "0", ",", "1"}], "}"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "/", "2"}], ",", 
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}], ",", "0", ",", "1"}], "}"}]}],
             "\[IndentingNewLine]", "}"}], "*", "2"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"minDim", "=", "2"}]}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FME", "[", 
           RowBox[{
           "primaryHalf", ",", "secondaryHalf", ",", "newPrimary", ",", 
            "minDim"}], "]"}], " ", "\[Equal]", " ", "result"}], ",", 
         "\[IndentingNewLine]", "\"\<! Test 1: FME gave expected result.\>\"",
          ",", "\[IndentingNewLine]", 
         "\"\<? Test 1: FME gave unexpected result.\>\""}], "]"}]}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: FME unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
AddDescriptor
This is the crux of the whole package. I think that testing this big fat \
\"unit\" should be divided into several parts.\
\>", "Text",
 CellChangeTimes->{{3.398205180709065*^9, 3.398205276887191*^9}}],

Cell[CellGroupData[{

Cell["\<\
AddDescriptor: the new primary saturates all secondary descriptors.\
\>", "Text",
 CellChangeTimes->{{3.398205288059362*^9, 3.398205325713022*^9}, 
   3.398205506103819*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"primFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"primHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "1"}]}], "}"}], "\[IndentingNewLine]", "}"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"newDescriptor", "=", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", 
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "\[IndentingNewLine]", 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AddDescriptor", "[", 
           RowBox[{"4", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}], ",",
             "newDescriptor", ",", "True"}], "]"}], " ", "\[Equal]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}]}], ",",
          "\[IndentingNewLine]", 
         "\"\<! Test 2: AddDescriptor gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 2: AddDescriptor gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: AddDescriptor unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}, {3.398248474770553*^9, 3.3982485089559717`*^9}, {
   3.398248601311475*^9, 3.398248841101098*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
AddDescriptor: a full secondary descriptor is not saturated. The new primary \
descriptor is full.\
\>", "Text",
 CellChangeTimes->{{3.398205334005828*^9, 3.398205366130392*^9}, {
   3.39820543057275*^9, 3.39820543916494*^9}, 3.39820550772045*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"primFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"primHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newDescriptor", "=", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newPrimFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newPrimHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}]}],
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AddDescriptor", "[", 
           RowBox[{"4", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}], ",",
             "newDescriptor", ",", "True"}], "]"}], " ", "\[Equal]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"newPrimFull", ",", "newPrimHalf"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"newSecondFull", ",", "newSecondHalf"}], "}"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", 
         "\"\<! Test 3: AddDescriptor gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 3: AddDescriptor gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: AddDescriptor unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}, {3.398248474770553*^9, 3.3982485089559717`*^9}, {
   3.398248601311475*^9, 3.398248841101098*^9}, {3.398290244246571*^9, 
   3.398290522297192*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
AddDescriptor: a full secondary descriptor is not saturated. The new primary \
descriptor is half\
\>", "Text",
 CellChangeTimes->{{3.398205451741541*^9, 3.39820552388169*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"primFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"primHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newDescriptor", "=", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newPrimFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newPrimHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "\[IndentingNewLine]", 
           "}"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AddDescriptor", "[", 
           RowBox[{"4", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}], ",",
             "newDescriptor", ",", "False"}], "]"}], " ", "\[Equal]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"newPrimFull", ",", "newPrimHalf"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"newSecondFull", ",", "newSecondHalf"}], "}"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", 
         "\"\<! Test 4: AddDescriptor gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 4: AddDescriptor gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: AddDescriptor unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}, {3.398248474770553*^9, 3.3982485089559717`*^9}, {
   3.398248601311475*^9, 3.398248841101098*^9}, {3.398290244246571*^9, 
   3.398290522297192*^9}, {3.398291837031604*^9, 3.398291913216648*^9}, 
   3.398382864501652*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
AddDescriptor: a half secondary descriptor is the first one not saturated.  \
The new primary descriptor is full.\
\>", "Text",
 CellChangeTimes->{{3.398205451741541*^9, 3.3982055794107227`*^9}, {
  3.3982056135808773`*^9, 3.398205614603414*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"primFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"primHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"secondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newDescriptor", "=", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newPrimFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newPrimHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}]}],
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AddDescriptor", "[", 
           RowBox[{"4", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}], ",",
             "newDescriptor", ",", "True"}], "]"}], " ", "\[Equal]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"newPrimFull", ",", "newPrimHalf"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"newSecondFull", ",", "newSecondHalf"}], "}"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", 
         "\"\<! Test 5: AddDescriptor gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 5: AddDescriptor gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: AddDescriptor unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}, {3.398248474770553*^9, 3.3982485089559717`*^9}, {
   3.398248601311475*^9, 3.398248841101098*^9}, {3.398290244246571*^9, 
   3.398290522297192*^9}, {3.398291837031604*^9, 3.398291913216648*^9}, {
   3.3983828465075197`*^9, 3.398383030113946*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
AddDescriptor : a half secondary descriptor is the first one not saturated.  \
The new primary descriptor is half.\
\>", "Text",
 CellChangeTimes->{{3.3982055710778513`*^9, 3.3982056288834877`*^9}, 
   3.398383198143042*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"primFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"primHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"secondFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"secondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newDescriptor", "=", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newPrimFull", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newPrimHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondFull", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newSecondHalf", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}], ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}]}],
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AddDescriptor", "[", 
           RowBox[{"4", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"primFull", ",", "primHalf"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"secondFull", ",", "secondHalf"}], "}"}]}], "}"}], ",",
             "newDescriptor", ",", "False"}], "]"}], " ", "\[Equal]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"newPrimFull", ",", "newPrimHalf"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"newSecondFull", ",", "newSecondHalf"}], "}"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", 
         "\"\<! Test 6: AddDescriptor gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 6: AddDescriptor gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 6: AddDescriptor unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}, {3.398248474770553*^9, 3.3982485089559717`*^9}, {
   3.398248601311475*^9, 3.398248841101098*^9}, {3.398290244246571*^9, 
   3.398290522297192*^9}, {3.398291837031604*^9, 3.398291913216648*^9}, {
   3.3983828465075197`*^9, 3.398383030113946*^9}, {3.398383552457562*^9, 
   3.398383614460025*^9}, {3.398383646097149*^9, 3.398383671199258*^9}, {
   3.398383791101285*^9, 3.398383792237755*^9}, 3.398383965363619*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AddDescriptions", "Text",
 CellChangeTimes->{{3.398524560884377*^9, 3.3985245670555162`*^9}, {
  3.399312327983467*^9, 3.399312329640718*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test7", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "primaryHalf", ",", "primaryFull", ",", "secondaryFull", ",", 
         "secondaryHalf", ",", "\[IndentingNewLine]", "primary", ",", 
         "secondary", ",", "descriptions1", ",", "newPrimaryFull", ",", 
         "newprimaryHalf", ",", "result"}], "}"}], ",", "\[IndentingNewLine]",
        
       RowBox[{
        RowBox[{"primaryHalf", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"primaryFull", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"secondaryFull", "=", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
          "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"secondaryHalf", "=", 
         RowBox[{"{", "}"}]}], ";", 
        RowBox[{"primary", "=", 
         RowBox[{"{", 
          RowBox[{"primaryFull", ",", "primaryHalf"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"secondary", "=", 
         RowBox[{"{", 
          RowBox[{"secondaryFull", ",", "secondaryHalf"}], "}"}]}], ";", 
        RowBox[{"descriptions1", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{"primary", ",", "secondary"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"newPrimaryFull", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"newPrimaryHalf", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"result", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}],
             "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}]}], 
              "}"}]}], "}"}]}], "}"}]}], ";", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"AddDescriptions", "[", 
            RowBox[{"4", ",", "descriptions1", ",", 
             RowBox[{"{", 
              RowBox[{"newPrimaryFull", ",", "newPrimaryHalf"}], "}"}]}], 
            "]"}], "==", "result"}], ",", "\[IndentingNewLine]", 
          "\"\<! Test 7: AddDescriptions gave expected result.\>\"", ",", 
          "\[IndentingNewLine]", 
          "\"\<? Test 7: AddDescriptions gave unexpected result.\>\""}], 
         "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 7: AddDescriptions unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398194995345936*^9, 3.398195021553445*^9}, {
   3.398195062953438*^9, 3.3981952464748507`*^9}, {3.3981952822767153`*^9, 
   3.3981953701477222`*^9}, {3.3981956750764008`*^9, 3.398195838961953*^9}, 
   3.398196377266019*^9, 3.398196803044541*^9, 3.398197322736578*^9, {
   3.398198199400367*^9, 3.398198262989085*^9}, {3.3981984389543457`*^9, 
   3.398198440078661*^9}, {3.398248474770553*^9, 3.3982485089559717`*^9}, {
   3.398248601311475*^9, 3.398248841101098*^9}, {3.398290244246571*^9, 
   3.398290522297192*^9}, {3.398291837031604*^9, 3.398291913216648*^9}, {
   3.3983828465075197`*^9, 3.398383030113946*^9}, {3.398383552457562*^9, 
   3.398383614460025*^9}, {3.398383646097149*^9, 3.398383671199258*^9}, {
   3.398383791101285*^9, 3.398383792237755*^9}, 3.398383965363619*^9, {
   3.398524602698175*^9, 3.3985250519667664`*^9}, {3.398525135243286*^9, 
   3.398525156330152*^9}, {3.399312334907452*^9, 3.399312364209475*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
   "Test6", ",", "Test7"}], "}"}]], "Input",
 CellChangeTimes->{{3.398195027719287*^9, 3.398195038071621*^9}, {
  3.3982488535639467`*^9, 3.3982488554409037`*^9}, {3.398290544148211*^9, 
  3.398290546149338*^9}, {3.398291950836563*^9, 3.398291952554482*^9}, {
  3.3983831464973507`*^9, 3.398383148416798*^9}, {3.398383687651576*^9, 
  3.398383693160098*^9}, {3.398525099388899*^9, 3.398525101196457*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: FME gave expected result.\"\>", 
   ",", "\<\"! Test 2: AddDescriptor gave expected result.\"\>", 
   ",", "\<\"! Test 3: AddDescriptor gave expected result.\"\>", 
   ",", "\<\"! Test 4: AddDescriptor gave expected result.\"\>", 
   ",", "\<\"! Test 5: AddDescriptor gave expected result.\"\>", 
   ",", "\<\"! Test 6: AddDescriptor gave expected result.\"\>", 
   ",", "\<\"! Test 7: AddDescriptions gave expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.398195860524811*^9, 3.398195932973113*^9, 3.398196406951603*^9, 
   3.398196811469915*^9, 3.398197332332746*^9, 3.3981977720018787`*^9, 
   3.3981981826695137`*^9, 3.3981984608914003`*^9, 3.398248865083076*^9, 
   3.3982905492962637`*^9, 3.398291401887456*^9, 3.398291740629155*^9, {
   3.398291943771564*^9, 3.398291952978697*^9}, 3.3983831559560947`*^9, 
   3.398383740066024*^9, 3.398383796847761*^9, 3.398383972475047*^9, {
   3.398525116048069*^9, 3.3985251658442297`*^9}, 3.399312127997321*^9, 
   3.399312431784143*^9}]
}, Open  ]]
},
CellGrouping->Manual,
WindowSize->{640, 750},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 316, 6, 27, "Input"],
Cell[887, 29, 191, 4, 27, "Input"],
Cell[1081, 35, 396, 8, 58, "Input"],
Cell[1480, 45, 391, 9, 27, "Input"],
Cell[1874, 56, 270, 7, 27, "Input"],
Cell[2147, 65, 202, 5, 27, "Input"],
Cell[2352, 72, 219, 5, 27, "Input"],
Cell[2574, 79, 654, 15, 58, "Input"],
Cell[3231, 96, 459, 11, 43, "Input"],
Cell[3693, 109, 228, 5, 27, "Input"],
Cell[3924, 116, 416, 7, 41, "Text"],
Cell[4343, 125, 170, 4, 27, "Input"],
Cell[4516, 131, 169, 4, 27, "Input"],
Cell[4688, 137, 303, 7, 27, "Input"],
Cell[CellGroupData[{
Cell[5016, 148, 185, 3, 26, "Text"],
Cell[5204, 153, 7241, 168, 643, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[12482, 326, 225, 5, 41, "Text"],
Cell[CellGroupData[{
Cell[12732, 335, 183, 4, 26, "Text"],
Cell[12918, 341, 3598, 77, 388, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[16553, 423, 257, 5, 26, "Text"],
Cell[16813, 430, 5408, 118, 613, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[22258, 553, 186, 4, 26, "Text"],
Cell[22447, 559, 5660, 124, 628, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[28144, 688, 256, 5, 26, "Text"],
Cell[28403, 695, 5790, 126, 643, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[34230, 826, 234, 5, 26, "Text"],
Cell[34467, 833, 6530, 142, 688, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41046, 981, 148, 2, 26, "Text"],
Cell[41197, 985, 5620, 125, 403, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[46854, 1115, 517, 9, 27, "Input"],
Cell[47374, 1126, 1057, 18, 118, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
