(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     30573,        767]
NotebookOptionsPosition[     28895,        713]
NotebookOutlinePosition[     29255,        729]
CellTagsIndexPosition[     29212,        726]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestOptimize"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.4007791673268833`*^9, 3.400779169248684*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "internal", " ", "functions", " ", 
     "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains unit test for those functions in ConvexCones`Private \
that optimze parts of a double description.\
\>", "Text",
 CellChangeTimes->{{3.398029343051496*^9, 3.398029387455433*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397770787542433*^9, 3.397770806006796*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SaveContextPath", " ", "=", " ", "$ContextPath"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397670949157873*^9, 3.39767096293219*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", "=", 
   RowBox[{"Prepend", "[", 
    RowBox[{"$ContextPath", ",", "\"\<Convex`ConvexCones`Private`\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397670343821027*^9, 3.397670391460298*^9}, {
  3.397770853039165*^9, 3.397770853752977*^9}}],

Cell[CellGroupData[{

Cell["\<\
OptimizeDescList is applied to the one-sided descriptors of a double \
description that has already been third-stage optimized. Test1 shows that a \
redundant descriptor can be detected if its saturation set is too small. \
Test2 shows that a redundant descriptor can be detected if its saturation set \
is a subset of that of another descriptor. Note that third-stage optimization \
avoids the case that two descriptors have the same saturation set because \
they are proportional.\
\>", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.398029441330123*^9, 3.398029491738474*^9}, {
   3.3980295495962048`*^9, 3.398029736903125*^9}, {3.3980306895924673`*^9, 
   3.398030690562522*^9}, 3.398098927096147*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"OptimizeDescList", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", "2"}], "]"}], "\[Equal]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 1: OptimizeDesc gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: OptimizeDesc gave unexpected result.\>\""}], "]"}], ",",
      "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: OptimizeDesc unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}, {3.3978409396837053`*^9, 3.397841035341238*^9}, {
   3.397841491907913*^9, 3.397841568190716*^9}, 3.3978417230348577`*^9, {
   3.397944702548745*^9, 3.397944794196334*^9}, {3.398029773100349*^9, 
   3.398029803809836*^9}, {3.398030009550714*^9, 3.398030186945051*^9}, {
   3.398030519048932*^9, 3.3980305235294037`*^9}, {3.398030706650523*^9, 
   3.398030707678691*^9}, 3.398098927096634*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"OptimizeDescList", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", "2"}], "]"}], "\[Equal]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 2: OptimizeDesc gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: OptimizeDesc gave unexpected result.\>\""}], "]"}], ",",
      "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: OptimizeDesc unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}, {3.3978409396837053`*^9, 3.397841035341238*^9}, {
   3.397841491907913*^9, 3.397841568190716*^9}, 3.3978417230348577`*^9, {
   3.397944702548745*^9, 3.397944794196334*^9}, {3.398029773100349*^9, 
   3.398029803809836*^9}, {3.398030009550714*^9, 3.398030186945051*^9}, {
   3.398030405148259*^9, 3.39803044884007*^9}, {3.398030532132041*^9, 
   3.398030534578347*^9}, {3.398030711777533*^9, 3.3980307127995462`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
FullOptimize uses OptimizeDescList to remove redundant one-sided descriptors \
from a double description that is already third-stage optimized.\
\>", "Text",
 CellChangeTimes->{{3.398099010555131*^9, 3.398099016854254*^9}, {
  3.3980990518212967`*^9, 3.398099093737174*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"halfSp", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "\[IndentingNewLine]", 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"rays", " ", "=", " ", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "/", "2"}], ",", "0", ",", "0", ",", "1"}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"1", "/", "2"}], ",", "0", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newHalfSp", " ", "=", " ", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newRays", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FullOptimize", "[", 
           RowBox[{"ConvexCone", "[", 
            RowBox[{"4", ",", 
             RowBox[{"{", "}"}], ",", "halfSp", ",", 
             RowBox[{"{", "}"}], ",", "rays"}], "]"}], "]"}], " ", "\[Equal]",
           "\[IndentingNewLine]", 
          RowBox[{"ConvexCone", "[", 
           RowBox[{"4", ",", 
            RowBox[{"{", "}"}], ",", "newHalfSp", ",", 
            RowBox[{"{", "}"}], ",", "newRays"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 3: FullOptimize gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 3: FullOptimize gave unexpected result.\>\""}], "]"}]}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: FullOptimize unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
SecondOptimize acts on each description separately. Within a description, it \
uses each two-sided descriptor to sweep out a component of both the two-sided \
and the one-sided descriptors. Zero vectors are purged.\
\>", "Text",
 CellChangeTimes->{{3.398113074345643*^9, 3.3981131660225143`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"oldHp", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"oldHs", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", 
              RowBox[{"-", "1"}], ",", "2", ",", 
              RowBox[{"-", "2"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", 
              RowBox[{"-", "2"}], ",", "2", ",", "3", ",", 
              RowBox[{"-", "2"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"oldLn", " ", "=", " ", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"3", ",", "5", ",", "2", ",", "2", ",", "2", ",", "4"}], 
             "}"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"oldRa", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "2", ",", "2", ",", "3", ",", "5"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "3", ",", "3", ",", "2", ",", "5"}], 
             "}"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"newHp", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newHs", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0", ",", 
              RowBox[{"-", "3"}], ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0", ",", "3", ",",
               
              RowBox[{"-", "2"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newLn", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "1"}], ",", 
              RowBox[{"-", "2"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newRa", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "2", ",", "3"}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "2", ",", "2", ",", "1", ",", "3"}], 
             "}"}]}], "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]",
         "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SecondOptimize", "[", 
           RowBox[{"ConvexCone", "[", 
            RowBox[{
            "6", ",", "oldHp", ",", "oldHs", ",", "oldLn", ",", "oldRa"}], 
            "]"}], "]"}], " ", "\[Equal]", "\[IndentingNewLine]", 
          RowBox[{"ConvexCone", "[", 
           RowBox[{
           "6", ",", "newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], 
           "]"}]}], ",", "\[IndentingNewLine]", 
         "\"\<! Test 4: SecondOptimize gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 4: SecondOptimize gave unexpected result.\>\""}], 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 4: SecondOptimize unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398113195798705*^9, 3.398113658287339*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["FirstOptimize", "Text",
 CellChangeTimes->{{3.39818486887173*^9, 3.398184873200885*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"oldHp", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"oldHs", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"oldLn", " ", "=", " ", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"oldRa", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newHp", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newHs", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"newLn", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "\[IndentingNewLine]", 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"newRa", "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FirstOptimize", "[", 
           RowBox[{"ConvexCone", "[", 
            RowBox[{
            "4", ",", "oldHp", ",", "oldHs", ",", "oldLn", ",", "oldRa"}], 
            "]"}], "]"}], " ", "\[Equal]", "\[IndentingNewLine]", 
          RowBox[{"ConvexCone", "[", 
           RowBox[{
           "4", ",", "newHp", ",", "newHs", ",", "newLn", ",", "newRa"}], 
           "]"}]}], ",", "\[IndentingNewLine]", 
         "\"\<! Test 5: FirstOptimize gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 5: FirstOptimize gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: FirstOptimize unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.398099167874209*^9, 
   3.398099606489175*^9}, {3.398113195798705*^9, 3.398113658287339*^9}, {
   3.398184911722156*^9, 3.3981851446556053`*^9}, 3.398186381743061*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5"}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.398030454132823*^9, 3.398030459855109*^9}, {
  3.39809960946107*^9, 3.398099611247108*^9}, {3.398113661457766*^9, 
  3.3981136645556993`*^9}, {3.398185158657798*^9, 3.398185160613686*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: OptimizeDesc gave expected result.\"\>", 
   ",", "\<\"! Test 2: OptimizeDesc gave expected result.\"\>", 
   ",", "\<\"! Test 3: FullOptimize gave expected result.\"\>", 
   ",", "\<\"! Test 4: SecondOptimize gave expected result.\"\>", 
   ",", "\<\"! Test 5: FirstOptimize gave expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.398186326581036*^9, 3.398186397746256*^9, 
  3.3982927374409857`*^9}]
}, Open  ]]
},
CellGrouping->Manual,
WindowSize->{737, 762},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 321, 6, 27, "Input"],
Cell[892, 29, 191, 4, 27, "Input"],
Cell[1086, 35, 396, 8, 58, "Input"],
Cell[1485, 45, 391, 9, 27, "Input"],
Cell[1879, 56, 270, 7, 27, "Input"],
Cell[2152, 65, 202, 5, 27, "Input"],
Cell[2357, 72, 219, 5, 27, "Input"],
Cell[2579, 79, 654, 15, 58, "Input"],
Cell[3236, 96, 459, 11, 43, "Input"],
Cell[3698, 109, 228, 5, 27, "Input"],
Cell[3929, 116, 211, 4, 26, "Text"],
Cell[4143, 122, 170, 4, 27, "Input"],
Cell[4316, 128, 169, 4, 27, "Input"],
Cell[4488, 134, 303, 7, 27, "Input"],
Cell[CellGroupData[{
Cell[4816, 145, 751, 12, 71, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[5570, 159, 2899, 67, 268, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[8472, 228, 3075, 71, 283, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Closed]],
Cell[CellGroupData[{
Cell[11584, 304, 284, 5, 38, "Text"],
Cell[11871, 311, 4913, 114, 553, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[16821, 430, 306, 5, 41, "Text"],
Cell[17130, 437, 5929, 133, 658, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[23096, 575, 94, 1, 26, "Text"],
Cell[23193, 578, 4839, 110, 583, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[28069, 693, 336, 6, 27, "Input"],
Cell[28408, 701, 471, 9, 88, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
