(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     36739,        966]
NotebookOptionsPosition[     33891,        881]
NotebookOutlinePosition[     34253,        897]
CellTagsIndexPosition[     34210,        894]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestSmallFunctions"}]}], " ", "*)"}]], "Input",\

 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779194663187*^9, 3.4007792107464247`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", " ", "internal", " ", "functions", " ", 
     "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains tests of several brief functions in \
ConvexCones`Private.\
\>", "Text",
 CellChangeTimes->{{3.397770697891056*^9, 3.397770740897654*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397770787542433*^9, 3.397770806006796*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SaveContextPath", " ", "=", " ", "$ContextPath"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397670949157873*^9, 3.39767096293219*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", "=", 
   RowBox[{"Prepend", "[", 
    RowBox[{"$ContextPath", ",", "\"\<Convex`ConvexCones`Private`\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.397670343821027*^9, 3.397670391460298*^9}, {
  3.397770853039165*^9, 3.397770853752977*^9}}],

Cell[CellGroupData[{

Cell["Test 1: ShiftDescriptors.", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.3977708818753366`*^9, 3.397770894814074*^9}, 
   3.3978208089278107`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"normal", "=", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], ",", 
         RowBox[{"addend", "=", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", 
            RowBox[{"-", "1"}]}], "}"}]}], ",", 
         RowBox[{"given", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"8", ",", "1", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"3", ",", "5", ",", "7"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"4", ",", "9", ",", "2"}], "}"}]}], "}"}]}], ",", " ", 
         RowBox[{"expected", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "48"}], ",", 
              RowBox[{"-", "27"}], ",", "34"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "65"}], ",", 
              RowBox[{"-", "29"}], ",", "41"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "52"}], ",", 
              RowBox[{"-", "19"}], ",", "30"}], "}"}]}], "}"}]}]}], "}"}], 
       ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"expected", "\[Equal]", 
          RowBox[{"ShiftDescriptors", "[", 
           RowBox[{"normal", ",", "addend", ",", "given"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 1: ShiftDescriptors gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 1: ShiftDescriptors gave unexpected result.\>\""}], 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 1: ShiftDescriptors unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["ProportionalQ", "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellChangeTimes->{{3.39782082085672*^9, 3.3978208278264313`*^9}, 
   3.3978408718035593`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "=", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], ",", 
         RowBox[{"v2", "=", 
          RowBox[{"{", 
           RowBox[{"2", ",", "4", ",", "6"}], "}"}]}]}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ProportionalQ", "[", 
           RowBox[{"v1", ",", "v2"}], "]"}], "===", "True"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 2: ProportionalQ gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 2: ProportionalQ gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: ProportionalQ unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "=", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], ",", 
         RowBox[{"v2", "=", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "6"}], "}"}]}]}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ProportionalQ", "[", 
           RowBox[{"v1", ",", "v2"}], "]"}], "===", "False"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 3: ProportionalQ gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 3: ProportionalQ gave unexpected result.\>\""}], "]"}]}],
       "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: ProportionalQ unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["IsNotZeroQ", "Text",
 CellChangeTimes->{{3.3978408812398453`*^9, 3.397840886655818*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"IsNotZeroQ", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], "]"}], "===", 
        "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 4: IsNotZeroQ gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: IsNotZeroQ gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: IsNotZeroQ unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}, {3.3978409396837053`*^9, 3.397841035341238*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"IsNotZeroQ", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], "]"}], "===", "False"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 5: IsNotZeroQ gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 5: IsNotZeroQ gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: IsNotZeroQ unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9, {3.397841041460739*^9, 
   3.397841133823805*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["SelectIndex", "Text",
 CellChangeTimes->{{3.397841466277421*^9, 3.39784146987455*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SelectIndex", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "1", ",", "4", ",", "1", ",", "6"}], "}"}], ",", 
          "EvenQ"}], "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"3", ",", "5"}], "}"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 6: EvenQ gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 6: EvenQ gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 6: EvenQ unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}, {3.3978409396837053`*^9, 3.397841035341238*^9}, {
   3.397841491907913*^9, 3.397841568190716*^9}, 3.3978417230348577`*^9}],

Cell[CellGroupData[{

Cell["EBR2", "Text",
 CellChangeTimes->{{3.3978420566180763`*^9, 3.39784205852623*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test7", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"m1", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "4", ",", "9", ",", "16"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "8", ",", "27", ",", "64"}], "}"}], "}"}]}], 
           "}"}]}], ",", 
         RowBox[{"m2", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "4", ",", "9", ",", "16"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "8", ",", "27", ",", "64"}], "}"}], "}"}]}], 
           "}"}]}]}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"EBR2", "[", 
           RowBox[{"m1", ",", "1", ",", 
            RowBox[{"{", "}"}]}], "]"}], "\[Equal]", "m2"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 7: EBR2 gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 7: EBR2 gave unexpected result.\>\""}], "]"}]}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 7: EBR2 unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9, {3.397842097120739*^9, 
   3.397842141438961*^9}, {3.3978421749903717`*^9, 3.397842222698056*^9}, {
   3.397842308364813*^9, 3.397842448330175*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test8", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"m1", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "4", ",", "9", ",", "16"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "8", ",", "27", ",", "64"}], "}"}], "}"}]}], 
           "}"}]}], ",", 
         RowBox[{"m2", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "3", ",", "8", ",", "15"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"0", ",", "7", ",", "26", ",", "63"}], "}"}], "}"}]}], 
           "}"}]}]}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"EBR2", "[", 
           RowBox[{"m1", ",", "1", ",", 
            RowBox[{"{", "1", "}"}]}], "]"}], "\[Equal]", "m2"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 8: EBR2 gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 8: EBR2 gave unexpected result.\>\""}], "]"}]}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 8: EBR2 unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9, {3.397842097120739*^9, 
   3.397842141438961*^9}, {3.3978421749903717`*^9, 3.397842222698056*^9}, {
   3.397842308364813*^9, 3.397842448330175*^9}, 3.39784260402223*^9, {
   3.39784265904958*^9, 3.3978426985220118`*^9}, {3.397842768191206*^9, 
   3.397842784485424*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test9", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"m1", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "4", ",", "9", ",", "16"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "8", ",", "27", ",", "64"}], "}"}], "}"}]}], 
           "}"}]}], ",", 
         RowBox[{"m2", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"1", "/", "2"}], ",", "0", ",", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}], ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "0", ",", "3", ",", "8"}], "}"}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "3"}], ",", "0", ",", "15", ",", "48"}], "}"}], 
             "}"}]}], "}"}]}]}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"EBR2", "[", 
           RowBox[{"m1", ",", "2", ",", 
            RowBox[{"{", "2", "}"}]}], "]"}], "\[Equal]", "m2"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 9: EBR2 gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 9: EBR2 gave unexpected result.\>\""}], "]"}]}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 9: EBR2 unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9, {3.397842097120739*^9, 
   3.397842141438961*^9}, {3.3978421749903717`*^9, 3.397842222698056*^9}, {
   3.397842308364813*^9, 3.397842448330175*^9}, {3.397842802340722*^9, 
   3.397842887521471*^9}, {3.397843174784787*^9, 3.397843178257719*^9}, 
   3.3978432890285187`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test10", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"m1", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "4", ",", "9", ",", "16"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "8", ",", "27", ",", "64"}], "}"}], "}"}]}], 
           "}"}]}], ",", 
         RowBox[{"m2", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "3"}], ",", 
                RowBox[{"-", "8"}], ",", 
                RowBox[{"-", "15"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"-", "2"}], ",", 
                RowBox[{"-", "6"}], ",", 
                RowBox[{"-", "12"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "4", ",", "9", ",", "16"}], "}"}]}], "}"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"0", ",", "4", ",", "18", ",", "48"}], "}"}], "}"}]}], 
           "}"}]}]}], "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"EBR2", "[", 
           RowBox[{"m1", ",", "3", ",", 
            RowBox[{"{", "1", "}"}]}], "]"}], "\[Equal]", "m2"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 10: EBR2 gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 10: EBR2 gave unexpected result.\>\""}], "]"}]}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 10: EBR2 unexpectedly Threw.\>\""}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9, {3.397842097120739*^9, 
   3.397842141438961*^9}, {3.3978421749903717`*^9, 3.397842222698056*^9}, {
   3.397842308364813*^9, 3.397842448330175*^9}, {3.397842961993249*^9, 
   3.397843046181933*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EliminateByRow", "Text",
 CellChangeTimes->{{3.397928209938699*^9, 3.3979282158386106`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test11", " ", ":=", " ", 
   RowBox[{"Catch", "[", " ", 
    RowBox[{
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"m1", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"2", ",", "1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1", ",", "2"}], "}"}]}], "}"}]}], "}"}]}], 
         ",", 
         RowBox[{"m2", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"2", ",", "0", ",", 
                RowBox[{"-", "2"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], "}"}]}]}],
         "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"EliminateByRow", "[", 
           RowBox[{"m1", ",", "1"}], "]"}], "\[Equal]", "m2"}], ",", 
         "\[IndentingNewLine]", 
         "\"\<! Test 11: EliminateByRow gave expected result.\>\"", ",", 
         "\[IndentingNewLine]", 
         "\"\<? Test 11: EliminateByRow gave unexpected result.\>\""}], 
        "]"}]}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? 11: EliminateByRow unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.3978210937710743`*^9}, 3.397840897866826*^9, {3.397842097120739*^9, 
   3.397842141438961*^9}, {3.3978421749903717`*^9, 3.397842222698056*^9}, {
   3.397842308364813*^9, 3.397842448330175*^9}, {3.397842961993249*^9, 
   3.397843046181933*^9}, {3.397928235798327*^9, 3.397928394847239*^9}, 
   3.3979292885310698`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"General", "::", "spell1"}], "]"}], ";", "Test12", ";", "Test13", 
  ";", 
  RowBox[{"On", "[", 
   RowBox[{"General", "::", "spell1"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.39802817050008*^9, 3.398028213888021*^9}}],

Cell[CellGroupData[{

Cell["SaturationSet", "Text",
 CellChangeTimes->{{3.397944680824294*^9, 3.39794468626156*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test12", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SaturationSet", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "2"}], ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "3", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
         "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}]}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 12: SaturationSet gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 12: SaturationSet gave unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 12: SaturationSet unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}, {3.3978409396837053`*^9, 3.397841035341238*^9}, {
   3.397841491907913*^9, 3.397841568190716*^9}, 3.3978417230348577`*^9, {
   3.397944702548745*^9, 3.397944794196334*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["WeedOut", "Text",
 CellChangeTimes->{{3.3980279499367847`*^9, 3.3980279525642853`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test13", " ", ":=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"WeedOut", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], "}"}], "]"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 13: WeedOut gave expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 13: WeedOut gave unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 13: WeedOut unexpectedly Threw.\>\""}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.},
 CellChangeTimes->{{3.397681146396357*^9, 3.3976813196175957`*^9}, {
   3.39777094871986*^9, 3.397771170713135*^9}, {3.397771208979857*^9, 
   3.397771357292376*^9}, 3.3978208089281883`*^9, {3.397820843898573*^9, 
   3.397821039385112*^9}, 3.397821097275221*^9, {3.397840871804533*^9, 
   3.3978408978665237`*^9}, {3.3978409396837053`*^9, 3.397841035341238*^9}, {
   3.397841491907913*^9, 3.397841568190716*^9}, 3.3978417230348577`*^9, {
   3.397944702548745*^9, 3.397944794196334*^9}, {3.398027970184113*^9, 
   3.3980280815571203`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
   "Test6", ",", "Test7", ",", "Test8", ",", "Test9", ",", "Test10", ",", 
   "Test11", ",", "Test12", ",", "Test13"}], "}"}]], "Input",
 CellChangeTimes->{{3.397771386177486*^9, 3.397771390183823*^9}, {
  3.397821117626164*^9, 3.397821122428095*^9}, {3.3978411390849323`*^9, 
  3.397841145019703*^9}, {3.397841587825451*^9, 3.397841589561632*^9}, {
  3.3978424645919933`*^9, 3.39784246687783*^9}, {3.397843054962925*^9, 
  3.397843062261651*^9}, {3.3979284186718407`*^9, 3.397928420954237*^9}, {
  3.397945114618429*^9, 3.3979451223516827`*^9}, {3.3980280940700827`*^9, 
  3.398028096669692*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: ShiftDescriptors gave expected result.\"\>", 
   ",", "\<\"! Test 2: ProportionalQ gave expected result.\"\>", 
   ",", "\<\"! Test 3: ProportionalQ gave expected result.\"\>", 
   ",", "\<\"! Test 4: IsNotZeroQ gave expected result.\"\>", 
   ",", "\<\"! Test 5: IsNotZeroQ gave expected result.\"\>", 
   ",", "\<\"! Test 6: EvenQ gave expected result.\"\>", 
   ",", "\<\"! Test 7: EBR2 gave expected result.\"\>", 
   ",", "\<\"! Test 8: EBR2 gave expected result.\"\>", 
   ",", "\<\"! Test 9: EBR2 gave expected result.\"\>", 
   ",", "\<\"! Test 10: EBR2 gave expected result.\"\>", 
   ",", "\<\"! Test 11: EliminateByRow gave expected result.\"\>", 
   ",", "\<\"! Test 12: SaturationSet gave expected result.\"\>", 
   ",", "\<\"! Test 13: WeedOut gave expected result.\"\>"}], "}"}]], "Output",\

 CellChangeTimes->{
  3.397771405835166*^9, 3.397771739155888*^9, 3.397772100596081*^9, 
   3.397772652773827*^9, 3.3978211242283792`*^9, 3.3978411691259327`*^9, {
   3.3978415822932*^9, 3.397841590096108*^9}, 3.3978416488279953`*^9, 
   3.3978417296999407`*^9, 3.397842469628833*^9, 3.397843065703751*^9, 
   3.397843180563447*^9, 3.39784331258278*^9, {3.3979284293164263`*^9, 
   3.397928436248496*^9}, 3.3979285031554613`*^9, 3.3979287514779663`*^9, 
   3.3979291446187963`*^9, 3.397929301561432*^9, 3.397944800266893*^9, 
   3.397945122959734*^9, 3.398028111030286*^9, 3.398028401304287*^9, 
   3.398292700436562*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ContextPath", " ", "=", " ", "SaveContextPath"}], ";"}]], "Input",\

 CellChangeTimes->{{3.397670969824622*^9, 3.39767098391678*^9}}]
},
CellGrouping->Manual,
WindowSize->{640, 750},
WindowMargins->{{28, Automatic}, {50, Automatic}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 329, 7, 27, "Input"],
Cell[900, 30, 191, 4, 27, "Input"],
Cell[1094, 36, 396, 8, 58, "Input"],
Cell[1493, 46, 391, 9, 27, "Input"],
Cell[1887, 57, 270, 7, 27, "Input"],
Cell[2160, 66, 202, 5, 27, "Input"],
Cell[2365, 73, 219, 5, 27, "Input"],
Cell[2587, 80, 654, 15, 58, "Input"],
Cell[3244, 97, 459, 11, 43, "Input"],
Cell[3706, 110, 228, 5, 27, "Input"],
Cell[3937, 117, 171, 4, 26, "Text"],
Cell[4111, 123, 170, 4, 27, "Input"],
Cell[4284, 129, 169, 4, 27, "Input"],
Cell[4456, 135, 303, 7, 27, "Input"],
Cell[CellGroupData[{
Cell[4784, 146, 190, 3, 26, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[4977, 151, 2234, 57, 163, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[7248, 213, 177, 3, 26, "Text",
 CellGroupingRules->{GroupTogetherGrouping, 10001.}],
Cell[7428, 218, 1370, 32, 133, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[8801, 252, 1321, 31, 133, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[10159, 288, 94, 1, 26, "Text"],
Cell[10256, 291, 1104, 23, 103, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[11363, 316, 1036, 23, 103, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[12436, 344, 92, 1, 26, "Text"],
Cell[12531, 347, 1273, 27, 103, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[CellGroupData[{
Cell[13829, 378, 87, 1, 26, "Text"],
Cell[13919, 381, 2451, 60, 163, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[16373, 443, 2578, 62, 163, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[18954, 507, 2784, 68, 163, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}],
Cell[21741, 577, 2704, 67, 163, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24494, 650, 98, 1, 26, "Text"],
Cell[24595, 653, 2766, 68, 163, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[27376, 724, 283, 7, 27, "Input"],
Cell[CellGroupData[{
Cell[27684, 735, 94, 1, 26, "Text"],
Cell[27781, 738, 1690, 38, 133, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[29508, 781, 93, 1, 26, "Text"],
Cell[29604, 784, 1866, 44, 133, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10002.}]
}, Open  ]],
Cell[CellGroupData[{
Cell[31507, 833, 710, 12, 43, "Input"],
Cell[32220, 847, 1483, 25, 208, "Output"]
}, Open  ]],
Cell[33718, 875, 169, 4, 27, "Input"]
}
]
*)

(* End of internal cache information *)
