(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     16095,        453]
NotebookOptionsPosition[     14781,        411]
NotebookOutlinePosition[     15119,        426]
CellTagsIndexPosition[     15076,        423]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestTests"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.4007798759255238`*^9, 
   3.4007798770632267`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", "  ", "functions", " ", "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}]}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains tests of CodeContains, SubCone, and EqualCone.\
\>", "Text",
 CellChangeTimes->{{3.398688521499158*^9, 3.3986885714182577`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.398604574326457*^9, 3.3986046111226187`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.398604628714024*^9, 3.398604630035698*^9}}],

Cell["Tests of CodeContains", "Text",
 CellChangeTimes->{{3.398688637860414*^9, 3.398688656573517*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"triangle", "=", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3986887829178247`*^9, 3.398688868257317*^9}, 
   3.3986891402654943`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ConeContains", "[", 
         RowBox[{"triangle", ",", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "/", "3"}], ",", 
            RowBox[{"1", "/", "3"}], ",", "1", ",", "1"}], "}"}]}], "]"}], 
        "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: ConeContains gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 1: ConeContains gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 1: ConeContains unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398688885945285*^9, 
   3.3986889819452972`*^9}, 3.398689032474761*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ConeContains", "[", 
         RowBox[{"triangle", ",", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "/", "2"}], ",", 
            RowBox[{"1", "/", "2"}], ",", "1", ",", "1"}], "}"}]}], "]"}], 
        "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 2: ConeContains gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: ConeContains gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: ConeContains unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398688885945285*^9, 
   3.3986890449313517`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ConeContains", "[", 
         RowBox[{"triangle", ",", " ", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "]"}], 
        "\[Equal]", "False"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 3: ConeContains gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 3: ConeContains gives unexpected result.\>\""}], "]"}], 
     ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 3: ConeContains unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398688885945285*^9, 
   3.3986889819452972`*^9}, {3.3986890615125*^9, 3.398689083331595*^9}}],

Cell["Tests of SubCone", "Text",
 CellChangeTimes->{{3.3986895121936913`*^9, 3.398689524361512*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"bigStrip", " ", "=", " ", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "3", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"littleStrip", " ", "=", " ", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.398689295671401*^9, 3.3986894790325336`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test4", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SubCone", "[", 
         RowBox[{"littleStrip", ",", "bigStrip"}], "]"}], "\[Equal]", 
        "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 4: SubCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 4: SubCone gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 4: SubCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398688885945285*^9, 
   3.3986889819452972`*^9}, {3.3986890615125*^9, 3.398689083331595*^9}, {
   3.398689541532054*^9, 3.3986896041172943`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test5", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SubCone", "[", 
         RowBox[{"littleStrip", ",", "triangle"}], "]"}], "\[Equal]", 
        "False"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 5: SubCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 5: SubCone gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 5: SubCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398688885945285*^9, 
   3.3986889819452972`*^9}, {3.3986890615125*^9, 3.398689083331595*^9}, {
   3.398689541532054*^9, 3.3986896041172943`*^9}, {3.398689646638132*^9, 
   3.398689670270319*^9}}],

Cell["Tests of EqualCone", "Text",
 CellChangeTimes->{{3.398689808531971*^9, 3.398689829355461*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"band1", "=", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"band2", "=", 
   RowBox[{"ConeIntersection", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "2", ",", 
         RowBox[{"-", "3"}]}], "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.398689850526434*^9, 3.398689887615654*^9}, {
  3.398689934536662*^9, 3.398689970545218*^9}, {3.3986900230025253`*^9, 
  3.398690038810172*^9}, {3.398690073711175*^9, 3.398690100993856*^9}, {
  3.39869105957795*^9, 3.3986912050770397`*^9}, {3.398691244422271*^9, 
  3.398691328218349*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test6", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualCone", "[", 
         RowBox[{"band1", ",", "band2"}], "]"}], "\[Equal]", "True"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 6: EqualCone gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 6: EqualCone unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 6: EqualCone unexpectedly Throws.\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398690139229589*^9, 
   3.398690184742072*^9}, {3.398690218133647*^9, 3.3986902320387373`*^9}, {
   3.398691335813003*^9, 3.398691339666471*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Test1", ",", "Test2", ",", "Test3", ",", "Test4", ",", "Test5", ",", 
   "Test6"}], "}"}]], "Input",
 CellChangeTimes->{{3.398689091628899*^9, 3.3986890977102337`*^9}, {
  3.39868967594667*^9, 3.398689681209491*^9}, {3.398690197507432*^9, 
  3.39869019905788*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: ConeContains gives expected result.\"\>", 
   ",", "\<\"! Test 2: ConeContains gives expected result.\"\>", 
   ",", "\<\"! Test 3: ConeContains gives expected result.\"\>", 
   ",", "\<\"! Test 4: SubCone gives expected result.\"\>", 
   ",", "\<\"! Test 5: SubCone gives expected result.\"\>", 
   ",", "\<\"! Test 6: EqualCone gives expected result.\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.3986891173873587`*^9, 3.3986891496763887`*^9, 3.398689698114863*^9, {
   3.398690210170149*^9, 3.398690236145314*^9}, 3.3986913470679083`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9}]
},
WindowSize->{640, 750},
WindowMargins->{{4, Automatic}, {Automatic, 5}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 372, 7, 27, "Input"],
Cell[943, 30, 191, 4, 27, "Input"],
Cell[1137, 36, 396, 8, 58, "Input"],
Cell[1536, 46, 395, 9, 27, "Input"],
Cell[1934, 57, 270, 7, 27, "Input"],
Cell[2207, 66, 202, 5, 27, "Input"],
Cell[2412, 73, 219, 5, 27, "Input"],
Cell[2634, 80, 654, 15, 58, "Input"],
Cell[3291, 97, 459, 11, 43, "Input"],
Cell[3753, 110, 228, 5, 27, "Input"],
Cell[3984, 117, 161, 3, 26, "Text"],
Cell[4148, 122, 172, 4, 27, "Input"],
Cell[4323, 128, 133, 3, 27, "Input"],
Cell[4459, 133, 103, 1, 26, "Text"],
Cell[4565, 136, 554, 16, 27, "Input"],
Cell[5122, 154, 977, 23, 88, "Input"],
Cell[6102, 179, 955, 23, 88, "Input"],
Cell[7060, 204, 934, 21, 88, "Input"],
Cell[7997, 227, 100, 1, 26, "Text"],
Cell[8100, 230, 996, 29, 43, "Input"],
Cell[9099, 261, 887, 20, 88, "Input"],
Cell[9989, 283, 938, 21, 88, "Input"],
Cell[10930, 306, 100, 1, 26, "Text"],
Cell[11033, 309, 1309, 36, 43, "Input"],
Cell[12345, 347, 879, 20, 88, "Input"],
Cell[CellGroupData[{
Cell[13249, 371, 307, 7, 27, "Input"],
Cell[13559, 380, 602, 11, 103, "Output"]
}, Open  ]],
Cell[14176, 394, 601, 15, 88, "Input"]
}
]
*)

(* End of internal cache information *)
