(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     14868,        428]
NotebookOptionsPosition[     13624,        388]
NotebookOutlinePosition[     13962,        403]
CellTagsIndexPosition[     13919,        400]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Title", ":", " ", "TestTransforms"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007783648905773`*^9, 3.400778389848178*^9}, 
   3.4007789943584127`*^9, {3.4007790614919357`*^9, 3.4007790658931713`*^9}, {
   3.400779805419591*^9, 3.4007798133175898`*^9}, {3.400779911878434*^9, 
   3.40077991368856*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "\"\<Convex`\>\""}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.40077839826663*^9, 3.4007784298325*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Herich"}], "\n", "            ", "19", " ", 
     "Tillinghast", " ", "Place", "\[IndentingNewLine]", "\t\t ", "Buffalo", 
     " ", "NY", " ", "14216"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.4007784331205177`*^9, 3.4007785133909187`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Summary", ":", " ", 
    RowBox[{
    "Tests", " ", "for", " ", "some", "  ", "functions", " ", "of", " ", 
     RowBox[{"ConvexCones", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.4007785193712473`*^9, 3.400778611163659*^9}, 
   3.400778997156551*^9, {3.400779081765668*^9, 3.400779095678822*^9}, 
   3.400779821094699*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Copyright", ":", " ", 
    RowBox[{"Christopher", " ", 
     RowBox[{"J", ".", " ", "Henrich"}], " ", "2007"}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.400778617958004*^9, 3.400778656152369*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778641057249*^9, 3.400778661432424*^9}, {
  3.4532170411194973`*^9, 3.453217042543014*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", 
    RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778670351119*^9, 3.4007786862811832`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"Developed", " ", "from", " ", "Guenter", " ", 
      RowBox[{"M", ".", " ", "Ziegler"}]}]}]}], ",", " ", 
   RowBox[{"Lectures", " ", "on", " ", "Polytopes"}], ",", " ", 
   "\[IndentingNewLine]", "             ", 
   RowBox[{
    RowBox[{"Springer", "-", 
     RowBox[{"Verlag", " ", "1995"}]}], ";", " ", "\[IndentingNewLine]", 
    "             ", 
    RowBox[{"and", " ", "the", " ", "Parma", " ", "Polyhedral", " ", 
     RowBox[{"Library", "."}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778690532626*^9, 3.400778774108075*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", 
     RowBox[{"convex", " ", "polyhedra"}]}]}], ",", " ", 
   RowBox[{"convex", " ", "cones"}], ",", " ", 
   RowBox[{"linear", " ", "algebra"}], ",", "  ", "\[IndentingNewLine]", 
   "              ", 
   RowBox[{"multi", "-", 
    RowBox[{"dimensional", " ", "geometry"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.400778785524385*^9, 3.400778881816313*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Requirements", ":", " ", 
    RowBox[{"Convex`ConvexCones", ".", "nb"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.400778889883216*^9, 3.400778912648223*^9}}],

Cell["\<\
This notebook contains tests of TransformGeneratorsOfCone, \
ProjectConeAlongAxis, and IntersectConeWithHyperplane.\
\>", "Text",
 CellChangeTimes->{{3.398727301825521*^9, 3.398727351436215*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Convex`ConvexCones`\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.398604574326457*^9, 3.3986046111226187`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.398604628714024*^9, 3.398604630035698*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fourpoints", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.3987278724272013`*^9, 3.398727919768029*^9}, {
  3.398729868519555*^9, 3.3987298714865427`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"square1", "=", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "fourpoints"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398727830021097*^9, 3.398727854487453*^9}, {
  3.398727926361986*^9, 3.3987279359783154`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"morepoints", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398727947533443*^9, 3.3987279502335978`*^9}, {
  3.398728046373063*^9, 3.398728090727791*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"square2", "=", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "morepoints"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398728094691642*^9, 3.398728128952734*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"xform", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398728135084427*^9, 3.398728178284783*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test1", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EqualCone", "[", 
         RowBox[{
          RowBox[{"TransformGeneratorsOfCone", "[", 
           RowBox[{"square1", ",", "xform"}], "]"}], ",", "square2"}], "]"}], 
        "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
       "\"\<! Test 1: TransformGeneratorsOfCone gives expected result.\>\"", 
       ",", "\[IndentingNewLine]", 
       "\"\<? Test 1: TransformGeneratorsOfCone gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 1: TransformGeneratorsOfCone unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.39872833640493*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tetrahedron", " ", "=", " ", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", "1"}], "/", "2"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", 
         RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", 
         RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", 
         RowBox[{
          RowBox[{"-", "1"}], "/", "2"}], ",", "1"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"square", "=", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.3987844878724823`*^9, 3.398784647987218*^9}, {
  3.398786161699852*^9, 3.3987861825499163`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test2", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"EqualCone", "[", 
        RowBox[{"square", ",", 
         RowBox[{"ProjectConeAlongAxis", "[", 
          RowBox[{"tetrahedron", ",", "3"}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 2: ProjectConeAlongAxis gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test 2: ProjectConeAlongAxis gives unexpected result.\>\""}], 
      "]"}], ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test 2: ProjectConeAlongAxis unexpectedly Throws.\>\""}], "]"}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.3987846628157043`*^9, 3.39878474923915*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"diamond", " ", "=", " ", 
   RowBox[{"ConicalHull", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ",", "1", ",", "1"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.398785483101795*^9, 3.398785537152505*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Test3", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"EqualCone", "[", 
        RowBox[{"diamond", ",", 
         RowBox[{"IntersectConeWithHyperplane", "[", 
          RowBox[{"tetrahedron", ",", "3"}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       "\"\<! Test 3: IntersectConeWithHyperplane gives expected result.\>\"",
        ",", "\[IndentingNewLine]", 
       "\"\<? Test 3: IntersectConeWithHyperplane gives unexpected \
result.\>\""}], "]"}], ",", "\[IndentingNewLine]", "_", ",", 
     "\[IndentingNewLine]", 
     "\"\<? Test 3: IntersectConeWithHyperplane unexpectedly Throws.\>\""}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}, {3.398785558421444*^9, 3.398785654539072*^9}, {
   3.398785792312978*^9, 3.39878579617029*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Test1", ",", "Test2", ",", "Test3"}], "}"}]], "Input",
 CellChangeTimes->{{3.398728344060884*^9, 3.398728346662422*^9}, {
  3.3987847584012136`*^9, 3.3987847606489077`*^9}, {3.398785800817759*^9, 
  3.3987858032111397`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"! Test 1: TransformGeneratorsOfCone gives expected \
result.\"\>", 
   ",", "\<\"! Test 2: ProjectConeAlongAxis gives expected result.\"\>", 
   ",", "\<\"! Test 3: IntersectConeWithHyperplane gives expected \
result.\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.398728360101245*^9, 3.398729923874126*^9, 3.398729994772972*^9, {
   3.3987311876673183`*^9, 3.398731212560714*^9}, 3.398731314666341*^9, 
   3.398784776312613*^9, 3.398785241812456*^9, 3.3987858094313507`*^9, 
   3.398786193933344*^9, 3.3996407515877028`*^9, 3.4532170603407297`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Testx", " ", "=", " ", 
   RowBox[{"Catch", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
      "ufb", ",", "\[IndentingNewLine]", 
       "\"\<! Test *: ufb gives expected result.\>\"", ",", 
       "\[IndentingNewLine]", 
       "\"\<? Test *: ufb gives unexpected result.\>\""}], "]"}], ",", 
     "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
     "\"\<? Test *: ufb unexpectedly Throws.\>\""}], "]"}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.39855182466687*^9, 3.398551964157494*^9}, 
   3.398552456266678*^9, 3.3985524979234657`*^9, {3.398728188062615*^9, 
   3.398728201816588*^9}}]
},
WindowSize->{640, 750},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"6.0 for Mac OS X PowerPC (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 372, 7, 27, "Input"],
Cell[943, 30, 191, 4, 27, "Input"],
Cell[1137, 36, 396, 8, 58, "Input"],
Cell[1536, 46, 395, 9, 27, "Input"],
Cell[1934, 57, 270, 7, 27, "Input"],
Cell[2207, 66, 264, 6, 27, "Input"],
Cell[2474, 74, 219, 5, 27, "Input"],
Cell[2696, 81, 654, 15, 58, "Input"],
Cell[3353, 98, 459, 11, 43, "Input"],
Cell[3815, 111, 228, 5, 27, "Input"],
Cell[4046, 118, 205, 4, 41, "Text"],
Cell[4254, 124, 172, 4, 27, "Input"],
Cell[4429, 130, 133, 3, 27, "Input"],
Cell[4565, 135, 694, 18, 103, "Input"],
Cell[5262, 155, 284, 7, 27, "Input"],
Cell[5549, 164, 692, 18, 103, "Input"],
Cell[6244, 184, 233, 6, 27, "Input"],
Cell[6480, 192, 659, 18, 103, "Input"],
Cell[7142, 212, 939, 22, 118, "Input"],
Cell[8084, 236, 1353, 40, 73, "Input"],
Cell[9440, 278, 920, 20, 88, "Input"],
Cell[10363, 300, 700, 21, 43, "Input"],
Cell[11066, 323, 1000, 22, 118, "Input"],
Cell[CellGroupData[{
Cell[12091, 349, 264, 5, 27, "Input"],
Cell[12358, 356, 596, 11, 58, "Output"]
}, Open  ]],
Cell[12969, 370, 651, 16, 88, "Input"]
}
]
*)

(* End of internal cache information *)
